package org.eclipse.lsat.machine.teditor.ide.contentassist.antlr.internal;

import java.io.InputStream;
import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.AbstractInternalContentAssistParser;
import org.eclipse.xtext.ide.editor.contentassist.antlr.internal.DFA;
import org.eclipse.lsat.machine.teditor.services.MachineGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

/**
 * Copyright (c) 2021 Contributors to the Eclipse Foundation
 *
 * This program and the accompanying materials are made
 * available under the terms of the Eclipse Public License 2.0
 * which is available at https://www.eclipse.org/legal/epl-2.0/
 *
 * SPDX-License-Identifier: EPL-2.0
 *
 * Do not edit: This file is generated by Xtext
 */
@SuppressWarnings("all")
public class InternalMachineParser extends AbstractInternalContentAssistParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_INT", "RULE_ID", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'Machine'", "'PathAnnotations'", "'{'", "'}'", "'import'", "'PeripheralType'", "'Actions'", "'SetPoints'", "'Axes'", "'Conversion'", "'['", "']'", "'moves'", "','", "'Resource'", "'('", "')'", "':'", "'Profiles'", "'AxisPositions'", "'SymbolicPositions'", "'Distances'", "'Paths'", "'.'", "'-->'", "'profiles'", "'profile'", "'@'", "'<->'", "'FullMesh'"
    };
    public static final int RULE_STRING=6;
    public static final int RULE_SL_COMMENT=8;
    public static final int T__19=19;
    public static final int T__15=15;
    public static final int T__37=37;
    public static final int T__16=16;
    public static final int T__38=38;
    public static final int T__17=17;
    public static final int T__39=39;
    public static final int T__18=18;
    public static final int T__11=11;
    public static final int T__33=33;
    public static final int T__12=12;
    public static final int T__34=34;
    public static final int T__13=13;
    public static final int T__35=35;
    public static final int T__14=14;
    public static final int T__36=36;
    public static final int EOF=-1;
    public static final int T__30=30;
    public static final int T__31=31;
    public static final int T__32=32;
    public static final int RULE_ID=5;
    public static final int RULE_WS=9;
    public static final int RULE_ANY_OTHER=10;
    public static final int T__26=26;
    public static final int T__27=27;
    public static final int T__28=28;
    public static final int RULE_INT=4;
    public static final int T__29=29;
    public static final int T__22=22;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__23=23;
    public static final int T__24=24;
    public static final int T__25=25;
    public static final int T__40=40;
    public static final int T__20=20;
    public static final int T__21=21;

    // delegates
    // delegators


        public InternalMachineParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalMachineParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalMachineParser.tokenNames; }
    public String getGrammarFileName() { return "InternalMachine.g"; }


    	private MachineGrammarAccess grammarAccess;

    	public void setGrammarAccess(MachineGrammarAccess grammarAccess) {
    		this.grammarAccess = grammarAccess;
    	}

    	@Override
    	protected Grammar getGrammar() {
    		return grammarAccess.getGrammar();
    	}

    	@Override
    	protected String getValueForTokenName(String tokenName) {
    		return tokenName;
    	}



    // $ANTLR start "entryRuleMachine"
    // InternalMachine.g:61:1: entryRuleMachine : ruleMachine EOF ;
    public final void entryRuleMachine() throws RecognitionException {
        try {
            // InternalMachine.g:62:1: ( ruleMachine EOF )
            // InternalMachine.g:63:1: ruleMachine EOF
            {
             before(grammarAccess.getMachineRule()); 
            pushFollow(FOLLOW_1);
            ruleMachine();

            state._fsp--;

             after(grammarAccess.getMachineRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleMachine"


    // $ANTLR start "ruleMachine"
    // InternalMachine.g:70:1: ruleMachine : ( ( rule__Machine__Group__0 ) ) ;
    public final void ruleMachine() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:74:2: ( ( ( rule__Machine__Group__0 ) ) )
            // InternalMachine.g:75:2: ( ( rule__Machine__Group__0 ) )
            {
            // InternalMachine.g:75:2: ( ( rule__Machine__Group__0 ) )
            // InternalMachine.g:76:3: ( rule__Machine__Group__0 )
            {
             before(grammarAccess.getMachineAccess().getGroup()); 
            // InternalMachine.g:77:3: ( rule__Machine__Group__0 )
            // InternalMachine.g:77:4: rule__Machine__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Machine__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getMachineAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleMachine"


    // $ANTLR start "entryRuleImport"
    // InternalMachine.g:86:1: entryRuleImport : ruleImport EOF ;
    public final void entryRuleImport() throws RecognitionException {
        try {
            // InternalMachine.g:87:1: ( ruleImport EOF )
            // InternalMachine.g:88:1: ruleImport EOF
            {
             before(grammarAccess.getImportRule()); 
            pushFollow(FOLLOW_1);
            ruleImport();

            state._fsp--;

             after(grammarAccess.getImportRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleImport"


    // $ANTLR start "ruleImport"
    // InternalMachine.g:95:1: ruleImport : ( ( rule__Import__Group__0 ) ) ;
    public final void ruleImport() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:99:2: ( ( ( rule__Import__Group__0 ) ) )
            // InternalMachine.g:100:2: ( ( rule__Import__Group__0 ) )
            {
            // InternalMachine.g:100:2: ( ( rule__Import__Group__0 ) )
            // InternalMachine.g:101:3: ( rule__Import__Group__0 )
            {
             before(grammarAccess.getImportAccess().getGroup()); 
            // InternalMachine.g:102:3: ( rule__Import__Group__0 )
            // InternalMachine.g:102:4: rule__Import__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Import__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getImportAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleImport"


    // $ANTLR start "entryRulePathAnnotation"
    // InternalMachine.g:111:1: entryRulePathAnnotation : rulePathAnnotation EOF ;
    public final void entryRulePathAnnotation() throws RecognitionException {
        try {
            // InternalMachine.g:112:1: ( rulePathAnnotation EOF )
            // InternalMachine.g:113:1: rulePathAnnotation EOF
            {
             before(grammarAccess.getPathAnnotationRule()); 
            pushFollow(FOLLOW_1);
            rulePathAnnotation();

            state._fsp--;

             after(grammarAccess.getPathAnnotationRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRulePathAnnotation"


    // $ANTLR start "rulePathAnnotation"
    // InternalMachine.g:120:1: rulePathAnnotation : ( ( rule__PathAnnotation__Group__0 ) ) ;
    public final void rulePathAnnotation() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:124:2: ( ( ( rule__PathAnnotation__Group__0 ) ) )
            // InternalMachine.g:125:2: ( ( rule__PathAnnotation__Group__0 ) )
            {
            // InternalMachine.g:125:2: ( ( rule__PathAnnotation__Group__0 ) )
            // InternalMachine.g:126:3: ( rule__PathAnnotation__Group__0 )
            {
             before(grammarAccess.getPathAnnotationAccess().getGroup()); 
            // InternalMachine.g:127:3: ( rule__PathAnnotation__Group__0 )
            // InternalMachine.g:127:4: rule__PathAnnotation__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__PathAnnotation__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getPathAnnotationAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rulePathAnnotation"


    // $ANTLR start "entryRulePeripheralType"
    // InternalMachine.g:136:1: entryRulePeripheralType : rulePeripheralType EOF ;
    public final void entryRulePeripheralType() throws RecognitionException {
        try {
            // InternalMachine.g:137:1: ( rulePeripheralType EOF )
            // InternalMachine.g:138:1: rulePeripheralType EOF
            {
             before(grammarAccess.getPeripheralTypeRule()); 
            pushFollow(FOLLOW_1);
            rulePeripheralType();

            state._fsp--;

             after(grammarAccess.getPeripheralTypeRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRulePeripheralType"


    // $ANTLR start "rulePeripheralType"
    // InternalMachine.g:145:1: rulePeripheralType : ( ( rule__PeripheralType__Group__0 ) ) ;
    public final void rulePeripheralType() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:149:2: ( ( ( rule__PeripheralType__Group__0 ) ) )
            // InternalMachine.g:150:2: ( ( rule__PeripheralType__Group__0 ) )
            {
            // InternalMachine.g:150:2: ( ( rule__PeripheralType__Group__0 ) )
            // InternalMachine.g:151:3: ( rule__PeripheralType__Group__0 )
            {
             before(grammarAccess.getPeripheralTypeAccess().getGroup()); 
            // InternalMachine.g:152:3: ( rule__PeripheralType__Group__0 )
            // InternalMachine.g:152:4: rule__PeripheralType__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getPeripheralTypeAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rulePeripheralType"


    // $ANTLR start "entryRuleActionType"
    // InternalMachine.g:161:1: entryRuleActionType : ruleActionType EOF ;
    public final void entryRuleActionType() throws RecognitionException {
        try {
            // InternalMachine.g:162:1: ( ruleActionType EOF )
            // InternalMachine.g:163:1: ruleActionType EOF
            {
             before(grammarAccess.getActionTypeRule()); 
            pushFollow(FOLLOW_1);
            ruleActionType();

            state._fsp--;

             after(grammarAccess.getActionTypeRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleActionType"


    // $ANTLR start "ruleActionType"
    // InternalMachine.g:170:1: ruleActionType : ( ( rule__ActionType__Group__0 ) ) ;
    public final void ruleActionType() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:174:2: ( ( ( rule__ActionType__Group__0 ) ) )
            // InternalMachine.g:175:2: ( ( rule__ActionType__Group__0 ) )
            {
            // InternalMachine.g:175:2: ( ( rule__ActionType__Group__0 ) )
            // InternalMachine.g:176:3: ( rule__ActionType__Group__0 )
            {
             before(grammarAccess.getActionTypeAccess().getGroup()); 
            // InternalMachine.g:177:3: ( rule__ActionType__Group__0 )
            // InternalMachine.g:177:4: rule__ActionType__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__ActionType__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getActionTypeAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleActionType"


    // $ANTLR start "entryRuleSetPoint"
    // InternalMachine.g:186:1: entryRuleSetPoint : ruleSetPoint EOF ;
    public final void entryRuleSetPoint() throws RecognitionException {
        try {
            // InternalMachine.g:187:1: ( ruleSetPoint EOF )
            // InternalMachine.g:188:1: ruleSetPoint EOF
            {
             before(grammarAccess.getSetPointRule()); 
            pushFollow(FOLLOW_1);
            ruleSetPoint();

            state._fsp--;

             after(grammarAccess.getSetPointRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleSetPoint"


    // $ANTLR start "ruleSetPoint"
    // InternalMachine.g:195:1: ruleSetPoint : ( ( rule__SetPoint__Group__0 ) ) ;
    public final void ruleSetPoint() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:199:2: ( ( ( rule__SetPoint__Group__0 ) ) )
            // InternalMachine.g:200:2: ( ( rule__SetPoint__Group__0 ) )
            {
            // InternalMachine.g:200:2: ( ( rule__SetPoint__Group__0 ) )
            // InternalMachine.g:201:3: ( rule__SetPoint__Group__0 )
            {
             before(grammarAccess.getSetPointAccess().getGroup()); 
            // InternalMachine.g:202:3: ( rule__SetPoint__Group__0 )
            // InternalMachine.g:202:4: rule__SetPoint__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__SetPoint__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getSetPointAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleSetPoint"


    // $ANTLR start "entryRuleAxis"
    // InternalMachine.g:211:1: entryRuleAxis : ruleAxis EOF ;
    public final void entryRuleAxis() throws RecognitionException {
        try {
            // InternalMachine.g:212:1: ( ruleAxis EOF )
            // InternalMachine.g:213:1: ruleAxis EOF
            {
             before(grammarAccess.getAxisRule()); 
            pushFollow(FOLLOW_1);
            ruleAxis();

            state._fsp--;

             after(grammarAccess.getAxisRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleAxis"


    // $ANTLR start "ruleAxis"
    // InternalMachine.g:220:1: ruleAxis : ( ( rule__Axis__Group__0 ) ) ;
    public final void ruleAxis() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:224:2: ( ( ( rule__Axis__Group__0 ) ) )
            // InternalMachine.g:225:2: ( ( rule__Axis__Group__0 ) )
            {
            // InternalMachine.g:225:2: ( ( rule__Axis__Group__0 ) )
            // InternalMachine.g:226:3: ( rule__Axis__Group__0 )
            {
             before(grammarAccess.getAxisAccess().getGroup()); 
            // InternalMachine.g:227:3: ( rule__Axis__Group__0 )
            // InternalMachine.g:227:4: rule__Axis__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Axis__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getAxisAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleAxis"


    // $ANTLR start "entryRuleResourceItem"
    // InternalMachine.g:236:1: entryRuleResourceItem : ruleResourceItem EOF ;
    public final void entryRuleResourceItem() throws RecognitionException {
        try {
            // InternalMachine.g:237:1: ( ruleResourceItem EOF )
            // InternalMachine.g:238:1: ruleResourceItem EOF
            {
             before(grammarAccess.getResourceItemRule()); 
            pushFollow(FOLLOW_1);
            ruleResourceItem();

            state._fsp--;

             after(grammarAccess.getResourceItemRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleResourceItem"


    // $ANTLR start "ruleResourceItem"
    // InternalMachine.g:245:1: ruleResourceItem : ( ( rule__ResourceItem__Group__0 ) ) ;
    public final void ruleResourceItem() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:249:2: ( ( ( rule__ResourceItem__Group__0 ) ) )
            // InternalMachine.g:250:2: ( ( rule__ResourceItem__Group__0 ) )
            {
            // InternalMachine.g:250:2: ( ( rule__ResourceItem__Group__0 ) )
            // InternalMachine.g:251:3: ( rule__ResourceItem__Group__0 )
            {
             before(grammarAccess.getResourceItemAccess().getGroup()); 
            // InternalMachine.g:252:3: ( rule__ResourceItem__Group__0 )
            // InternalMachine.g:252:4: rule__ResourceItem__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__ResourceItem__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getResourceItemAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleResourceItem"


    // $ANTLR start "entryRuleResource"
    // InternalMachine.g:261:1: entryRuleResource : ruleResource EOF ;
    public final void entryRuleResource() throws RecognitionException {
        try {
            // InternalMachine.g:262:1: ( ruleResource EOF )
            // InternalMachine.g:263:1: ruleResource EOF
            {
             before(grammarAccess.getResourceRule()); 
            pushFollow(FOLLOW_1);
            ruleResource();

            state._fsp--;

             after(grammarAccess.getResourceRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleResource"


    // $ANTLR start "ruleResource"
    // InternalMachine.g:270:1: ruleResource : ( ( rule__Resource__Group__0 ) ) ;
    public final void ruleResource() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:274:2: ( ( ( rule__Resource__Group__0 ) ) )
            // InternalMachine.g:275:2: ( ( rule__Resource__Group__0 ) )
            {
            // InternalMachine.g:275:2: ( ( rule__Resource__Group__0 ) )
            // InternalMachine.g:276:3: ( rule__Resource__Group__0 )
            {
             before(grammarAccess.getResourceAccess().getGroup()); 
            // InternalMachine.g:277:3: ( rule__Resource__Group__0 )
            // InternalMachine.g:277:4: rule__Resource__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Resource__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getResourceAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleResource"


    // $ANTLR start "entryRulePeripheral"
    // InternalMachine.g:286:1: entryRulePeripheral : rulePeripheral EOF ;
    public final void entryRulePeripheral() throws RecognitionException {
        try {
            // InternalMachine.g:287:1: ( rulePeripheral EOF )
            // InternalMachine.g:288:1: rulePeripheral EOF
            {
             before(grammarAccess.getPeripheralRule()); 
            pushFollow(FOLLOW_1);
            rulePeripheral();

            state._fsp--;

             after(grammarAccess.getPeripheralRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRulePeripheral"


    // $ANTLR start "rulePeripheral"
    // InternalMachine.g:295:1: rulePeripheral : ( ( rule__Peripheral__Group__0 ) ) ;
    public final void rulePeripheral() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:299:2: ( ( ( rule__Peripheral__Group__0 ) ) )
            // InternalMachine.g:300:2: ( ( rule__Peripheral__Group__0 ) )
            {
            // InternalMachine.g:300:2: ( ( rule__Peripheral__Group__0 ) )
            // InternalMachine.g:301:3: ( rule__Peripheral__Group__0 )
            {
             before(grammarAccess.getPeripheralAccess().getGroup()); 
            // InternalMachine.g:302:3: ( rule__Peripheral__Group__0 )
            // InternalMachine.g:302:4: rule__Peripheral__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getPeripheralAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rulePeripheral"


    // $ANTLR start "entryRuleDistance"
    // InternalMachine.g:311:1: entryRuleDistance : ruleDistance EOF ;
    public final void entryRuleDistance() throws RecognitionException {
        try {
            // InternalMachine.g:312:1: ( ruleDistance EOF )
            // InternalMachine.g:313:1: ruleDistance EOF
            {
             before(grammarAccess.getDistanceRule()); 
            pushFollow(FOLLOW_1);
            ruleDistance();

            state._fsp--;

             after(grammarAccess.getDistanceRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleDistance"


    // $ANTLR start "ruleDistance"
    // InternalMachine.g:320:1: ruleDistance : ( ( rule__Distance__Group__0 ) ) ;
    public final void ruleDistance() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:324:2: ( ( ( rule__Distance__Group__0 ) ) )
            // InternalMachine.g:325:2: ( ( rule__Distance__Group__0 ) )
            {
            // InternalMachine.g:325:2: ( ( rule__Distance__Group__0 ) )
            // InternalMachine.g:326:3: ( rule__Distance__Group__0 )
            {
             before(grammarAccess.getDistanceAccess().getGroup()); 
            // InternalMachine.g:327:3: ( rule__Distance__Group__0 )
            // InternalMachine.g:327:4: rule__Distance__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Distance__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getDistanceAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleDistance"


    // $ANTLR start "entryRuleAxisPositionsMapEntry"
    // InternalMachine.g:336:1: entryRuleAxisPositionsMapEntry : ruleAxisPositionsMapEntry EOF ;
    public final void entryRuleAxisPositionsMapEntry() throws RecognitionException {
        try {
            // InternalMachine.g:337:1: ( ruleAxisPositionsMapEntry EOF )
            // InternalMachine.g:338:1: ruleAxisPositionsMapEntry EOF
            {
             before(grammarAccess.getAxisPositionsMapEntryRule()); 
            pushFollow(FOLLOW_1);
            ruleAxisPositionsMapEntry();

            state._fsp--;

             after(grammarAccess.getAxisPositionsMapEntryRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleAxisPositionsMapEntry"


    // $ANTLR start "ruleAxisPositionsMapEntry"
    // InternalMachine.g:345:1: ruleAxisPositionsMapEntry : ( ( rule__AxisPositionsMapEntry__Group__0 ) ) ;
    public final void ruleAxisPositionsMapEntry() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:349:2: ( ( ( rule__AxisPositionsMapEntry__Group__0 ) ) )
            // InternalMachine.g:350:2: ( ( rule__AxisPositionsMapEntry__Group__0 ) )
            {
            // InternalMachine.g:350:2: ( ( rule__AxisPositionsMapEntry__Group__0 ) )
            // InternalMachine.g:351:3: ( rule__AxisPositionsMapEntry__Group__0 )
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getGroup()); 
            // InternalMachine.g:352:3: ( rule__AxisPositionsMapEntry__Group__0 )
            // InternalMachine.g:352:4: rule__AxisPositionsMapEntry__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getAxisPositionsMapEntryAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleAxisPositionsMapEntry"


    // $ANTLR start "entryRulePosition"
    // InternalMachine.g:361:1: entryRulePosition : rulePosition EOF ;
    public final void entryRulePosition() throws RecognitionException {
        try {
            // InternalMachine.g:362:1: ( rulePosition EOF )
            // InternalMachine.g:363:1: rulePosition EOF
            {
             before(grammarAccess.getPositionRule()); 
            pushFollow(FOLLOW_1);
            rulePosition();

            state._fsp--;

             after(grammarAccess.getPositionRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRulePosition"


    // $ANTLR start "rulePosition"
    // InternalMachine.g:370:1: rulePosition : ( ( rule__Position__Group__0 ) ) ;
    public final void rulePosition() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:374:2: ( ( ( rule__Position__Group__0 ) ) )
            // InternalMachine.g:375:2: ( ( rule__Position__Group__0 ) )
            {
            // InternalMachine.g:375:2: ( ( rule__Position__Group__0 ) )
            // InternalMachine.g:376:3: ( rule__Position__Group__0 )
            {
             before(grammarAccess.getPositionAccess().getGroup()); 
            // InternalMachine.g:377:3: ( rule__Position__Group__0 )
            // InternalMachine.g:377:4: rule__Position__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Position__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getPositionAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rulePosition"


    // $ANTLR start "entryRuleSymbolicPosition"
    // InternalMachine.g:386:1: entryRuleSymbolicPosition : ruleSymbolicPosition EOF ;
    public final void entryRuleSymbolicPosition() throws RecognitionException {
        try {
            // InternalMachine.g:387:1: ( ruleSymbolicPosition EOF )
            // InternalMachine.g:388:1: ruleSymbolicPosition EOF
            {
             before(grammarAccess.getSymbolicPositionRule()); 
            pushFollow(FOLLOW_1);
            ruleSymbolicPosition();

            state._fsp--;

             after(grammarAccess.getSymbolicPositionRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleSymbolicPosition"


    // $ANTLR start "ruleSymbolicPosition"
    // InternalMachine.g:395:1: ruleSymbolicPosition : ( ( rule__SymbolicPosition__Group__0 ) ) ;
    public final void ruleSymbolicPosition() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:399:2: ( ( ( rule__SymbolicPosition__Group__0 ) ) )
            // InternalMachine.g:400:2: ( ( rule__SymbolicPosition__Group__0 ) )
            {
            // InternalMachine.g:400:2: ( ( rule__SymbolicPosition__Group__0 ) )
            // InternalMachine.g:401:3: ( rule__SymbolicPosition__Group__0 )
            {
             before(grammarAccess.getSymbolicPositionAccess().getGroup()); 
            // InternalMachine.g:402:3: ( rule__SymbolicPosition__Group__0 )
            // InternalMachine.g:402:4: rule__SymbolicPosition__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getSymbolicPositionAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleSymbolicPosition"


    // $ANTLR start "entryRuleAxisPositionMapEntry"
    // InternalMachine.g:411:1: entryRuleAxisPositionMapEntry : ruleAxisPositionMapEntry EOF ;
    public final void entryRuleAxisPositionMapEntry() throws RecognitionException {
        try {
            // InternalMachine.g:412:1: ( ruleAxisPositionMapEntry EOF )
            // InternalMachine.g:413:1: ruleAxisPositionMapEntry EOF
            {
             before(grammarAccess.getAxisPositionMapEntryRule()); 
            pushFollow(FOLLOW_1);
            ruleAxisPositionMapEntry();

            state._fsp--;

             after(grammarAccess.getAxisPositionMapEntryRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleAxisPositionMapEntry"


    // $ANTLR start "ruleAxisPositionMapEntry"
    // InternalMachine.g:420:1: ruleAxisPositionMapEntry : ( ( rule__AxisPositionMapEntry__Group__0 ) ) ;
    public final void ruleAxisPositionMapEntry() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:424:2: ( ( ( rule__AxisPositionMapEntry__Group__0 ) ) )
            // InternalMachine.g:425:2: ( ( rule__AxisPositionMapEntry__Group__0 ) )
            {
            // InternalMachine.g:425:2: ( ( rule__AxisPositionMapEntry__Group__0 ) )
            // InternalMachine.g:426:3: ( rule__AxisPositionMapEntry__Group__0 )
            {
             before(grammarAccess.getAxisPositionMapEntryAccess().getGroup()); 
            // InternalMachine.g:427:3: ( rule__AxisPositionMapEntry__Group__0 )
            // InternalMachine.g:427:4: rule__AxisPositionMapEntry__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionMapEntry__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getAxisPositionMapEntryAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleAxisPositionMapEntry"


    // $ANTLR start "entryRuleProfile"
    // InternalMachine.g:436:1: entryRuleProfile : ruleProfile EOF ;
    public final void entryRuleProfile() throws RecognitionException {
        try {
            // InternalMachine.g:437:1: ( ruleProfile EOF )
            // InternalMachine.g:438:1: ruleProfile EOF
            {
             before(grammarAccess.getProfileRule()); 
            pushFollow(FOLLOW_1);
            ruleProfile();

            state._fsp--;

             after(grammarAccess.getProfileRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleProfile"


    // $ANTLR start "ruleProfile"
    // InternalMachine.g:445:1: ruleProfile : ( ( rule__Profile__Group__0 ) ) ;
    public final void ruleProfile() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:449:2: ( ( ( rule__Profile__Group__0 ) ) )
            // InternalMachine.g:450:2: ( ( rule__Profile__Group__0 ) )
            {
            // InternalMachine.g:450:2: ( ( rule__Profile__Group__0 ) )
            // InternalMachine.g:451:3: ( rule__Profile__Group__0 )
            {
             before(grammarAccess.getProfileAccess().getGroup()); 
            // InternalMachine.g:452:3: ( rule__Profile__Group__0 )
            // InternalMachine.g:452:4: rule__Profile__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__Profile__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getProfileAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleProfile"


    // $ANTLR start "entryRulePath"
    // InternalMachine.g:461:1: entryRulePath : rulePath EOF ;
    public final void entryRulePath() throws RecognitionException {
        try {
            // InternalMachine.g:462:1: ( rulePath EOF )
            // InternalMachine.g:463:1: rulePath EOF
            {
             before(grammarAccess.getPathRule()); 
            pushFollow(FOLLOW_1);
            rulePath();

            state._fsp--;

             after(grammarAccess.getPathRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRulePath"


    // $ANTLR start "rulePath"
    // InternalMachine.g:470:1: rulePath : ( ( rule__Path__Alternatives ) ) ;
    public final void rulePath() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:474:2: ( ( ( rule__Path__Alternatives ) ) )
            // InternalMachine.g:475:2: ( ( rule__Path__Alternatives ) )
            {
            // InternalMachine.g:475:2: ( ( rule__Path__Alternatives ) )
            // InternalMachine.g:476:3: ( rule__Path__Alternatives )
            {
             before(grammarAccess.getPathAccess().getAlternatives()); 
            // InternalMachine.g:477:3: ( rule__Path__Alternatives )
            // InternalMachine.g:477:4: rule__Path__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__Path__Alternatives();

            state._fsp--;


            }

             after(grammarAccess.getPathAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rulePath"


    // $ANTLR start "entryRuleUnidirectionalPath"
    // InternalMachine.g:486:1: entryRuleUnidirectionalPath : ruleUnidirectionalPath EOF ;
    public final void entryRuleUnidirectionalPath() throws RecognitionException {
        try {
            // InternalMachine.g:487:1: ( ruleUnidirectionalPath EOF )
            // InternalMachine.g:488:1: ruleUnidirectionalPath EOF
            {
             before(grammarAccess.getUnidirectionalPathRule()); 
            pushFollow(FOLLOW_1);
            ruleUnidirectionalPath();

            state._fsp--;

             after(grammarAccess.getUnidirectionalPathRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleUnidirectionalPath"


    // $ANTLR start "ruleUnidirectionalPath"
    // InternalMachine.g:495:1: ruleUnidirectionalPath : ( ( rule__UnidirectionalPath__Group__0 ) ) ;
    public final void ruleUnidirectionalPath() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:499:2: ( ( ( rule__UnidirectionalPath__Group__0 ) ) )
            // InternalMachine.g:500:2: ( ( rule__UnidirectionalPath__Group__0 ) )
            {
            // InternalMachine.g:500:2: ( ( rule__UnidirectionalPath__Group__0 ) )
            // InternalMachine.g:501:3: ( rule__UnidirectionalPath__Group__0 )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getGroup()); 
            // InternalMachine.g:502:3: ( rule__UnidirectionalPath__Group__0 )
            // InternalMachine.g:502:4: rule__UnidirectionalPath__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getUnidirectionalPathAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleUnidirectionalPath"


    // $ANTLR start "entryRuleBidirectionalPath"
    // InternalMachine.g:511:1: entryRuleBidirectionalPath : ruleBidirectionalPath EOF ;
    public final void entryRuleBidirectionalPath() throws RecognitionException {
        try {
            // InternalMachine.g:512:1: ( ruleBidirectionalPath EOF )
            // InternalMachine.g:513:1: ruleBidirectionalPath EOF
            {
             before(grammarAccess.getBidirectionalPathRule()); 
            pushFollow(FOLLOW_1);
            ruleBidirectionalPath();

            state._fsp--;

             after(grammarAccess.getBidirectionalPathRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleBidirectionalPath"


    // $ANTLR start "ruleBidirectionalPath"
    // InternalMachine.g:520:1: ruleBidirectionalPath : ( ( rule__BidirectionalPath__Group__0 ) ) ;
    public final void ruleBidirectionalPath() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:524:2: ( ( ( rule__BidirectionalPath__Group__0 ) ) )
            // InternalMachine.g:525:2: ( ( rule__BidirectionalPath__Group__0 ) )
            {
            // InternalMachine.g:525:2: ( ( rule__BidirectionalPath__Group__0 ) )
            // InternalMachine.g:526:3: ( rule__BidirectionalPath__Group__0 )
            {
             before(grammarAccess.getBidirectionalPathAccess().getGroup()); 
            // InternalMachine.g:527:3: ( rule__BidirectionalPath__Group__0 )
            // InternalMachine.g:527:4: rule__BidirectionalPath__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getBidirectionalPathAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleBidirectionalPath"


    // $ANTLR start "entryRuleFullMeshPath"
    // InternalMachine.g:536:1: entryRuleFullMeshPath : ruleFullMeshPath EOF ;
    public final void entryRuleFullMeshPath() throws RecognitionException {
        try {
            // InternalMachine.g:537:1: ( ruleFullMeshPath EOF )
            // InternalMachine.g:538:1: ruleFullMeshPath EOF
            {
             before(grammarAccess.getFullMeshPathRule()); 
            pushFollow(FOLLOW_1);
            ruleFullMeshPath();

            state._fsp--;

             after(grammarAccess.getFullMeshPathRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleFullMeshPath"


    // $ANTLR start "ruleFullMeshPath"
    // InternalMachine.g:545:1: ruleFullMeshPath : ( ( rule__FullMeshPath__Group__0 ) ) ;
    public final void ruleFullMeshPath() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:549:2: ( ( ( rule__FullMeshPath__Group__0 ) ) )
            // InternalMachine.g:550:2: ( ( rule__FullMeshPath__Group__0 ) )
            {
            // InternalMachine.g:550:2: ( ( rule__FullMeshPath__Group__0 ) )
            // InternalMachine.g:551:3: ( rule__FullMeshPath__Group__0 )
            {
             before(grammarAccess.getFullMeshPathAccess().getGroup()); 
            // InternalMachine.g:552:3: ( rule__FullMeshPath__Group__0 )
            // InternalMachine.g:552:4: rule__FullMeshPath__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getFullMeshPathAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleFullMeshPath"


    // $ANTLR start "entryRulePathTargetReference"
    // InternalMachine.g:561:1: entryRulePathTargetReference : rulePathTargetReference EOF ;
    public final void entryRulePathTargetReference() throws RecognitionException {
        try {
            // InternalMachine.g:562:1: ( rulePathTargetReference EOF )
            // InternalMachine.g:563:1: rulePathTargetReference EOF
            {
             before(grammarAccess.getPathTargetReferenceRule()); 
            pushFollow(FOLLOW_1);
            rulePathTargetReference();

            state._fsp--;

             after(grammarAccess.getPathTargetReferenceRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRulePathTargetReference"


    // $ANTLR start "rulePathTargetReference"
    // InternalMachine.g:570:1: rulePathTargetReference : ( ( rule__PathTargetReference__Group__0 ) ) ;
    public final void rulePathTargetReference() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:574:2: ( ( ( rule__PathTargetReference__Group__0 ) ) )
            // InternalMachine.g:575:2: ( ( rule__PathTargetReference__Group__0 ) )
            {
            // InternalMachine.g:575:2: ( ( rule__PathTargetReference__Group__0 ) )
            // InternalMachine.g:576:3: ( rule__PathTargetReference__Group__0 )
            {
             before(grammarAccess.getPathTargetReferenceAccess().getGroup()); 
            // InternalMachine.g:577:3: ( rule__PathTargetReference__Group__0 )
            // InternalMachine.g:577:4: rule__PathTargetReference__Group__0
            {
            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group__0();

            state._fsp--;


            }

             after(grammarAccess.getPathTargetReferenceAccess().getGroup()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rulePathTargetReference"


    // $ANTLR start "entryRuleIID"
    // InternalMachine.g:586:1: entryRuleIID : ruleIID EOF ;
    public final void entryRuleIID() throws RecognitionException {
        try {
            // InternalMachine.g:587:1: ( ruleIID EOF )
            // InternalMachine.g:588:1: ruleIID EOF
            {
             before(grammarAccess.getIIDRule()); 
            pushFollow(FOLLOW_1);
            ruleIID();

            state._fsp--;

             after(grammarAccess.getIIDRule()); 
            match(input,EOF,FOLLOW_2); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return ;
    }
    // $ANTLR end "entryRuleIID"


    // $ANTLR start "ruleIID"
    // InternalMachine.g:595:1: ruleIID : ( ( rule__IID__Alternatives ) ) ;
    public final void ruleIID() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:599:2: ( ( ( rule__IID__Alternatives ) ) )
            // InternalMachine.g:600:2: ( ( rule__IID__Alternatives ) )
            {
            // InternalMachine.g:600:2: ( ( rule__IID__Alternatives ) )
            // InternalMachine.g:601:3: ( rule__IID__Alternatives )
            {
             before(grammarAccess.getIIDAccess().getAlternatives()); 
            // InternalMachine.g:602:3: ( rule__IID__Alternatives )
            // InternalMachine.g:602:4: rule__IID__Alternatives
            {
            pushFollow(FOLLOW_2);
            rule__IID__Alternatives();

            state._fsp--;


            }

             after(grammarAccess.getIIDAccess().getAlternatives()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "ruleIID"


    // $ANTLR start "rule__Machine__Alternatives_4"
    // InternalMachine.g:610:1: rule__Machine__Alternatives_4 : ( ( ( rule__Machine__PeripheralTypesAssignment_4_0 ) ) | ( ( rule__Machine__ResourcesAssignment_4_1 ) ) );
    public final void rule__Machine__Alternatives_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:614:1: ( ( ( rule__Machine__PeripheralTypesAssignment_4_0 ) ) | ( ( rule__Machine__ResourcesAssignment_4_1 ) ) )
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==16) ) {
                alt1=1;
            }
            else if ( (LA1_0==25) ) {
                alt1=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 1, 0, input);

                throw nvae;
            }
            switch (alt1) {
                case 1 :
                    // InternalMachine.g:615:2: ( ( rule__Machine__PeripheralTypesAssignment_4_0 ) )
                    {
                    // InternalMachine.g:615:2: ( ( rule__Machine__PeripheralTypesAssignment_4_0 ) )
                    // InternalMachine.g:616:3: ( rule__Machine__PeripheralTypesAssignment_4_0 )
                    {
                     before(grammarAccess.getMachineAccess().getPeripheralTypesAssignment_4_0()); 
                    // InternalMachine.g:617:3: ( rule__Machine__PeripheralTypesAssignment_4_0 )
                    // InternalMachine.g:617:4: rule__Machine__PeripheralTypesAssignment_4_0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Machine__PeripheralTypesAssignment_4_0();

                    state._fsp--;


                    }

                     after(grammarAccess.getMachineAccess().getPeripheralTypesAssignment_4_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalMachine.g:621:2: ( ( rule__Machine__ResourcesAssignment_4_1 ) )
                    {
                    // InternalMachine.g:621:2: ( ( rule__Machine__ResourcesAssignment_4_1 ) )
                    // InternalMachine.g:622:3: ( rule__Machine__ResourcesAssignment_4_1 )
                    {
                     before(grammarAccess.getMachineAccess().getResourcesAssignment_4_1()); 
                    // InternalMachine.g:623:3: ( rule__Machine__ResourcesAssignment_4_1 )
                    // InternalMachine.g:623:4: rule__Machine__ResourcesAssignment_4_1
                    {
                    pushFollow(FOLLOW_2);
                    rule__Machine__ResourcesAssignment_4_1();

                    state._fsp--;


                    }

                     after(grammarAccess.getMachineAccess().getResourcesAssignment_4_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Alternatives_4"


    // $ANTLR start "rule__Path__Alternatives"
    // InternalMachine.g:631:1: rule__Path__Alternatives : ( ( ruleUnidirectionalPath ) | ( ruleBidirectionalPath ) | ( ruleFullMeshPath ) );
    public final void rule__Path__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:635:1: ( ( ruleUnidirectionalPath ) | ( ruleBidirectionalPath ) | ( ruleFullMeshPath ) )
            int alt2=3;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==RULE_ID) ) {
                int LA2_1 = input.LA(2);

                if ( (LA2_1==21||LA2_1==39) ) {
                    alt2=2;
                }
                else if ( (LA2_1==35) ) {
                    alt2=1;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 2, 1, input);

                    throw nvae;
                }
            }
            else if ( (LA2_0==40) ) {
                alt2=3;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }
            switch (alt2) {
                case 1 :
                    // InternalMachine.g:636:2: ( ruleUnidirectionalPath )
                    {
                    // InternalMachine.g:636:2: ( ruleUnidirectionalPath )
                    // InternalMachine.g:637:3: ruleUnidirectionalPath
                    {
                     before(grammarAccess.getPathAccess().getUnidirectionalPathParserRuleCall_0()); 
                    pushFollow(FOLLOW_2);
                    ruleUnidirectionalPath();

                    state._fsp--;

                     after(grammarAccess.getPathAccess().getUnidirectionalPathParserRuleCall_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalMachine.g:642:2: ( ruleBidirectionalPath )
                    {
                    // InternalMachine.g:642:2: ( ruleBidirectionalPath )
                    // InternalMachine.g:643:3: ruleBidirectionalPath
                    {
                     before(grammarAccess.getPathAccess().getBidirectionalPathParserRuleCall_1()); 
                    pushFollow(FOLLOW_2);
                    ruleBidirectionalPath();

                    state._fsp--;

                     after(grammarAccess.getPathAccess().getBidirectionalPathParserRuleCall_1()); 

                    }


                    }
                    break;
                case 3 :
                    // InternalMachine.g:648:2: ( ruleFullMeshPath )
                    {
                    // InternalMachine.g:648:2: ( ruleFullMeshPath )
                    // InternalMachine.g:649:3: ruleFullMeshPath
                    {
                     before(grammarAccess.getPathAccess().getFullMeshPathParserRuleCall_2()); 
                    pushFollow(FOLLOW_2);
                    ruleFullMeshPath();

                    state._fsp--;

                     after(grammarAccess.getPathAccess().getFullMeshPathParserRuleCall_2()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Path__Alternatives"


    // $ANTLR start "rule__UnidirectionalPath__Alternatives_4"
    // InternalMachine.g:658:1: rule__UnidirectionalPath__Alternatives_4 : ( ( ( rule__UnidirectionalPath__Group_4_0__0 ) ) | ( ( rule__UnidirectionalPath__Group_4_1__0 ) ) );
    public final void rule__UnidirectionalPath__Alternatives_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:662:1: ( ( ( rule__UnidirectionalPath__Group_4_0__0 ) ) | ( ( rule__UnidirectionalPath__Group_4_1__0 ) ) )
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==36) ) {
                alt3=1;
            }
            else if ( (LA3_0==37) ) {
                alt3=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 3, 0, input);

                throw nvae;
            }
            switch (alt3) {
                case 1 :
                    // InternalMachine.g:663:2: ( ( rule__UnidirectionalPath__Group_4_0__0 ) )
                    {
                    // InternalMachine.g:663:2: ( ( rule__UnidirectionalPath__Group_4_0__0 ) )
                    // InternalMachine.g:664:3: ( rule__UnidirectionalPath__Group_4_0__0 )
                    {
                     before(grammarAccess.getUnidirectionalPathAccess().getGroup_4_0()); 
                    // InternalMachine.g:665:3: ( rule__UnidirectionalPath__Group_4_0__0 )
                    // InternalMachine.g:665:4: rule__UnidirectionalPath__Group_4_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__UnidirectionalPath__Group_4_0__0();

                    state._fsp--;


                    }

                     after(grammarAccess.getUnidirectionalPathAccess().getGroup_4_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalMachine.g:669:2: ( ( rule__UnidirectionalPath__Group_4_1__0 ) )
                    {
                    // InternalMachine.g:669:2: ( ( rule__UnidirectionalPath__Group_4_1__0 ) )
                    // InternalMachine.g:670:3: ( rule__UnidirectionalPath__Group_4_1__0 )
                    {
                     before(grammarAccess.getUnidirectionalPathAccess().getGroup_4_1()); 
                    // InternalMachine.g:671:3: ( rule__UnidirectionalPath__Group_4_1__0 )
                    // InternalMachine.g:671:4: rule__UnidirectionalPath__Group_4_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__UnidirectionalPath__Group_4_1__0();

                    state._fsp--;


                    }

                     after(grammarAccess.getUnidirectionalPathAccess().getGroup_4_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Alternatives_4"


    // $ANTLR start "rule__BidirectionalPath__Alternatives_4"
    // InternalMachine.g:679:1: rule__BidirectionalPath__Alternatives_4 : ( ( ( rule__BidirectionalPath__Group_4_0__0 ) ) | ( ( rule__BidirectionalPath__Group_4_1__0 ) ) );
    public final void rule__BidirectionalPath__Alternatives_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:683:1: ( ( ( rule__BidirectionalPath__Group_4_0__0 ) ) | ( ( rule__BidirectionalPath__Group_4_1__0 ) ) )
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==36) ) {
                alt4=1;
            }
            else if ( (LA4_0==37) ) {
                alt4=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 4, 0, input);

                throw nvae;
            }
            switch (alt4) {
                case 1 :
                    // InternalMachine.g:684:2: ( ( rule__BidirectionalPath__Group_4_0__0 ) )
                    {
                    // InternalMachine.g:684:2: ( ( rule__BidirectionalPath__Group_4_0__0 ) )
                    // InternalMachine.g:685:3: ( rule__BidirectionalPath__Group_4_0__0 )
                    {
                     before(grammarAccess.getBidirectionalPathAccess().getGroup_4_0()); 
                    // InternalMachine.g:686:3: ( rule__BidirectionalPath__Group_4_0__0 )
                    // InternalMachine.g:686:4: rule__BidirectionalPath__Group_4_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__BidirectionalPath__Group_4_0__0();

                    state._fsp--;


                    }

                     after(grammarAccess.getBidirectionalPathAccess().getGroup_4_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalMachine.g:690:2: ( ( rule__BidirectionalPath__Group_4_1__0 ) )
                    {
                    // InternalMachine.g:690:2: ( ( rule__BidirectionalPath__Group_4_1__0 ) )
                    // InternalMachine.g:691:3: ( rule__BidirectionalPath__Group_4_1__0 )
                    {
                     before(grammarAccess.getBidirectionalPathAccess().getGroup_4_1()); 
                    // InternalMachine.g:692:3: ( rule__BidirectionalPath__Group_4_1__0 )
                    // InternalMachine.g:692:4: rule__BidirectionalPath__Group_4_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__BidirectionalPath__Group_4_1__0();

                    state._fsp--;


                    }

                     after(grammarAccess.getBidirectionalPathAccess().getGroup_4_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Alternatives_4"


    // $ANTLR start "rule__FullMeshPath__Alternatives_3"
    // InternalMachine.g:700:1: rule__FullMeshPath__Alternatives_3 : ( ( ( rule__FullMeshPath__Group_3_0__0 ) ) | ( ( rule__FullMeshPath__Group_3_1__0 ) ) );
    public final void rule__FullMeshPath__Alternatives_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:704:1: ( ( ( rule__FullMeshPath__Group_3_0__0 ) ) | ( ( rule__FullMeshPath__Group_3_1__0 ) ) )
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==36) ) {
                alt5=1;
            }
            else if ( (LA5_0==37) ) {
                alt5=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 5, 0, input);

                throw nvae;
            }
            switch (alt5) {
                case 1 :
                    // InternalMachine.g:705:2: ( ( rule__FullMeshPath__Group_3_0__0 ) )
                    {
                    // InternalMachine.g:705:2: ( ( rule__FullMeshPath__Group_3_0__0 ) )
                    // InternalMachine.g:706:3: ( rule__FullMeshPath__Group_3_0__0 )
                    {
                     before(grammarAccess.getFullMeshPathAccess().getGroup_3_0()); 
                    // InternalMachine.g:707:3: ( rule__FullMeshPath__Group_3_0__0 )
                    // InternalMachine.g:707:4: rule__FullMeshPath__Group_3_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__FullMeshPath__Group_3_0__0();

                    state._fsp--;


                    }

                     after(grammarAccess.getFullMeshPathAccess().getGroup_3_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalMachine.g:711:2: ( ( rule__FullMeshPath__Group_3_1__0 ) )
                    {
                    // InternalMachine.g:711:2: ( ( rule__FullMeshPath__Group_3_1__0 ) )
                    // InternalMachine.g:712:3: ( rule__FullMeshPath__Group_3_1__0 )
                    {
                     before(grammarAccess.getFullMeshPathAccess().getGroup_3_1()); 
                    // InternalMachine.g:713:3: ( rule__FullMeshPath__Group_3_1__0 )
                    // InternalMachine.g:713:4: rule__FullMeshPath__Group_3_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__FullMeshPath__Group_3_1__0();

                    state._fsp--;


                    }

                     after(grammarAccess.getFullMeshPathAccess().getGroup_3_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Alternatives_3"


    // $ANTLR start "rule__IID__Alternatives"
    // InternalMachine.g:721:1: rule__IID__Alternatives : ( ( RULE_INT ) | ( RULE_ID ) );
    public final void rule__IID__Alternatives() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:725:1: ( ( RULE_INT ) | ( RULE_ID ) )
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==RULE_INT) ) {
                alt6=1;
            }
            else if ( (LA6_0==RULE_ID) ) {
                alt6=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 6, 0, input);

                throw nvae;
            }
            switch (alt6) {
                case 1 :
                    // InternalMachine.g:726:2: ( RULE_INT )
                    {
                    // InternalMachine.g:726:2: ( RULE_INT )
                    // InternalMachine.g:727:3: RULE_INT
                    {
                     before(grammarAccess.getIIDAccess().getINTTerminalRuleCall_0()); 
                    match(input,RULE_INT,FOLLOW_2); 
                     after(grammarAccess.getIIDAccess().getINTTerminalRuleCall_0()); 

                    }


                    }
                    break;
                case 2 :
                    // InternalMachine.g:732:2: ( RULE_ID )
                    {
                    // InternalMachine.g:732:2: ( RULE_ID )
                    // InternalMachine.g:733:3: RULE_ID
                    {
                     before(grammarAccess.getIIDAccess().getIDTerminalRuleCall_1()); 
                    match(input,RULE_ID,FOLLOW_2); 
                     after(grammarAccess.getIIDAccess().getIDTerminalRuleCall_1()); 

                    }


                    }
                    break;

            }
        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__IID__Alternatives"


    // $ANTLR start "rule__Machine__Group__0"
    // InternalMachine.g:742:1: rule__Machine__Group__0 : rule__Machine__Group__0__Impl rule__Machine__Group__1 ;
    public final void rule__Machine__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:746:1: ( rule__Machine__Group__0__Impl rule__Machine__Group__1 )
            // InternalMachine.g:747:2: rule__Machine__Group__0__Impl rule__Machine__Group__1
            {
            pushFollow(FOLLOW_3);
            rule__Machine__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Machine__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__0"


    // $ANTLR start "rule__Machine__Group__0__Impl"
    // InternalMachine.g:754:1: rule__Machine__Group__0__Impl : ( () ) ;
    public final void rule__Machine__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:758:1: ( ( () ) )
            // InternalMachine.g:759:1: ( () )
            {
            // InternalMachine.g:759:1: ( () )
            // InternalMachine.g:760:2: ()
            {
             before(grammarAccess.getMachineAccess().getMachineAction_0()); 
            // InternalMachine.g:761:2: ()
            // InternalMachine.g:761:3: 
            {
            }

             after(grammarAccess.getMachineAccess().getMachineAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__0__Impl"


    // $ANTLR start "rule__Machine__Group__1"
    // InternalMachine.g:769:1: rule__Machine__Group__1 : rule__Machine__Group__1__Impl rule__Machine__Group__2 ;
    public final void rule__Machine__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:773:1: ( rule__Machine__Group__1__Impl rule__Machine__Group__2 )
            // InternalMachine.g:774:2: rule__Machine__Group__1__Impl rule__Machine__Group__2
            {
            pushFollow(FOLLOW_3);
            rule__Machine__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Machine__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__1"


    // $ANTLR start "rule__Machine__Group__1__Impl"
    // InternalMachine.g:781:1: rule__Machine__Group__1__Impl : ( ( rule__Machine__ImportsAssignment_1 )* ) ;
    public final void rule__Machine__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:785:1: ( ( ( rule__Machine__ImportsAssignment_1 )* ) )
            // InternalMachine.g:786:1: ( ( rule__Machine__ImportsAssignment_1 )* )
            {
            // InternalMachine.g:786:1: ( ( rule__Machine__ImportsAssignment_1 )* )
            // InternalMachine.g:787:2: ( rule__Machine__ImportsAssignment_1 )*
            {
             before(grammarAccess.getMachineAccess().getImportsAssignment_1()); 
            // InternalMachine.g:788:2: ( rule__Machine__ImportsAssignment_1 )*
            loop7:
            do {
                int alt7=2;
                int LA7_0 = input.LA(1);

                if ( (LA7_0==15) ) {
                    alt7=1;
                }


                switch (alt7) {
            	case 1 :
            	    // InternalMachine.g:788:3: rule__Machine__ImportsAssignment_1
            	    {
            	    pushFollow(FOLLOW_4);
            	    rule__Machine__ImportsAssignment_1();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop7;
                }
            } while (true);

             after(grammarAccess.getMachineAccess().getImportsAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__1__Impl"


    // $ANTLR start "rule__Machine__Group__2"
    // InternalMachine.g:796:1: rule__Machine__Group__2 : rule__Machine__Group__2__Impl rule__Machine__Group__3 ;
    public final void rule__Machine__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:800:1: ( rule__Machine__Group__2__Impl rule__Machine__Group__3 )
            // InternalMachine.g:801:2: rule__Machine__Group__2__Impl rule__Machine__Group__3
            {
            pushFollow(FOLLOW_3);
            rule__Machine__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Machine__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__2"


    // $ANTLR start "rule__Machine__Group__2__Impl"
    // InternalMachine.g:808:1: rule__Machine__Group__2__Impl : ( ( rule__Machine__Group_2__0 )? ) ;
    public final void rule__Machine__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:812:1: ( ( ( rule__Machine__Group_2__0 )? ) )
            // InternalMachine.g:813:1: ( ( rule__Machine__Group_2__0 )? )
            {
            // InternalMachine.g:813:1: ( ( rule__Machine__Group_2__0 )? )
            // InternalMachine.g:814:2: ( rule__Machine__Group_2__0 )?
            {
             before(grammarAccess.getMachineAccess().getGroup_2()); 
            // InternalMachine.g:815:2: ( rule__Machine__Group_2__0 )?
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==11) ) {
                alt8=1;
            }
            switch (alt8) {
                case 1 :
                    // InternalMachine.g:815:3: rule__Machine__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Machine__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getMachineAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__2__Impl"


    // $ANTLR start "rule__Machine__Group__3"
    // InternalMachine.g:823:1: rule__Machine__Group__3 : rule__Machine__Group__3__Impl rule__Machine__Group__4 ;
    public final void rule__Machine__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:827:1: ( rule__Machine__Group__3__Impl rule__Machine__Group__4 )
            // InternalMachine.g:828:2: rule__Machine__Group__3__Impl rule__Machine__Group__4
            {
            pushFollow(FOLLOW_3);
            rule__Machine__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Machine__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__3"


    // $ANTLR start "rule__Machine__Group__3__Impl"
    // InternalMachine.g:835:1: rule__Machine__Group__3__Impl : ( ( rule__Machine__Group_3__0 )? ) ;
    public final void rule__Machine__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:839:1: ( ( ( rule__Machine__Group_3__0 )? ) )
            // InternalMachine.g:840:1: ( ( rule__Machine__Group_3__0 )? )
            {
            // InternalMachine.g:840:1: ( ( rule__Machine__Group_3__0 )? )
            // InternalMachine.g:841:2: ( rule__Machine__Group_3__0 )?
            {
             before(grammarAccess.getMachineAccess().getGroup_3()); 
            // InternalMachine.g:842:2: ( rule__Machine__Group_3__0 )?
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==12) ) {
                alt9=1;
            }
            switch (alt9) {
                case 1 :
                    // InternalMachine.g:842:3: rule__Machine__Group_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Machine__Group_3__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getMachineAccess().getGroup_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__3__Impl"


    // $ANTLR start "rule__Machine__Group__4"
    // InternalMachine.g:850:1: rule__Machine__Group__4 : rule__Machine__Group__4__Impl ;
    public final void rule__Machine__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:854:1: ( rule__Machine__Group__4__Impl )
            // InternalMachine.g:855:2: rule__Machine__Group__4__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Machine__Group__4__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__4"


    // $ANTLR start "rule__Machine__Group__4__Impl"
    // InternalMachine.g:861:1: rule__Machine__Group__4__Impl : ( ( rule__Machine__Alternatives_4 )* ) ;
    public final void rule__Machine__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:865:1: ( ( ( rule__Machine__Alternatives_4 )* ) )
            // InternalMachine.g:866:1: ( ( rule__Machine__Alternatives_4 )* )
            {
            // InternalMachine.g:866:1: ( ( rule__Machine__Alternatives_4 )* )
            // InternalMachine.g:867:2: ( rule__Machine__Alternatives_4 )*
            {
             before(grammarAccess.getMachineAccess().getAlternatives_4()); 
            // InternalMachine.g:868:2: ( rule__Machine__Alternatives_4 )*
            loop10:
            do {
                int alt10=2;
                int LA10_0 = input.LA(1);

                if ( (LA10_0==16||LA10_0==25) ) {
                    alt10=1;
                }


                switch (alt10) {
            	case 1 :
            	    // InternalMachine.g:868:3: rule__Machine__Alternatives_4
            	    {
            	    pushFollow(FOLLOW_5);
            	    rule__Machine__Alternatives_4();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop10;
                }
            } while (true);

             after(grammarAccess.getMachineAccess().getAlternatives_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group__4__Impl"


    // $ANTLR start "rule__Machine__Group_2__0"
    // InternalMachine.g:877:1: rule__Machine__Group_2__0 : rule__Machine__Group_2__0__Impl rule__Machine__Group_2__1 ;
    public final void rule__Machine__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:881:1: ( rule__Machine__Group_2__0__Impl rule__Machine__Group_2__1 )
            // InternalMachine.g:882:2: rule__Machine__Group_2__0__Impl rule__Machine__Group_2__1
            {
            pushFollow(FOLLOW_6);
            rule__Machine__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Machine__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_2__0"


    // $ANTLR start "rule__Machine__Group_2__0__Impl"
    // InternalMachine.g:889:1: rule__Machine__Group_2__0__Impl : ( 'Machine' ) ;
    public final void rule__Machine__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:893:1: ( ( 'Machine' ) )
            // InternalMachine.g:894:1: ( 'Machine' )
            {
            // InternalMachine.g:894:1: ( 'Machine' )
            // InternalMachine.g:895:2: 'Machine'
            {
             before(grammarAccess.getMachineAccess().getMachineKeyword_2_0()); 
            match(input,11,FOLLOW_2); 
             after(grammarAccess.getMachineAccess().getMachineKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_2__0__Impl"


    // $ANTLR start "rule__Machine__Group_2__1"
    // InternalMachine.g:904:1: rule__Machine__Group_2__1 : rule__Machine__Group_2__1__Impl ;
    public final void rule__Machine__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:908:1: ( rule__Machine__Group_2__1__Impl )
            // InternalMachine.g:909:2: rule__Machine__Group_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Machine__Group_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_2__1"


    // $ANTLR start "rule__Machine__Group_2__1__Impl"
    // InternalMachine.g:915:1: rule__Machine__Group_2__1__Impl : ( ( rule__Machine__TypeAssignment_2_1 ) ) ;
    public final void rule__Machine__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:919:1: ( ( ( rule__Machine__TypeAssignment_2_1 ) ) )
            // InternalMachine.g:920:1: ( ( rule__Machine__TypeAssignment_2_1 ) )
            {
            // InternalMachine.g:920:1: ( ( rule__Machine__TypeAssignment_2_1 ) )
            // InternalMachine.g:921:2: ( rule__Machine__TypeAssignment_2_1 )
            {
             before(grammarAccess.getMachineAccess().getTypeAssignment_2_1()); 
            // InternalMachine.g:922:2: ( rule__Machine__TypeAssignment_2_1 )
            // InternalMachine.g:922:3: rule__Machine__TypeAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__Machine__TypeAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getMachineAccess().getTypeAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_2__1__Impl"


    // $ANTLR start "rule__Machine__Group_3__0"
    // InternalMachine.g:931:1: rule__Machine__Group_3__0 : rule__Machine__Group_3__0__Impl rule__Machine__Group_3__1 ;
    public final void rule__Machine__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:935:1: ( rule__Machine__Group_3__0__Impl rule__Machine__Group_3__1 )
            // InternalMachine.g:936:2: rule__Machine__Group_3__0__Impl rule__Machine__Group_3__1
            {
            pushFollow(FOLLOW_7);
            rule__Machine__Group_3__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Machine__Group_3__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_3__0"


    // $ANTLR start "rule__Machine__Group_3__0__Impl"
    // InternalMachine.g:943:1: rule__Machine__Group_3__0__Impl : ( 'PathAnnotations' ) ;
    public final void rule__Machine__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:947:1: ( ( 'PathAnnotations' ) )
            // InternalMachine.g:948:1: ( 'PathAnnotations' )
            {
            // InternalMachine.g:948:1: ( 'PathAnnotations' )
            // InternalMachine.g:949:2: 'PathAnnotations'
            {
             before(grammarAccess.getMachineAccess().getPathAnnotationsKeyword_3_0()); 
            match(input,12,FOLLOW_2); 
             after(grammarAccess.getMachineAccess().getPathAnnotationsKeyword_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_3__0__Impl"


    // $ANTLR start "rule__Machine__Group_3__1"
    // InternalMachine.g:958:1: rule__Machine__Group_3__1 : rule__Machine__Group_3__1__Impl rule__Machine__Group_3__2 ;
    public final void rule__Machine__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:962:1: ( rule__Machine__Group_3__1__Impl rule__Machine__Group_3__2 )
            // InternalMachine.g:963:2: rule__Machine__Group_3__1__Impl rule__Machine__Group_3__2
            {
            pushFollow(FOLLOW_8);
            rule__Machine__Group_3__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Machine__Group_3__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_3__1"


    // $ANTLR start "rule__Machine__Group_3__1__Impl"
    // InternalMachine.g:970:1: rule__Machine__Group_3__1__Impl : ( '{' ) ;
    public final void rule__Machine__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:974:1: ( ( '{' ) )
            // InternalMachine.g:975:1: ( '{' )
            {
            // InternalMachine.g:975:1: ( '{' )
            // InternalMachine.g:976:2: '{'
            {
             before(grammarAccess.getMachineAccess().getLeftCurlyBracketKeyword_3_1()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getMachineAccess().getLeftCurlyBracketKeyword_3_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_3__1__Impl"


    // $ANTLR start "rule__Machine__Group_3__2"
    // InternalMachine.g:985:1: rule__Machine__Group_3__2 : rule__Machine__Group_3__2__Impl rule__Machine__Group_3__3 ;
    public final void rule__Machine__Group_3__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:989:1: ( rule__Machine__Group_3__2__Impl rule__Machine__Group_3__3 )
            // InternalMachine.g:990:2: rule__Machine__Group_3__2__Impl rule__Machine__Group_3__3
            {
            pushFollow(FOLLOW_8);
            rule__Machine__Group_3__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Machine__Group_3__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_3__2"


    // $ANTLR start "rule__Machine__Group_3__2__Impl"
    // InternalMachine.g:997:1: rule__Machine__Group_3__2__Impl : ( ( rule__Machine__PathAnnotationsAssignment_3_2 )* ) ;
    public final void rule__Machine__Group_3__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1001:1: ( ( ( rule__Machine__PathAnnotationsAssignment_3_2 )* ) )
            // InternalMachine.g:1002:1: ( ( rule__Machine__PathAnnotationsAssignment_3_2 )* )
            {
            // InternalMachine.g:1002:1: ( ( rule__Machine__PathAnnotationsAssignment_3_2 )* )
            // InternalMachine.g:1003:2: ( rule__Machine__PathAnnotationsAssignment_3_2 )*
            {
             before(grammarAccess.getMachineAccess().getPathAnnotationsAssignment_3_2()); 
            // InternalMachine.g:1004:2: ( rule__Machine__PathAnnotationsAssignment_3_2 )*
            loop11:
            do {
                int alt11=2;
                int LA11_0 = input.LA(1);

                if ( (LA11_0==RULE_ID) ) {
                    alt11=1;
                }


                switch (alt11) {
            	case 1 :
            	    // InternalMachine.g:1004:3: rule__Machine__PathAnnotationsAssignment_3_2
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__Machine__PathAnnotationsAssignment_3_2();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop11;
                }
            } while (true);

             after(grammarAccess.getMachineAccess().getPathAnnotationsAssignment_3_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_3__2__Impl"


    // $ANTLR start "rule__Machine__Group_3__3"
    // InternalMachine.g:1012:1: rule__Machine__Group_3__3 : rule__Machine__Group_3__3__Impl ;
    public final void rule__Machine__Group_3__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1016:1: ( rule__Machine__Group_3__3__Impl )
            // InternalMachine.g:1017:2: rule__Machine__Group_3__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Machine__Group_3__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_3__3"


    // $ANTLR start "rule__Machine__Group_3__3__Impl"
    // InternalMachine.g:1023:1: rule__Machine__Group_3__3__Impl : ( '}' ) ;
    public final void rule__Machine__Group_3__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1027:1: ( ( '}' ) )
            // InternalMachine.g:1028:1: ( '}' )
            {
            // InternalMachine.g:1028:1: ( '}' )
            // InternalMachine.g:1029:2: '}'
            {
             before(grammarAccess.getMachineAccess().getRightCurlyBracketKeyword_3_3()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getMachineAccess().getRightCurlyBracketKeyword_3_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__Group_3__3__Impl"


    // $ANTLR start "rule__Import__Group__0"
    // InternalMachine.g:1039:1: rule__Import__Group__0 : rule__Import__Group__0__Impl rule__Import__Group__1 ;
    public final void rule__Import__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1043:1: ( rule__Import__Group__0__Impl rule__Import__Group__1 )
            // InternalMachine.g:1044:2: rule__Import__Group__0__Impl rule__Import__Group__1
            {
            pushFollow(FOLLOW_10);
            rule__Import__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Import__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__0"


    // $ANTLR start "rule__Import__Group__0__Impl"
    // InternalMachine.g:1051:1: rule__Import__Group__0__Impl : ( 'import' ) ;
    public final void rule__Import__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1055:1: ( ( 'import' ) )
            // InternalMachine.g:1056:1: ( 'import' )
            {
            // InternalMachine.g:1056:1: ( 'import' )
            // InternalMachine.g:1057:2: 'import'
            {
             before(grammarAccess.getImportAccess().getImportKeyword_0()); 
            match(input,15,FOLLOW_2); 
             after(grammarAccess.getImportAccess().getImportKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__0__Impl"


    // $ANTLR start "rule__Import__Group__1"
    // InternalMachine.g:1066:1: rule__Import__Group__1 : rule__Import__Group__1__Impl ;
    public final void rule__Import__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1070:1: ( rule__Import__Group__1__Impl )
            // InternalMachine.g:1071:2: rule__Import__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Import__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__1"


    // $ANTLR start "rule__Import__Group__1__Impl"
    // InternalMachine.g:1077:1: rule__Import__Group__1__Impl : ( ( rule__Import__ImportURIAssignment_1 ) ) ;
    public final void rule__Import__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1081:1: ( ( ( rule__Import__ImportURIAssignment_1 ) ) )
            // InternalMachine.g:1082:1: ( ( rule__Import__ImportURIAssignment_1 ) )
            {
            // InternalMachine.g:1082:1: ( ( rule__Import__ImportURIAssignment_1 ) )
            // InternalMachine.g:1083:2: ( rule__Import__ImportURIAssignment_1 )
            {
             before(grammarAccess.getImportAccess().getImportURIAssignment_1()); 
            // InternalMachine.g:1084:2: ( rule__Import__ImportURIAssignment_1 )
            // InternalMachine.g:1084:3: rule__Import__ImportURIAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Import__ImportURIAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getImportAccess().getImportURIAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__Group__1__Impl"


    // $ANTLR start "rule__PathAnnotation__Group__0"
    // InternalMachine.g:1093:1: rule__PathAnnotation__Group__0 : rule__PathAnnotation__Group__0__Impl rule__PathAnnotation__Group__1 ;
    public final void rule__PathAnnotation__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1097:1: ( rule__PathAnnotation__Group__0__Impl rule__PathAnnotation__Group__1 )
            // InternalMachine.g:1098:2: rule__PathAnnotation__Group__0__Impl rule__PathAnnotation__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__PathAnnotation__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PathAnnotation__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathAnnotation__Group__0"


    // $ANTLR start "rule__PathAnnotation__Group__0__Impl"
    // InternalMachine.g:1105:1: rule__PathAnnotation__Group__0__Impl : ( () ) ;
    public final void rule__PathAnnotation__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1109:1: ( ( () ) )
            // InternalMachine.g:1110:1: ( () )
            {
            // InternalMachine.g:1110:1: ( () )
            // InternalMachine.g:1111:2: ()
            {
             before(grammarAccess.getPathAnnotationAccess().getPathAnnotationAction_0()); 
            // InternalMachine.g:1112:2: ()
            // InternalMachine.g:1112:3: 
            {
            }

             after(grammarAccess.getPathAnnotationAccess().getPathAnnotationAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathAnnotation__Group__0__Impl"


    // $ANTLR start "rule__PathAnnotation__Group__1"
    // InternalMachine.g:1120:1: rule__PathAnnotation__Group__1 : rule__PathAnnotation__Group__1__Impl ;
    public final void rule__PathAnnotation__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1124:1: ( rule__PathAnnotation__Group__1__Impl )
            // InternalMachine.g:1125:2: rule__PathAnnotation__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__PathAnnotation__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathAnnotation__Group__1"


    // $ANTLR start "rule__PathAnnotation__Group__1__Impl"
    // InternalMachine.g:1131:1: rule__PathAnnotation__Group__1__Impl : ( ( rule__PathAnnotation__NameAssignment_1 ) ) ;
    public final void rule__PathAnnotation__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1135:1: ( ( ( rule__PathAnnotation__NameAssignment_1 ) ) )
            // InternalMachine.g:1136:1: ( ( rule__PathAnnotation__NameAssignment_1 ) )
            {
            // InternalMachine.g:1136:1: ( ( rule__PathAnnotation__NameAssignment_1 ) )
            // InternalMachine.g:1137:2: ( rule__PathAnnotation__NameAssignment_1 )
            {
             before(grammarAccess.getPathAnnotationAccess().getNameAssignment_1()); 
            // InternalMachine.g:1138:2: ( rule__PathAnnotation__NameAssignment_1 )
            // InternalMachine.g:1138:3: rule__PathAnnotation__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__PathAnnotation__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getPathAnnotationAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathAnnotation__Group__1__Impl"


    // $ANTLR start "rule__PeripheralType__Group__0"
    // InternalMachine.g:1147:1: rule__PeripheralType__Group__0 : rule__PeripheralType__Group__0__Impl rule__PeripheralType__Group__1 ;
    public final void rule__PeripheralType__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1151:1: ( rule__PeripheralType__Group__0__Impl rule__PeripheralType__Group__1 )
            // InternalMachine.g:1152:2: rule__PeripheralType__Group__0__Impl rule__PeripheralType__Group__1
            {
            pushFollow(FOLLOW_11);
            rule__PeripheralType__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__0"


    // $ANTLR start "rule__PeripheralType__Group__0__Impl"
    // InternalMachine.g:1159:1: rule__PeripheralType__Group__0__Impl : ( () ) ;
    public final void rule__PeripheralType__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1163:1: ( ( () ) )
            // InternalMachine.g:1164:1: ( () )
            {
            // InternalMachine.g:1164:1: ( () )
            // InternalMachine.g:1165:2: ()
            {
             before(grammarAccess.getPeripheralTypeAccess().getPeripheralTypeAction_0()); 
            // InternalMachine.g:1166:2: ()
            // InternalMachine.g:1166:3: 
            {
            }

             after(grammarAccess.getPeripheralTypeAccess().getPeripheralTypeAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__0__Impl"


    // $ANTLR start "rule__PeripheralType__Group__1"
    // InternalMachine.g:1174:1: rule__PeripheralType__Group__1 : rule__PeripheralType__Group__1__Impl rule__PeripheralType__Group__2 ;
    public final void rule__PeripheralType__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1178:1: ( rule__PeripheralType__Group__1__Impl rule__PeripheralType__Group__2 )
            // InternalMachine.g:1179:2: rule__PeripheralType__Group__1__Impl rule__PeripheralType__Group__2
            {
            pushFollow(FOLLOW_6);
            rule__PeripheralType__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__1"


    // $ANTLR start "rule__PeripheralType__Group__1__Impl"
    // InternalMachine.g:1186:1: rule__PeripheralType__Group__1__Impl : ( 'PeripheralType' ) ;
    public final void rule__PeripheralType__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1190:1: ( ( 'PeripheralType' ) )
            // InternalMachine.g:1191:1: ( 'PeripheralType' )
            {
            // InternalMachine.g:1191:1: ( 'PeripheralType' )
            // InternalMachine.g:1192:2: 'PeripheralType'
            {
             before(grammarAccess.getPeripheralTypeAccess().getPeripheralTypeKeyword_1()); 
            match(input,16,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getPeripheralTypeKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__1__Impl"


    // $ANTLR start "rule__PeripheralType__Group__2"
    // InternalMachine.g:1201:1: rule__PeripheralType__Group__2 : rule__PeripheralType__Group__2__Impl rule__PeripheralType__Group__3 ;
    public final void rule__PeripheralType__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1205:1: ( rule__PeripheralType__Group__2__Impl rule__PeripheralType__Group__3 )
            // InternalMachine.g:1206:2: rule__PeripheralType__Group__2__Impl rule__PeripheralType__Group__3
            {
            pushFollow(FOLLOW_7);
            rule__PeripheralType__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__2"


    // $ANTLR start "rule__PeripheralType__Group__2__Impl"
    // InternalMachine.g:1213:1: rule__PeripheralType__Group__2__Impl : ( ( rule__PeripheralType__NameAssignment_2 ) ) ;
    public final void rule__PeripheralType__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1217:1: ( ( ( rule__PeripheralType__NameAssignment_2 ) ) )
            // InternalMachine.g:1218:1: ( ( rule__PeripheralType__NameAssignment_2 ) )
            {
            // InternalMachine.g:1218:1: ( ( rule__PeripheralType__NameAssignment_2 ) )
            // InternalMachine.g:1219:2: ( rule__PeripheralType__NameAssignment_2 )
            {
             before(grammarAccess.getPeripheralTypeAccess().getNameAssignment_2()); 
            // InternalMachine.g:1220:2: ( rule__PeripheralType__NameAssignment_2 )
            // InternalMachine.g:1220:3: rule__PeripheralType__NameAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__PeripheralType__NameAssignment_2();

            state._fsp--;


            }

             after(grammarAccess.getPeripheralTypeAccess().getNameAssignment_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__2__Impl"


    // $ANTLR start "rule__PeripheralType__Group__3"
    // InternalMachine.g:1228:1: rule__PeripheralType__Group__3 : rule__PeripheralType__Group__3__Impl rule__PeripheralType__Group__4 ;
    public final void rule__PeripheralType__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1232:1: ( rule__PeripheralType__Group__3__Impl rule__PeripheralType__Group__4 )
            // InternalMachine.g:1233:2: rule__PeripheralType__Group__3__Impl rule__PeripheralType__Group__4
            {
            pushFollow(FOLLOW_12);
            rule__PeripheralType__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__3"


    // $ANTLR start "rule__PeripheralType__Group__3__Impl"
    // InternalMachine.g:1240:1: rule__PeripheralType__Group__3__Impl : ( '{' ) ;
    public final void rule__PeripheralType__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1244:1: ( ( '{' ) )
            // InternalMachine.g:1245:1: ( '{' )
            {
            // InternalMachine.g:1245:1: ( '{' )
            // InternalMachine.g:1246:2: '{'
            {
             before(grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_3()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__3__Impl"


    // $ANTLR start "rule__PeripheralType__Group__4"
    // InternalMachine.g:1255:1: rule__PeripheralType__Group__4 : rule__PeripheralType__Group__4__Impl rule__PeripheralType__Group__5 ;
    public final void rule__PeripheralType__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1259:1: ( rule__PeripheralType__Group__4__Impl rule__PeripheralType__Group__5 )
            // InternalMachine.g:1260:2: rule__PeripheralType__Group__4__Impl rule__PeripheralType__Group__5
            {
            pushFollow(FOLLOW_12);
            rule__PeripheralType__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__4"


    // $ANTLR start "rule__PeripheralType__Group__4__Impl"
    // InternalMachine.g:1267:1: rule__PeripheralType__Group__4__Impl : ( ( rule__PeripheralType__Group_4__0 )? ) ;
    public final void rule__PeripheralType__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1271:1: ( ( ( rule__PeripheralType__Group_4__0 )? ) )
            // InternalMachine.g:1272:1: ( ( rule__PeripheralType__Group_4__0 )? )
            {
            // InternalMachine.g:1272:1: ( ( rule__PeripheralType__Group_4__0 )? )
            // InternalMachine.g:1273:2: ( rule__PeripheralType__Group_4__0 )?
            {
             before(grammarAccess.getPeripheralTypeAccess().getGroup_4()); 
            // InternalMachine.g:1274:2: ( rule__PeripheralType__Group_4__0 )?
            int alt12=2;
            int LA12_0 = input.LA(1);

            if ( (LA12_0==17) ) {
                alt12=1;
            }
            switch (alt12) {
                case 1 :
                    // InternalMachine.g:1274:3: rule__PeripheralType__Group_4__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__PeripheralType__Group_4__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPeripheralTypeAccess().getGroup_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__4__Impl"


    // $ANTLR start "rule__PeripheralType__Group__5"
    // InternalMachine.g:1282:1: rule__PeripheralType__Group__5 : rule__PeripheralType__Group__5__Impl rule__PeripheralType__Group__6 ;
    public final void rule__PeripheralType__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1286:1: ( rule__PeripheralType__Group__5__Impl rule__PeripheralType__Group__6 )
            // InternalMachine.g:1287:2: rule__PeripheralType__Group__5__Impl rule__PeripheralType__Group__6
            {
            pushFollow(FOLLOW_12);
            rule__PeripheralType__Group__5__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group__6();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__5"


    // $ANTLR start "rule__PeripheralType__Group__5__Impl"
    // InternalMachine.g:1294:1: rule__PeripheralType__Group__5__Impl : ( ( rule__PeripheralType__Group_5__0 )? ) ;
    public final void rule__PeripheralType__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1298:1: ( ( ( rule__PeripheralType__Group_5__0 )? ) )
            // InternalMachine.g:1299:1: ( ( rule__PeripheralType__Group_5__0 )? )
            {
            // InternalMachine.g:1299:1: ( ( rule__PeripheralType__Group_5__0 )? )
            // InternalMachine.g:1300:2: ( rule__PeripheralType__Group_5__0 )?
            {
             before(grammarAccess.getPeripheralTypeAccess().getGroup_5()); 
            // InternalMachine.g:1301:2: ( rule__PeripheralType__Group_5__0 )?
            int alt13=2;
            int LA13_0 = input.LA(1);

            if ( (LA13_0==18) ) {
                alt13=1;
            }
            switch (alt13) {
                case 1 :
                    // InternalMachine.g:1301:3: rule__PeripheralType__Group_5__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__PeripheralType__Group_5__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPeripheralTypeAccess().getGroup_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__5__Impl"


    // $ANTLR start "rule__PeripheralType__Group__6"
    // InternalMachine.g:1309:1: rule__PeripheralType__Group__6 : rule__PeripheralType__Group__6__Impl ;
    public final void rule__PeripheralType__Group__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1313:1: ( rule__PeripheralType__Group__6__Impl )
            // InternalMachine.g:1314:2: rule__PeripheralType__Group__6__Impl
            {
            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group__6__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__6"


    // $ANTLR start "rule__PeripheralType__Group__6__Impl"
    // InternalMachine.g:1320:1: rule__PeripheralType__Group__6__Impl : ( '}' ) ;
    public final void rule__PeripheralType__Group__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1324:1: ( ( '}' ) )
            // InternalMachine.g:1325:1: ( '}' )
            {
            // InternalMachine.g:1325:1: ( '}' )
            // InternalMachine.g:1326:2: '}'
            {
             before(grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_6()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_6()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group__6__Impl"


    // $ANTLR start "rule__PeripheralType__Group_4__0"
    // InternalMachine.g:1336:1: rule__PeripheralType__Group_4__0 : rule__PeripheralType__Group_4__0__Impl rule__PeripheralType__Group_4__1 ;
    public final void rule__PeripheralType__Group_4__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1340:1: ( rule__PeripheralType__Group_4__0__Impl rule__PeripheralType__Group_4__1 )
            // InternalMachine.g:1341:2: rule__PeripheralType__Group_4__0__Impl rule__PeripheralType__Group_4__1
            {
            pushFollow(FOLLOW_7);
            rule__PeripheralType__Group_4__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_4__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_4__0"


    // $ANTLR start "rule__PeripheralType__Group_4__0__Impl"
    // InternalMachine.g:1348:1: rule__PeripheralType__Group_4__0__Impl : ( 'Actions' ) ;
    public final void rule__PeripheralType__Group_4__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1352:1: ( ( 'Actions' ) )
            // InternalMachine.g:1353:1: ( 'Actions' )
            {
            // InternalMachine.g:1353:1: ( 'Actions' )
            // InternalMachine.g:1354:2: 'Actions'
            {
             before(grammarAccess.getPeripheralTypeAccess().getActionsKeyword_4_0()); 
            match(input,17,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getActionsKeyword_4_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_4__0__Impl"


    // $ANTLR start "rule__PeripheralType__Group_4__1"
    // InternalMachine.g:1363:1: rule__PeripheralType__Group_4__1 : rule__PeripheralType__Group_4__1__Impl rule__PeripheralType__Group_4__2 ;
    public final void rule__PeripheralType__Group_4__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1367:1: ( rule__PeripheralType__Group_4__1__Impl rule__PeripheralType__Group_4__2 )
            // InternalMachine.g:1368:2: rule__PeripheralType__Group_4__1__Impl rule__PeripheralType__Group_4__2
            {
            pushFollow(FOLLOW_8);
            rule__PeripheralType__Group_4__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_4__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_4__1"


    // $ANTLR start "rule__PeripheralType__Group_4__1__Impl"
    // InternalMachine.g:1375:1: rule__PeripheralType__Group_4__1__Impl : ( '{' ) ;
    public final void rule__PeripheralType__Group_4__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1379:1: ( ( '{' ) )
            // InternalMachine.g:1380:1: ( '{' )
            {
            // InternalMachine.g:1380:1: ( '{' )
            // InternalMachine.g:1381:2: '{'
            {
             before(grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_4_1()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_4_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_4__1__Impl"


    // $ANTLR start "rule__PeripheralType__Group_4__2"
    // InternalMachine.g:1390:1: rule__PeripheralType__Group_4__2 : rule__PeripheralType__Group_4__2__Impl rule__PeripheralType__Group_4__3 ;
    public final void rule__PeripheralType__Group_4__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1394:1: ( rule__PeripheralType__Group_4__2__Impl rule__PeripheralType__Group_4__3 )
            // InternalMachine.g:1395:2: rule__PeripheralType__Group_4__2__Impl rule__PeripheralType__Group_4__3
            {
            pushFollow(FOLLOW_8);
            rule__PeripheralType__Group_4__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_4__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_4__2"


    // $ANTLR start "rule__PeripheralType__Group_4__2__Impl"
    // InternalMachine.g:1402:1: rule__PeripheralType__Group_4__2__Impl : ( ( rule__PeripheralType__ActionsAssignment_4_2 )* ) ;
    public final void rule__PeripheralType__Group_4__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1406:1: ( ( ( rule__PeripheralType__ActionsAssignment_4_2 )* ) )
            // InternalMachine.g:1407:1: ( ( rule__PeripheralType__ActionsAssignment_4_2 )* )
            {
            // InternalMachine.g:1407:1: ( ( rule__PeripheralType__ActionsAssignment_4_2 )* )
            // InternalMachine.g:1408:2: ( rule__PeripheralType__ActionsAssignment_4_2 )*
            {
             before(grammarAccess.getPeripheralTypeAccess().getActionsAssignment_4_2()); 
            // InternalMachine.g:1409:2: ( rule__PeripheralType__ActionsAssignment_4_2 )*
            loop14:
            do {
                int alt14=2;
                int LA14_0 = input.LA(1);

                if ( (LA14_0==RULE_ID) ) {
                    alt14=1;
                }


                switch (alt14) {
            	case 1 :
            	    // InternalMachine.g:1409:3: rule__PeripheralType__ActionsAssignment_4_2
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__PeripheralType__ActionsAssignment_4_2();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop14;
                }
            } while (true);

             after(grammarAccess.getPeripheralTypeAccess().getActionsAssignment_4_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_4__2__Impl"


    // $ANTLR start "rule__PeripheralType__Group_4__3"
    // InternalMachine.g:1417:1: rule__PeripheralType__Group_4__3 : rule__PeripheralType__Group_4__3__Impl ;
    public final void rule__PeripheralType__Group_4__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1421:1: ( rule__PeripheralType__Group_4__3__Impl )
            // InternalMachine.g:1422:2: rule__PeripheralType__Group_4__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_4__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_4__3"


    // $ANTLR start "rule__PeripheralType__Group_4__3__Impl"
    // InternalMachine.g:1428:1: rule__PeripheralType__Group_4__3__Impl : ( '}' ) ;
    public final void rule__PeripheralType__Group_4__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1432:1: ( ( '}' ) )
            // InternalMachine.g:1433:1: ( '}' )
            {
            // InternalMachine.g:1433:1: ( '}' )
            // InternalMachine.g:1434:2: '}'
            {
             before(grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_4_3()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_4_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_4__3__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5__0"
    // InternalMachine.g:1444:1: rule__PeripheralType__Group_5__0 : rule__PeripheralType__Group_5__0__Impl rule__PeripheralType__Group_5__1 ;
    public final void rule__PeripheralType__Group_5__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1448:1: ( rule__PeripheralType__Group_5__0__Impl rule__PeripheralType__Group_5__1 )
            // InternalMachine.g:1449:2: rule__PeripheralType__Group_5__0__Impl rule__PeripheralType__Group_5__1
            {
            pushFollow(FOLLOW_7);
            rule__PeripheralType__Group_5__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__0"


    // $ANTLR start "rule__PeripheralType__Group_5__0__Impl"
    // InternalMachine.g:1456:1: rule__PeripheralType__Group_5__0__Impl : ( 'SetPoints' ) ;
    public final void rule__PeripheralType__Group_5__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1460:1: ( ( 'SetPoints' ) )
            // InternalMachine.g:1461:1: ( 'SetPoints' )
            {
            // InternalMachine.g:1461:1: ( 'SetPoints' )
            // InternalMachine.g:1462:2: 'SetPoints'
            {
             before(grammarAccess.getPeripheralTypeAccess().getSetPointsKeyword_5_0()); 
            match(input,18,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getSetPointsKeyword_5_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__0__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5__1"
    // InternalMachine.g:1471:1: rule__PeripheralType__Group_5__1 : rule__PeripheralType__Group_5__1__Impl rule__PeripheralType__Group_5__2 ;
    public final void rule__PeripheralType__Group_5__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1475:1: ( rule__PeripheralType__Group_5__1__Impl rule__PeripheralType__Group_5__2 )
            // InternalMachine.g:1476:2: rule__PeripheralType__Group_5__1__Impl rule__PeripheralType__Group_5__2
            {
            pushFollow(FOLLOW_8);
            rule__PeripheralType__Group_5__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__1"


    // $ANTLR start "rule__PeripheralType__Group_5__1__Impl"
    // InternalMachine.g:1483:1: rule__PeripheralType__Group_5__1__Impl : ( '{' ) ;
    public final void rule__PeripheralType__Group_5__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1487:1: ( ( '{' ) )
            // InternalMachine.g:1488:1: ( '{' )
            {
            // InternalMachine.g:1488:1: ( '{' )
            // InternalMachine.g:1489:2: '{'
            {
             before(grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_5_1()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_5_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__1__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5__2"
    // InternalMachine.g:1498:1: rule__PeripheralType__Group_5__2 : rule__PeripheralType__Group_5__2__Impl rule__PeripheralType__Group_5__3 ;
    public final void rule__PeripheralType__Group_5__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1502:1: ( rule__PeripheralType__Group_5__2__Impl rule__PeripheralType__Group_5__3 )
            // InternalMachine.g:1503:2: rule__PeripheralType__Group_5__2__Impl rule__PeripheralType__Group_5__3
            {
            pushFollow(FOLLOW_8);
            rule__PeripheralType__Group_5__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__2"


    // $ANTLR start "rule__PeripheralType__Group_5__2__Impl"
    // InternalMachine.g:1510:1: rule__PeripheralType__Group_5__2__Impl : ( ( rule__PeripheralType__SetPointsAssignment_5_2 )* ) ;
    public final void rule__PeripheralType__Group_5__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1514:1: ( ( ( rule__PeripheralType__SetPointsAssignment_5_2 )* ) )
            // InternalMachine.g:1515:1: ( ( rule__PeripheralType__SetPointsAssignment_5_2 )* )
            {
            // InternalMachine.g:1515:1: ( ( rule__PeripheralType__SetPointsAssignment_5_2 )* )
            // InternalMachine.g:1516:2: ( rule__PeripheralType__SetPointsAssignment_5_2 )*
            {
             before(grammarAccess.getPeripheralTypeAccess().getSetPointsAssignment_5_2()); 
            // InternalMachine.g:1517:2: ( rule__PeripheralType__SetPointsAssignment_5_2 )*
            loop15:
            do {
                int alt15=2;
                int LA15_0 = input.LA(1);

                if ( (LA15_0==RULE_ID) ) {
                    alt15=1;
                }


                switch (alt15) {
            	case 1 :
            	    // InternalMachine.g:1517:3: rule__PeripheralType__SetPointsAssignment_5_2
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__PeripheralType__SetPointsAssignment_5_2();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop15;
                }
            } while (true);

             after(grammarAccess.getPeripheralTypeAccess().getSetPointsAssignment_5_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__2__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5__3"
    // InternalMachine.g:1525:1: rule__PeripheralType__Group_5__3 : rule__PeripheralType__Group_5__3__Impl rule__PeripheralType__Group_5__4 ;
    public final void rule__PeripheralType__Group_5__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1529:1: ( rule__PeripheralType__Group_5__3__Impl rule__PeripheralType__Group_5__4 )
            // InternalMachine.g:1530:2: rule__PeripheralType__Group_5__3__Impl rule__PeripheralType__Group_5__4
            {
            pushFollow(FOLLOW_13);
            rule__PeripheralType__Group_5__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__3"


    // $ANTLR start "rule__PeripheralType__Group_5__3__Impl"
    // InternalMachine.g:1537:1: rule__PeripheralType__Group_5__3__Impl : ( '}' ) ;
    public final void rule__PeripheralType__Group_5__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1541:1: ( ( '}' ) )
            // InternalMachine.g:1542:1: ( '}' )
            {
            // InternalMachine.g:1542:1: ( '}' )
            // InternalMachine.g:1543:2: '}'
            {
             before(grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_5_3()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_5_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__3__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5__4"
    // InternalMachine.g:1552:1: rule__PeripheralType__Group_5__4 : rule__PeripheralType__Group_5__4__Impl rule__PeripheralType__Group_5__5 ;
    public final void rule__PeripheralType__Group_5__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1556:1: ( rule__PeripheralType__Group_5__4__Impl rule__PeripheralType__Group_5__5 )
            // InternalMachine.g:1557:2: rule__PeripheralType__Group_5__4__Impl rule__PeripheralType__Group_5__5
            {
            pushFollow(FOLLOW_7);
            rule__PeripheralType__Group_5__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__4"


    // $ANTLR start "rule__PeripheralType__Group_5__4__Impl"
    // InternalMachine.g:1564:1: rule__PeripheralType__Group_5__4__Impl : ( 'Axes' ) ;
    public final void rule__PeripheralType__Group_5__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1568:1: ( ( 'Axes' ) )
            // InternalMachine.g:1569:1: ( 'Axes' )
            {
            // InternalMachine.g:1569:1: ( 'Axes' )
            // InternalMachine.g:1570:2: 'Axes'
            {
             before(grammarAccess.getPeripheralTypeAccess().getAxesKeyword_5_4()); 
            match(input,19,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getAxesKeyword_5_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__4__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5__5"
    // InternalMachine.g:1579:1: rule__PeripheralType__Group_5__5 : rule__PeripheralType__Group_5__5__Impl rule__PeripheralType__Group_5__6 ;
    public final void rule__PeripheralType__Group_5__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1583:1: ( rule__PeripheralType__Group_5__5__Impl rule__PeripheralType__Group_5__6 )
            // InternalMachine.g:1584:2: rule__PeripheralType__Group_5__5__Impl rule__PeripheralType__Group_5__6
            {
            pushFollow(FOLLOW_8);
            rule__PeripheralType__Group_5__5__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5__6();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__5"


    // $ANTLR start "rule__PeripheralType__Group_5__5__Impl"
    // InternalMachine.g:1591:1: rule__PeripheralType__Group_5__5__Impl : ( '{' ) ;
    public final void rule__PeripheralType__Group_5__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1595:1: ( ( '{' ) )
            // InternalMachine.g:1596:1: ( '{' )
            {
            // InternalMachine.g:1596:1: ( '{' )
            // InternalMachine.g:1597:2: '{'
            {
             before(grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_5_5()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getLeftCurlyBracketKeyword_5_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__5__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5__6"
    // InternalMachine.g:1606:1: rule__PeripheralType__Group_5__6 : rule__PeripheralType__Group_5__6__Impl rule__PeripheralType__Group_5__7 ;
    public final void rule__PeripheralType__Group_5__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1610:1: ( rule__PeripheralType__Group_5__6__Impl rule__PeripheralType__Group_5__7 )
            // InternalMachine.g:1611:2: rule__PeripheralType__Group_5__6__Impl rule__PeripheralType__Group_5__7
            {
            pushFollow(FOLLOW_8);
            rule__PeripheralType__Group_5__6__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5__7();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__6"


    // $ANTLR start "rule__PeripheralType__Group_5__6__Impl"
    // InternalMachine.g:1618:1: rule__PeripheralType__Group_5__6__Impl : ( ( rule__PeripheralType__AxesAssignment_5_6 )* ) ;
    public final void rule__PeripheralType__Group_5__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1622:1: ( ( ( rule__PeripheralType__AxesAssignment_5_6 )* ) )
            // InternalMachine.g:1623:1: ( ( rule__PeripheralType__AxesAssignment_5_6 )* )
            {
            // InternalMachine.g:1623:1: ( ( rule__PeripheralType__AxesAssignment_5_6 )* )
            // InternalMachine.g:1624:2: ( rule__PeripheralType__AxesAssignment_5_6 )*
            {
             before(grammarAccess.getPeripheralTypeAccess().getAxesAssignment_5_6()); 
            // InternalMachine.g:1625:2: ( rule__PeripheralType__AxesAssignment_5_6 )*
            loop16:
            do {
                int alt16=2;
                int LA16_0 = input.LA(1);

                if ( (LA16_0==RULE_ID) ) {
                    alt16=1;
                }


                switch (alt16) {
            	case 1 :
            	    // InternalMachine.g:1625:3: rule__PeripheralType__AxesAssignment_5_6
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__PeripheralType__AxesAssignment_5_6();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop16;
                }
            } while (true);

             after(grammarAccess.getPeripheralTypeAccess().getAxesAssignment_5_6()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__6__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5__7"
    // InternalMachine.g:1633:1: rule__PeripheralType__Group_5__7 : rule__PeripheralType__Group_5__7__Impl rule__PeripheralType__Group_5__8 ;
    public final void rule__PeripheralType__Group_5__7() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1637:1: ( rule__PeripheralType__Group_5__7__Impl rule__PeripheralType__Group_5__8 )
            // InternalMachine.g:1638:2: rule__PeripheralType__Group_5__7__Impl rule__PeripheralType__Group_5__8
            {
            pushFollow(FOLLOW_14);
            rule__PeripheralType__Group_5__7__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5__8();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__7"


    // $ANTLR start "rule__PeripheralType__Group_5__7__Impl"
    // InternalMachine.g:1645:1: rule__PeripheralType__Group_5__7__Impl : ( '}' ) ;
    public final void rule__PeripheralType__Group_5__7__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1649:1: ( ( '}' ) )
            // InternalMachine.g:1650:1: ( '}' )
            {
            // InternalMachine.g:1650:1: ( '}' )
            // InternalMachine.g:1651:2: '}'
            {
             before(grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_5_7()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getRightCurlyBracketKeyword_5_7()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__7__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5__8"
    // InternalMachine.g:1660:1: rule__PeripheralType__Group_5__8 : rule__PeripheralType__Group_5__8__Impl ;
    public final void rule__PeripheralType__Group_5__8() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1664:1: ( rule__PeripheralType__Group_5__8__Impl )
            // InternalMachine.g:1665:2: rule__PeripheralType__Group_5__8__Impl
            {
            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5__8__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__8"


    // $ANTLR start "rule__PeripheralType__Group_5__8__Impl"
    // InternalMachine.g:1671:1: rule__PeripheralType__Group_5__8__Impl : ( ( rule__PeripheralType__Group_5_8__0 )? ) ;
    public final void rule__PeripheralType__Group_5__8__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1675:1: ( ( ( rule__PeripheralType__Group_5_8__0 )? ) )
            // InternalMachine.g:1676:1: ( ( rule__PeripheralType__Group_5_8__0 )? )
            {
            // InternalMachine.g:1676:1: ( ( rule__PeripheralType__Group_5_8__0 )? )
            // InternalMachine.g:1677:2: ( rule__PeripheralType__Group_5_8__0 )?
            {
             before(grammarAccess.getPeripheralTypeAccess().getGroup_5_8()); 
            // InternalMachine.g:1678:2: ( rule__PeripheralType__Group_5_8__0 )?
            int alt17=2;
            int LA17_0 = input.LA(1);

            if ( (LA17_0==20) ) {
                alt17=1;
            }
            switch (alt17) {
                case 1 :
                    // InternalMachine.g:1678:3: rule__PeripheralType__Group_5_8__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__PeripheralType__Group_5_8__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPeripheralTypeAccess().getGroup_5_8()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5__8__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5_8__0"
    // InternalMachine.g:1687:1: rule__PeripheralType__Group_5_8__0 : rule__PeripheralType__Group_5_8__0__Impl rule__PeripheralType__Group_5_8__1 ;
    public final void rule__PeripheralType__Group_5_8__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1691:1: ( rule__PeripheralType__Group_5_8__0__Impl rule__PeripheralType__Group_5_8__1 )
            // InternalMachine.g:1692:2: rule__PeripheralType__Group_5_8__0__Impl rule__PeripheralType__Group_5_8__1
            {
            pushFollow(FOLLOW_10);
            rule__PeripheralType__Group_5_8__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5_8__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5_8__0"


    // $ANTLR start "rule__PeripheralType__Group_5_8__0__Impl"
    // InternalMachine.g:1699:1: rule__PeripheralType__Group_5_8__0__Impl : ( 'Conversion' ) ;
    public final void rule__PeripheralType__Group_5_8__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1703:1: ( ( 'Conversion' ) )
            // InternalMachine.g:1704:1: ( 'Conversion' )
            {
            // InternalMachine.g:1704:1: ( 'Conversion' )
            // InternalMachine.g:1705:2: 'Conversion'
            {
             before(grammarAccess.getPeripheralTypeAccess().getConversionKeyword_5_8_0()); 
            match(input,20,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getConversionKeyword_5_8_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5_8__0__Impl"


    // $ANTLR start "rule__PeripheralType__Group_5_8__1"
    // InternalMachine.g:1714:1: rule__PeripheralType__Group_5_8__1 : rule__PeripheralType__Group_5_8__1__Impl ;
    public final void rule__PeripheralType__Group_5_8__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1718:1: ( rule__PeripheralType__Group_5_8__1__Impl )
            // InternalMachine.g:1719:2: rule__PeripheralType__Group_5_8__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__PeripheralType__Group_5_8__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5_8__1"


    // $ANTLR start "rule__PeripheralType__Group_5_8__1__Impl"
    // InternalMachine.g:1725:1: rule__PeripheralType__Group_5_8__1__Impl : ( ( rule__PeripheralType__ConversionAssignment_5_8_1 ) ) ;
    public final void rule__PeripheralType__Group_5_8__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1729:1: ( ( ( rule__PeripheralType__ConversionAssignment_5_8_1 ) ) )
            // InternalMachine.g:1730:1: ( ( rule__PeripheralType__ConversionAssignment_5_8_1 ) )
            {
            // InternalMachine.g:1730:1: ( ( rule__PeripheralType__ConversionAssignment_5_8_1 ) )
            // InternalMachine.g:1731:2: ( rule__PeripheralType__ConversionAssignment_5_8_1 )
            {
             before(grammarAccess.getPeripheralTypeAccess().getConversionAssignment_5_8_1()); 
            // InternalMachine.g:1732:2: ( rule__PeripheralType__ConversionAssignment_5_8_1 )
            // InternalMachine.g:1732:3: rule__PeripheralType__ConversionAssignment_5_8_1
            {
            pushFollow(FOLLOW_2);
            rule__PeripheralType__ConversionAssignment_5_8_1();

            state._fsp--;


            }

             after(grammarAccess.getPeripheralTypeAccess().getConversionAssignment_5_8_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__Group_5_8__1__Impl"


    // $ANTLR start "rule__ActionType__Group__0"
    // InternalMachine.g:1741:1: rule__ActionType__Group__0 : rule__ActionType__Group__0__Impl rule__ActionType__Group__1 ;
    public final void rule__ActionType__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1745:1: ( rule__ActionType__Group__0__Impl rule__ActionType__Group__1 )
            // InternalMachine.g:1746:2: rule__ActionType__Group__0__Impl rule__ActionType__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__ActionType__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__ActionType__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ActionType__Group__0"


    // $ANTLR start "rule__ActionType__Group__0__Impl"
    // InternalMachine.g:1753:1: rule__ActionType__Group__0__Impl : ( () ) ;
    public final void rule__ActionType__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1757:1: ( ( () ) )
            // InternalMachine.g:1758:1: ( () )
            {
            // InternalMachine.g:1758:1: ( () )
            // InternalMachine.g:1759:2: ()
            {
             before(grammarAccess.getActionTypeAccess().getActionTypeAction_0()); 
            // InternalMachine.g:1760:2: ()
            // InternalMachine.g:1760:3: 
            {
            }

             after(grammarAccess.getActionTypeAccess().getActionTypeAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ActionType__Group__0__Impl"


    // $ANTLR start "rule__ActionType__Group__1"
    // InternalMachine.g:1768:1: rule__ActionType__Group__1 : rule__ActionType__Group__1__Impl ;
    public final void rule__ActionType__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1772:1: ( rule__ActionType__Group__1__Impl )
            // InternalMachine.g:1773:2: rule__ActionType__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__ActionType__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ActionType__Group__1"


    // $ANTLR start "rule__ActionType__Group__1__Impl"
    // InternalMachine.g:1779:1: rule__ActionType__Group__1__Impl : ( ( rule__ActionType__NameAssignment_1 ) ) ;
    public final void rule__ActionType__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1783:1: ( ( ( rule__ActionType__NameAssignment_1 ) ) )
            // InternalMachine.g:1784:1: ( ( rule__ActionType__NameAssignment_1 ) )
            {
            // InternalMachine.g:1784:1: ( ( rule__ActionType__NameAssignment_1 ) )
            // InternalMachine.g:1785:2: ( rule__ActionType__NameAssignment_1 )
            {
             before(grammarAccess.getActionTypeAccess().getNameAssignment_1()); 
            // InternalMachine.g:1786:2: ( rule__ActionType__NameAssignment_1 )
            // InternalMachine.g:1786:3: rule__ActionType__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__ActionType__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getActionTypeAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ActionType__Group__1__Impl"


    // $ANTLR start "rule__SetPoint__Group__0"
    // InternalMachine.g:1795:1: rule__SetPoint__Group__0 : rule__SetPoint__Group__0__Impl rule__SetPoint__Group__1 ;
    public final void rule__SetPoint__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1799:1: ( rule__SetPoint__Group__0__Impl rule__SetPoint__Group__1 )
            // InternalMachine.g:1800:2: rule__SetPoint__Group__0__Impl rule__SetPoint__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__SetPoint__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SetPoint__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group__0"


    // $ANTLR start "rule__SetPoint__Group__0__Impl"
    // InternalMachine.g:1807:1: rule__SetPoint__Group__0__Impl : ( () ) ;
    public final void rule__SetPoint__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1811:1: ( ( () ) )
            // InternalMachine.g:1812:1: ( () )
            {
            // InternalMachine.g:1812:1: ( () )
            // InternalMachine.g:1813:2: ()
            {
             before(grammarAccess.getSetPointAccess().getSetPointAction_0()); 
            // InternalMachine.g:1814:2: ()
            // InternalMachine.g:1814:3: 
            {
            }

             after(grammarAccess.getSetPointAccess().getSetPointAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group__0__Impl"


    // $ANTLR start "rule__SetPoint__Group__1"
    // InternalMachine.g:1822:1: rule__SetPoint__Group__1 : rule__SetPoint__Group__1__Impl rule__SetPoint__Group__2 ;
    public final void rule__SetPoint__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1826:1: ( rule__SetPoint__Group__1__Impl rule__SetPoint__Group__2 )
            // InternalMachine.g:1827:2: rule__SetPoint__Group__1__Impl rule__SetPoint__Group__2
            {
            pushFollow(FOLLOW_15);
            rule__SetPoint__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SetPoint__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group__1"


    // $ANTLR start "rule__SetPoint__Group__1__Impl"
    // InternalMachine.g:1834:1: rule__SetPoint__Group__1__Impl : ( ( rule__SetPoint__NameAssignment_1 ) ) ;
    public final void rule__SetPoint__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1838:1: ( ( ( rule__SetPoint__NameAssignment_1 ) ) )
            // InternalMachine.g:1839:1: ( ( rule__SetPoint__NameAssignment_1 ) )
            {
            // InternalMachine.g:1839:1: ( ( rule__SetPoint__NameAssignment_1 ) )
            // InternalMachine.g:1840:2: ( rule__SetPoint__NameAssignment_1 )
            {
             before(grammarAccess.getSetPointAccess().getNameAssignment_1()); 
            // InternalMachine.g:1841:2: ( rule__SetPoint__NameAssignment_1 )
            // InternalMachine.g:1841:3: rule__SetPoint__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__SetPoint__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getSetPointAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group__1__Impl"


    // $ANTLR start "rule__SetPoint__Group__2"
    // InternalMachine.g:1849:1: rule__SetPoint__Group__2 : rule__SetPoint__Group__2__Impl ;
    public final void rule__SetPoint__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1853:1: ( rule__SetPoint__Group__2__Impl )
            // InternalMachine.g:1854:2: rule__SetPoint__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__SetPoint__Group__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group__2"


    // $ANTLR start "rule__SetPoint__Group__2__Impl"
    // InternalMachine.g:1860:1: rule__SetPoint__Group__2__Impl : ( ( rule__SetPoint__Group_2__0 )? ) ;
    public final void rule__SetPoint__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1864:1: ( ( ( rule__SetPoint__Group_2__0 )? ) )
            // InternalMachine.g:1865:1: ( ( rule__SetPoint__Group_2__0 )? )
            {
            // InternalMachine.g:1865:1: ( ( rule__SetPoint__Group_2__0 )? )
            // InternalMachine.g:1866:2: ( rule__SetPoint__Group_2__0 )?
            {
             before(grammarAccess.getSetPointAccess().getGroup_2()); 
            // InternalMachine.g:1867:2: ( rule__SetPoint__Group_2__0 )?
            int alt18=2;
            int LA18_0 = input.LA(1);

            if ( (LA18_0==21) ) {
                alt18=1;
            }
            switch (alt18) {
                case 1 :
                    // InternalMachine.g:1867:3: rule__SetPoint__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__SetPoint__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getSetPointAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group__2__Impl"


    // $ANTLR start "rule__SetPoint__Group_2__0"
    // InternalMachine.g:1876:1: rule__SetPoint__Group_2__0 : rule__SetPoint__Group_2__0__Impl rule__SetPoint__Group_2__1 ;
    public final void rule__SetPoint__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1880:1: ( rule__SetPoint__Group_2__0__Impl rule__SetPoint__Group_2__1 )
            // InternalMachine.g:1881:2: rule__SetPoint__Group_2__0__Impl rule__SetPoint__Group_2__1
            {
            pushFollow(FOLLOW_6);
            rule__SetPoint__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SetPoint__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group_2__0"


    // $ANTLR start "rule__SetPoint__Group_2__0__Impl"
    // InternalMachine.g:1888:1: rule__SetPoint__Group_2__0__Impl : ( '[' ) ;
    public final void rule__SetPoint__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1892:1: ( ( '[' ) )
            // InternalMachine.g:1893:1: ( '[' )
            {
            // InternalMachine.g:1893:1: ( '[' )
            // InternalMachine.g:1894:2: '['
            {
             before(grammarAccess.getSetPointAccess().getLeftSquareBracketKeyword_2_0()); 
            match(input,21,FOLLOW_2); 
             after(grammarAccess.getSetPointAccess().getLeftSquareBracketKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group_2__0__Impl"


    // $ANTLR start "rule__SetPoint__Group_2__1"
    // InternalMachine.g:1903:1: rule__SetPoint__Group_2__1 : rule__SetPoint__Group_2__1__Impl rule__SetPoint__Group_2__2 ;
    public final void rule__SetPoint__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1907:1: ( rule__SetPoint__Group_2__1__Impl rule__SetPoint__Group_2__2 )
            // InternalMachine.g:1908:2: rule__SetPoint__Group_2__1__Impl rule__SetPoint__Group_2__2
            {
            pushFollow(FOLLOW_16);
            rule__SetPoint__Group_2__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SetPoint__Group_2__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group_2__1"


    // $ANTLR start "rule__SetPoint__Group_2__1__Impl"
    // InternalMachine.g:1915:1: rule__SetPoint__Group_2__1__Impl : ( ( rule__SetPoint__UnitAssignment_2_1 ) ) ;
    public final void rule__SetPoint__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1919:1: ( ( ( rule__SetPoint__UnitAssignment_2_1 ) ) )
            // InternalMachine.g:1920:1: ( ( rule__SetPoint__UnitAssignment_2_1 ) )
            {
            // InternalMachine.g:1920:1: ( ( rule__SetPoint__UnitAssignment_2_1 ) )
            // InternalMachine.g:1921:2: ( rule__SetPoint__UnitAssignment_2_1 )
            {
             before(grammarAccess.getSetPointAccess().getUnitAssignment_2_1()); 
            // InternalMachine.g:1922:2: ( rule__SetPoint__UnitAssignment_2_1 )
            // InternalMachine.g:1922:3: rule__SetPoint__UnitAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__SetPoint__UnitAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getSetPointAccess().getUnitAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group_2__1__Impl"


    // $ANTLR start "rule__SetPoint__Group_2__2"
    // InternalMachine.g:1930:1: rule__SetPoint__Group_2__2 : rule__SetPoint__Group_2__2__Impl ;
    public final void rule__SetPoint__Group_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1934:1: ( rule__SetPoint__Group_2__2__Impl )
            // InternalMachine.g:1935:2: rule__SetPoint__Group_2__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__SetPoint__Group_2__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group_2__2"


    // $ANTLR start "rule__SetPoint__Group_2__2__Impl"
    // InternalMachine.g:1941:1: rule__SetPoint__Group_2__2__Impl : ( ']' ) ;
    public final void rule__SetPoint__Group_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1945:1: ( ( ']' ) )
            // InternalMachine.g:1946:1: ( ']' )
            {
            // InternalMachine.g:1946:1: ( ']' )
            // InternalMachine.g:1947:2: ']'
            {
             before(grammarAccess.getSetPointAccess().getRightSquareBracketKeyword_2_2()); 
            match(input,22,FOLLOW_2); 
             after(grammarAccess.getSetPointAccess().getRightSquareBracketKeyword_2_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__Group_2__2__Impl"


    // $ANTLR start "rule__Axis__Group__0"
    // InternalMachine.g:1957:1: rule__Axis__Group__0 : rule__Axis__Group__0__Impl rule__Axis__Group__1 ;
    public final void rule__Axis__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1961:1: ( rule__Axis__Group__0__Impl rule__Axis__Group__1 )
            // InternalMachine.g:1962:2: rule__Axis__Group__0__Impl rule__Axis__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__Axis__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Axis__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group__0"


    // $ANTLR start "rule__Axis__Group__0__Impl"
    // InternalMachine.g:1969:1: rule__Axis__Group__0__Impl : ( () ) ;
    public final void rule__Axis__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1973:1: ( ( () ) )
            // InternalMachine.g:1974:1: ( () )
            {
            // InternalMachine.g:1974:1: ( () )
            // InternalMachine.g:1975:2: ()
            {
             before(grammarAccess.getAxisAccess().getAxisAction_0()); 
            // InternalMachine.g:1976:2: ()
            // InternalMachine.g:1976:3: 
            {
            }

             after(grammarAccess.getAxisAccess().getAxisAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group__0__Impl"


    // $ANTLR start "rule__Axis__Group__1"
    // InternalMachine.g:1984:1: rule__Axis__Group__1 : rule__Axis__Group__1__Impl rule__Axis__Group__2 ;
    public final void rule__Axis__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:1988:1: ( rule__Axis__Group__1__Impl rule__Axis__Group__2 )
            // InternalMachine.g:1989:2: rule__Axis__Group__1__Impl rule__Axis__Group__2
            {
            pushFollow(FOLLOW_17);
            rule__Axis__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Axis__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group__1"


    // $ANTLR start "rule__Axis__Group__1__Impl"
    // InternalMachine.g:1996:1: rule__Axis__Group__1__Impl : ( ( rule__Axis__NameAssignment_1 ) ) ;
    public final void rule__Axis__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2000:1: ( ( ( rule__Axis__NameAssignment_1 ) ) )
            // InternalMachine.g:2001:1: ( ( rule__Axis__NameAssignment_1 ) )
            {
            // InternalMachine.g:2001:1: ( ( rule__Axis__NameAssignment_1 ) )
            // InternalMachine.g:2002:2: ( rule__Axis__NameAssignment_1 )
            {
             before(grammarAccess.getAxisAccess().getNameAssignment_1()); 
            // InternalMachine.g:2003:2: ( rule__Axis__NameAssignment_1 )
            // InternalMachine.g:2003:3: rule__Axis__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Axis__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getAxisAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group__1__Impl"


    // $ANTLR start "rule__Axis__Group__2"
    // InternalMachine.g:2011:1: rule__Axis__Group__2 : rule__Axis__Group__2__Impl rule__Axis__Group__3 ;
    public final void rule__Axis__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2015:1: ( rule__Axis__Group__2__Impl rule__Axis__Group__3 )
            // InternalMachine.g:2016:2: rule__Axis__Group__2__Impl rule__Axis__Group__3
            {
            pushFollow(FOLLOW_17);
            rule__Axis__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Axis__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group__2"


    // $ANTLR start "rule__Axis__Group__2__Impl"
    // InternalMachine.g:2023:1: rule__Axis__Group__2__Impl : ( ( rule__Axis__Group_2__0 )? ) ;
    public final void rule__Axis__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2027:1: ( ( ( rule__Axis__Group_2__0 )? ) )
            // InternalMachine.g:2028:1: ( ( rule__Axis__Group_2__0 )? )
            {
            // InternalMachine.g:2028:1: ( ( rule__Axis__Group_2__0 )? )
            // InternalMachine.g:2029:2: ( rule__Axis__Group_2__0 )?
            {
             before(grammarAccess.getAxisAccess().getGroup_2()); 
            // InternalMachine.g:2030:2: ( rule__Axis__Group_2__0 )?
            int alt19=2;
            int LA19_0 = input.LA(1);

            if ( (LA19_0==21) ) {
                alt19=1;
            }
            switch (alt19) {
                case 1 :
                    // InternalMachine.g:2030:3: rule__Axis__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Axis__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getAxisAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group__2__Impl"


    // $ANTLR start "rule__Axis__Group__3"
    // InternalMachine.g:2038:1: rule__Axis__Group__3 : rule__Axis__Group__3__Impl ;
    public final void rule__Axis__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2042:1: ( rule__Axis__Group__3__Impl )
            // InternalMachine.g:2043:2: rule__Axis__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Axis__Group__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group__3"


    // $ANTLR start "rule__Axis__Group__3__Impl"
    // InternalMachine.g:2049:1: rule__Axis__Group__3__Impl : ( ( rule__Axis__Group_3__0 )? ) ;
    public final void rule__Axis__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2053:1: ( ( ( rule__Axis__Group_3__0 )? ) )
            // InternalMachine.g:2054:1: ( ( rule__Axis__Group_3__0 )? )
            {
            // InternalMachine.g:2054:1: ( ( rule__Axis__Group_3__0 )? )
            // InternalMachine.g:2055:2: ( rule__Axis__Group_3__0 )?
            {
             before(grammarAccess.getAxisAccess().getGroup_3()); 
            // InternalMachine.g:2056:2: ( rule__Axis__Group_3__0 )?
            int alt20=2;
            int LA20_0 = input.LA(1);

            if ( (LA20_0==23) ) {
                alt20=1;
            }
            switch (alt20) {
                case 1 :
                    // InternalMachine.g:2056:3: rule__Axis__Group_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Axis__Group_3__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getAxisAccess().getGroup_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group__3__Impl"


    // $ANTLR start "rule__Axis__Group_2__0"
    // InternalMachine.g:2065:1: rule__Axis__Group_2__0 : rule__Axis__Group_2__0__Impl rule__Axis__Group_2__1 ;
    public final void rule__Axis__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2069:1: ( rule__Axis__Group_2__0__Impl rule__Axis__Group_2__1 )
            // InternalMachine.g:2070:2: rule__Axis__Group_2__0__Impl rule__Axis__Group_2__1
            {
            pushFollow(FOLLOW_6);
            rule__Axis__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Axis__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_2__0"


    // $ANTLR start "rule__Axis__Group_2__0__Impl"
    // InternalMachine.g:2077:1: rule__Axis__Group_2__0__Impl : ( '[' ) ;
    public final void rule__Axis__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2081:1: ( ( '[' ) )
            // InternalMachine.g:2082:1: ( '[' )
            {
            // InternalMachine.g:2082:1: ( '[' )
            // InternalMachine.g:2083:2: '['
            {
             before(grammarAccess.getAxisAccess().getLeftSquareBracketKeyword_2_0()); 
            match(input,21,FOLLOW_2); 
             after(grammarAccess.getAxisAccess().getLeftSquareBracketKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_2__0__Impl"


    // $ANTLR start "rule__Axis__Group_2__1"
    // InternalMachine.g:2092:1: rule__Axis__Group_2__1 : rule__Axis__Group_2__1__Impl rule__Axis__Group_2__2 ;
    public final void rule__Axis__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2096:1: ( rule__Axis__Group_2__1__Impl rule__Axis__Group_2__2 )
            // InternalMachine.g:2097:2: rule__Axis__Group_2__1__Impl rule__Axis__Group_2__2
            {
            pushFollow(FOLLOW_16);
            rule__Axis__Group_2__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Axis__Group_2__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_2__1"


    // $ANTLR start "rule__Axis__Group_2__1__Impl"
    // InternalMachine.g:2104:1: rule__Axis__Group_2__1__Impl : ( ( rule__Axis__UnitAssignment_2_1 ) ) ;
    public final void rule__Axis__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2108:1: ( ( ( rule__Axis__UnitAssignment_2_1 ) ) )
            // InternalMachine.g:2109:1: ( ( rule__Axis__UnitAssignment_2_1 ) )
            {
            // InternalMachine.g:2109:1: ( ( rule__Axis__UnitAssignment_2_1 ) )
            // InternalMachine.g:2110:2: ( rule__Axis__UnitAssignment_2_1 )
            {
             before(grammarAccess.getAxisAccess().getUnitAssignment_2_1()); 
            // InternalMachine.g:2111:2: ( rule__Axis__UnitAssignment_2_1 )
            // InternalMachine.g:2111:3: rule__Axis__UnitAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__Axis__UnitAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getAxisAccess().getUnitAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_2__1__Impl"


    // $ANTLR start "rule__Axis__Group_2__2"
    // InternalMachine.g:2119:1: rule__Axis__Group_2__2 : rule__Axis__Group_2__2__Impl ;
    public final void rule__Axis__Group_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2123:1: ( rule__Axis__Group_2__2__Impl )
            // InternalMachine.g:2124:2: rule__Axis__Group_2__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Axis__Group_2__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_2__2"


    // $ANTLR start "rule__Axis__Group_2__2__Impl"
    // InternalMachine.g:2130:1: rule__Axis__Group_2__2__Impl : ( ']' ) ;
    public final void rule__Axis__Group_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2134:1: ( ( ']' ) )
            // InternalMachine.g:2135:1: ( ']' )
            {
            // InternalMachine.g:2135:1: ( ']' )
            // InternalMachine.g:2136:2: ']'
            {
             before(grammarAccess.getAxisAccess().getRightSquareBracketKeyword_2_2()); 
            match(input,22,FOLLOW_2); 
             after(grammarAccess.getAxisAccess().getRightSquareBracketKeyword_2_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_2__2__Impl"


    // $ANTLR start "rule__Axis__Group_3__0"
    // InternalMachine.g:2146:1: rule__Axis__Group_3__0 : rule__Axis__Group_3__0__Impl rule__Axis__Group_3__1 ;
    public final void rule__Axis__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2150:1: ( rule__Axis__Group_3__0__Impl rule__Axis__Group_3__1 )
            // InternalMachine.g:2151:2: rule__Axis__Group_3__0__Impl rule__Axis__Group_3__1
            {
            pushFollow(FOLLOW_6);
            rule__Axis__Group_3__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Axis__Group_3__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3__0"


    // $ANTLR start "rule__Axis__Group_3__0__Impl"
    // InternalMachine.g:2158:1: rule__Axis__Group_3__0__Impl : ( 'moves' ) ;
    public final void rule__Axis__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2162:1: ( ( 'moves' ) )
            // InternalMachine.g:2163:1: ( 'moves' )
            {
            // InternalMachine.g:2163:1: ( 'moves' )
            // InternalMachine.g:2164:2: 'moves'
            {
             before(grammarAccess.getAxisAccess().getMovesKeyword_3_0()); 
            match(input,23,FOLLOW_2); 
             after(grammarAccess.getAxisAccess().getMovesKeyword_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3__0__Impl"


    // $ANTLR start "rule__Axis__Group_3__1"
    // InternalMachine.g:2173:1: rule__Axis__Group_3__1 : rule__Axis__Group_3__1__Impl rule__Axis__Group_3__2 ;
    public final void rule__Axis__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2177:1: ( rule__Axis__Group_3__1__Impl rule__Axis__Group_3__2 )
            // InternalMachine.g:2178:2: rule__Axis__Group_3__1__Impl rule__Axis__Group_3__2
            {
            pushFollow(FOLLOW_18);
            rule__Axis__Group_3__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Axis__Group_3__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3__1"


    // $ANTLR start "rule__Axis__Group_3__1__Impl"
    // InternalMachine.g:2185:1: rule__Axis__Group_3__1__Impl : ( ( rule__Axis__SetPointsAssignment_3_1 ) ) ;
    public final void rule__Axis__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2189:1: ( ( ( rule__Axis__SetPointsAssignment_3_1 ) ) )
            // InternalMachine.g:2190:1: ( ( rule__Axis__SetPointsAssignment_3_1 ) )
            {
            // InternalMachine.g:2190:1: ( ( rule__Axis__SetPointsAssignment_3_1 ) )
            // InternalMachine.g:2191:2: ( rule__Axis__SetPointsAssignment_3_1 )
            {
             before(grammarAccess.getAxisAccess().getSetPointsAssignment_3_1()); 
            // InternalMachine.g:2192:2: ( rule__Axis__SetPointsAssignment_3_1 )
            // InternalMachine.g:2192:3: rule__Axis__SetPointsAssignment_3_1
            {
            pushFollow(FOLLOW_2);
            rule__Axis__SetPointsAssignment_3_1();

            state._fsp--;


            }

             after(grammarAccess.getAxisAccess().getSetPointsAssignment_3_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3__1__Impl"


    // $ANTLR start "rule__Axis__Group_3__2"
    // InternalMachine.g:2200:1: rule__Axis__Group_3__2 : rule__Axis__Group_3__2__Impl ;
    public final void rule__Axis__Group_3__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2204:1: ( rule__Axis__Group_3__2__Impl )
            // InternalMachine.g:2205:2: rule__Axis__Group_3__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Axis__Group_3__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3__2"


    // $ANTLR start "rule__Axis__Group_3__2__Impl"
    // InternalMachine.g:2211:1: rule__Axis__Group_3__2__Impl : ( ( rule__Axis__Group_3_2__0 )* ) ;
    public final void rule__Axis__Group_3__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2215:1: ( ( ( rule__Axis__Group_3_2__0 )* ) )
            // InternalMachine.g:2216:1: ( ( rule__Axis__Group_3_2__0 )* )
            {
            // InternalMachine.g:2216:1: ( ( rule__Axis__Group_3_2__0 )* )
            // InternalMachine.g:2217:2: ( rule__Axis__Group_3_2__0 )*
            {
             before(grammarAccess.getAxisAccess().getGroup_3_2()); 
            // InternalMachine.g:2218:2: ( rule__Axis__Group_3_2__0 )*
            loop21:
            do {
                int alt21=2;
                int LA21_0 = input.LA(1);

                if ( (LA21_0==24) ) {
                    alt21=1;
                }


                switch (alt21) {
            	case 1 :
            	    // InternalMachine.g:2218:3: rule__Axis__Group_3_2__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__Axis__Group_3_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop21;
                }
            } while (true);

             after(grammarAccess.getAxisAccess().getGroup_3_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3__2__Impl"


    // $ANTLR start "rule__Axis__Group_3_2__0"
    // InternalMachine.g:2227:1: rule__Axis__Group_3_2__0 : rule__Axis__Group_3_2__0__Impl rule__Axis__Group_3_2__1 ;
    public final void rule__Axis__Group_3_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2231:1: ( rule__Axis__Group_3_2__0__Impl rule__Axis__Group_3_2__1 )
            // InternalMachine.g:2232:2: rule__Axis__Group_3_2__0__Impl rule__Axis__Group_3_2__1
            {
            pushFollow(FOLLOW_6);
            rule__Axis__Group_3_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Axis__Group_3_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3_2__0"


    // $ANTLR start "rule__Axis__Group_3_2__0__Impl"
    // InternalMachine.g:2239:1: rule__Axis__Group_3_2__0__Impl : ( ',' ) ;
    public final void rule__Axis__Group_3_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2243:1: ( ( ',' ) )
            // InternalMachine.g:2244:1: ( ',' )
            {
            // InternalMachine.g:2244:1: ( ',' )
            // InternalMachine.g:2245:2: ','
            {
             before(grammarAccess.getAxisAccess().getCommaKeyword_3_2_0()); 
            match(input,24,FOLLOW_2); 
             after(grammarAccess.getAxisAccess().getCommaKeyword_3_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3_2__0__Impl"


    // $ANTLR start "rule__Axis__Group_3_2__1"
    // InternalMachine.g:2254:1: rule__Axis__Group_3_2__1 : rule__Axis__Group_3_2__1__Impl ;
    public final void rule__Axis__Group_3_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2258:1: ( rule__Axis__Group_3_2__1__Impl )
            // InternalMachine.g:2259:2: rule__Axis__Group_3_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Axis__Group_3_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3_2__1"


    // $ANTLR start "rule__Axis__Group_3_2__1__Impl"
    // InternalMachine.g:2265:1: rule__Axis__Group_3_2__1__Impl : ( ( rule__Axis__SetPointsAssignment_3_2_1 ) ) ;
    public final void rule__Axis__Group_3_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2269:1: ( ( ( rule__Axis__SetPointsAssignment_3_2_1 ) ) )
            // InternalMachine.g:2270:1: ( ( rule__Axis__SetPointsAssignment_3_2_1 ) )
            {
            // InternalMachine.g:2270:1: ( ( rule__Axis__SetPointsAssignment_3_2_1 ) )
            // InternalMachine.g:2271:2: ( rule__Axis__SetPointsAssignment_3_2_1 )
            {
             before(grammarAccess.getAxisAccess().getSetPointsAssignment_3_2_1()); 
            // InternalMachine.g:2272:2: ( rule__Axis__SetPointsAssignment_3_2_1 )
            // InternalMachine.g:2272:3: rule__Axis__SetPointsAssignment_3_2_1
            {
            pushFollow(FOLLOW_2);
            rule__Axis__SetPointsAssignment_3_2_1();

            state._fsp--;


            }

             after(grammarAccess.getAxisAccess().getSetPointsAssignment_3_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__Group_3_2__1__Impl"


    // $ANTLR start "rule__ResourceItem__Group__0"
    // InternalMachine.g:2281:1: rule__ResourceItem__Group__0 : rule__ResourceItem__Group__0__Impl rule__ResourceItem__Group__1 ;
    public final void rule__ResourceItem__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2285:1: ( rule__ResourceItem__Group__0__Impl rule__ResourceItem__Group__1 )
            // InternalMachine.g:2286:2: rule__ResourceItem__Group__0__Impl rule__ResourceItem__Group__1
            {
            pushFollow(FOLLOW_20);
            rule__ResourceItem__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__ResourceItem__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ResourceItem__Group__0"


    // $ANTLR start "rule__ResourceItem__Group__0__Impl"
    // InternalMachine.g:2293:1: rule__ResourceItem__Group__0__Impl : ( () ) ;
    public final void rule__ResourceItem__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2297:1: ( ( () ) )
            // InternalMachine.g:2298:1: ( () )
            {
            // InternalMachine.g:2298:1: ( () )
            // InternalMachine.g:2299:2: ()
            {
             before(grammarAccess.getResourceItemAccess().getResourceItemAction_0()); 
            // InternalMachine.g:2300:2: ()
            // InternalMachine.g:2300:3: 
            {
            }

             after(grammarAccess.getResourceItemAccess().getResourceItemAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ResourceItem__Group__0__Impl"


    // $ANTLR start "rule__ResourceItem__Group__1"
    // InternalMachine.g:2308:1: rule__ResourceItem__Group__1 : rule__ResourceItem__Group__1__Impl ;
    public final void rule__ResourceItem__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2312:1: ( rule__ResourceItem__Group__1__Impl )
            // InternalMachine.g:2313:2: rule__ResourceItem__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__ResourceItem__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ResourceItem__Group__1"


    // $ANTLR start "rule__ResourceItem__Group__1__Impl"
    // InternalMachine.g:2319:1: rule__ResourceItem__Group__1__Impl : ( ( rule__ResourceItem__NameAssignment_1 ) ) ;
    public final void rule__ResourceItem__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2323:1: ( ( ( rule__ResourceItem__NameAssignment_1 ) ) )
            // InternalMachine.g:2324:1: ( ( rule__ResourceItem__NameAssignment_1 ) )
            {
            // InternalMachine.g:2324:1: ( ( rule__ResourceItem__NameAssignment_1 ) )
            // InternalMachine.g:2325:2: ( rule__ResourceItem__NameAssignment_1 )
            {
             before(grammarAccess.getResourceItemAccess().getNameAssignment_1()); 
            // InternalMachine.g:2326:2: ( rule__ResourceItem__NameAssignment_1 )
            // InternalMachine.g:2326:3: rule__ResourceItem__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__ResourceItem__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getResourceItemAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ResourceItem__Group__1__Impl"


    // $ANTLR start "rule__Resource__Group__0"
    // InternalMachine.g:2335:1: rule__Resource__Group__0 : rule__Resource__Group__0__Impl rule__Resource__Group__1 ;
    public final void rule__Resource__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2339:1: ( rule__Resource__Group__0__Impl rule__Resource__Group__1 )
            // InternalMachine.g:2340:2: rule__Resource__Group__0__Impl rule__Resource__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__Resource__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Resource__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__0"


    // $ANTLR start "rule__Resource__Group__0__Impl"
    // InternalMachine.g:2347:1: rule__Resource__Group__0__Impl : ( 'Resource' ) ;
    public final void rule__Resource__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2351:1: ( ( 'Resource' ) )
            // InternalMachine.g:2352:1: ( 'Resource' )
            {
            // InternalMachine.g:2352:1: ( 'Resource' )
            // InternalMachine.g:2353:2: 'Resource'
            {
             before(grammarAccess.getResourceAccess().getResourceKeyword_0()); 
            match(input,25,FOLLOW_2); 
             after(grammarAccess.getResourceAccess().getResourceKeyword_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__0__Impl"


    // $ANTLR start "rule__Resource__Group__1"
    // InternalMachine.g:2362:1: rule__Resource__Group__1 : rule__Resource__Group__1__Impl rule__Resource__Group__2 ;
    public final void rule__Resource__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2366:1: ( rule__Resource__Group__1__Impl rule__Resource__Group__2 )
            // InternalMachine.g:2367:2: rule__Resource__Group__1__Impl rule__Resource__Group__2
            {
            pushFollow(FOLLOW_21);
            rule__Resource__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Resource__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__1"


    // $ANTLR start "rule__Resource__Group__1__Impl"
    // InternalMachine.g:2374:1: rule__Resource__Group__1__Impl : ( ( rule__Resource__NameAssignment_1 ) ) ;
    public final void rule__Resource__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2378:1: ( ( ( rule__Resource__NameAssignment_1 ) ) )
            // InternalMachine.g:2379:1: ( ( rule__Resource__NameAssignment_1 ) )
            {
            // InternalMachine.g:2379:1: ( ( rule__Resource__NameAssignment_1 ) )
            // InternalMachine.g:2380:2: ( rule__Resource__NameAssignment_1 )
            {
             before(grammarAccess.getResourceAccess().getNameAssignment_1()); 
            // InternalMachine.g:2381:2: ( rule__Resource__NameAssignment_1 )
            // InternalMachine.g:2381:3: rule__Resource__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Resource__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getResourceAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__1__Impl"


    // $ANTLR start "rule__Resource__Group__2"
    // InternalMachine.g:2389:1: rule__Resource__Group__2 : rule__Resource__Group__2__Impl rule__Resource__Group__3 ;
    public final void rule__Resource__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2393:1: ( rule__Resource__Group__2__Impl rule__Resource__Group__3 )
            // InternalMachine.g:2394:2: rule__Resource__Group__2__Impl rule__Resource__Group__3
            {
            pushFollow(FOLLOW_21);
            rule__Resource__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Resource__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__2"


    // $ANTLR start "rule__Resource__Group__2__Impl"
    // InternalMachine.g:2401:1: rule__Resource__Group__2__Impl : ( ( rule__Resource__Group_2__0 )? ) ;
    public final void rule__Resource__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2405:1: ( ( ( rule__Resource__Group_2__0 )? ) )
            // InternalMachine.g:2406:1: ( ( rule__Resource__Group_2__0 )? )
            {
            // InternalMachine.g:2406:1: ( ( rule__Resource__Group_2__0 )? )
            // InternalMachine.g:2407:2: ( rule__Resource__Group_2__0 )?
            {
             before(grammarAccess.getResourceAccess().getGroup_2()); 
            // InternalMachine.g:2408:2: ( rule__Resource__Group_2__0 )?
            int alt22=2;
            int LA22_0 = input.LA(1);

            if ( (LA22_0==26) ) {
                alt22=1;
            }
            switch (alt22) {
                case 1 :
                    // InternalMachine.g:2408:3: rule__Resource__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Resource__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getResourceAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__2__Impl"


    // $ANTLR start "rule__Resource__Group__3"
    // InternalMachine.g:2416:1: rule__Resource__Group__3 : rule__Resource__Group__3__Impl rule__Resource__Group__4 ;
    public final void rule__Resource__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2420:1: ( rule__Resource__Group__3__Impl rule__Resource__Group__4 )
            // InternalMachine.g:2421:2: rule__Resource__Group__3__Impl rule__Resource__Group__4
            {
            pushFollow(FOLLOW_8);
            rule__Resource__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Resource__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__3"


    // $ANTLR start "rule__Resource__Group__3__Impl"
    // InternalMachine.g:2428:1: rule__Resource__Group__3__Impl : ( '{' ) ;
    public final void rule__Resource__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2432:1: ( ( '{' ) )
            // InternalMachine.g:2433:1: ( '{' )
            {
            // InternalMachine.g:2433:1: ( '{' )
            // InternalMachine.g:2434:2: '{'
            {
             before(grammarAccess.getResourceAccess().getLeftCurlyBracketKeyword_3()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getResourceAccess().getLeftCurlyBracketKeyword_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__3__Impl"


    // $ANTLR start "rule__Resource__Group__4"
    // InternalMachine.g:2443:1: rule__Resource__Group__4 : rule__Resource__Group__4__Impl rule__Resource__Group__5 ;
    public final void rule__Resource__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2447:1: ( rule__Resource__Group__4__Impl rule__Resource__Group__5 )
            // InternalMachine.g:2448:2: rule__Resource__Group__4__Impl rule__Resource__Group__5
            {
            pushFollow(FOLLOW_8);
            rule__Resource__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Resource__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__4"


    // $ANTLR start "rule__Resource__Group__4__Impl"
    // InternalMachine.g:2455:1: rule__Resource__Group__4__Impl : ( ( rule__Resource__PeripheralsAssignment_4 )* ) ;
    public final void rule__Resource__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2459:1: ( ( ( rule__Resource__PeripheralsAssignment_4 )* ) )
            // InternalMachine.g:2460:1: ( ( rule__Resource__PeripheralsAssignment_4 )* )
            {
            // InternalMachine.g:2460:1: ( ( rule__Resource__PeripheralsAssignment_4 )* )
            // InternalMachine.g:2461:2: ( rule__Resource__PeripheralsAssignment_4 )*
            {
             before(grammarAccess.getResourceAccess().getPeripheralsAssignment_4()); 
            // InternalMachine.g:2462:2: ( rule__Resource__PeripheralsAssignment_4 )*
            loop23:
            do {
                int alt23=2;
                int LA23_0 = input.LA(1);

                if ( (LA23_0==RULE_ID) ) {
                    alt23=1;
                }


                switch (alt23) {
            	case 1 :
            	    // InternalMachine.g:2462:3: rule__Resource__PeripheralsAssignment_4
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__Resource__PeripheralsAssignment_4();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop23;
                }
            } while (true);

             after(grammarAccess.getResourceAccess().getPeripheralsAssignment_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__4__Impl"


    // $ANTLR start "rule__Resource__Group__5"
    // InternalMachine.g:2470:1: rule__Resource__Group__5 : rule__Resource__Group__5__Impl ;
    public final void rule__Resource__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2474:1: ( rule__Resource__Group__5__Impl )
            // InternalMachine.g:2475:2: rule__Resource__Group__5__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Resource__Group__5__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__5"


    // $ANTLR start "rule__Resource__Group__5__Impl"
    // InternalMachine.g:2481:1: rule__Resource__Group__5__Impl : ( '}' ) ;
    public final void rule__Resource__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2485:1: ( ( '}' ) )
            // InternalMachine.g:2486:1: ( '}' )
            {
            // InternalMachine.g:2486:1: ( '}' )
            // InternalMachine.g:2487:2: '}'
            {
             before(grammarAccess.getResourceAccess().getRightCurlyBracketKeyword_5()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getResourceAccess().getRightCurlyBracketKeyword_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group__5__Impl"


    // $ANTLR start "rule__Resource__Group_2__0"
    // InternalMachine.g:2497:1: rule__Resource__Group_2__0 : rule__Resource__Group_2__0__Impl rule__Resource__Group_2__1 ;
    public final void rule__Resource__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2501:1: ( rule__Resource__Group_2__0__Impl rule__Resource__Group_2__1 )
            // InternalMachine.g:2502:2: rule__Resource__Group_2__0__Impl rule__Resource__Group_2__1
            {
            pushFollow(FOLLOW_20);
            rule__Resource__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Resource__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2__0"


    // $ANTLR start "rule__Resource__Group_2__0__Impl"
    // InternalMachine.g:2509:1: rule__Resource__Group_2__0__Impl : ( '(' ) ;
    public final void rule__Resource__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2513:1: ( ( '(' ) )
            // InternalMachine.g:2514:1: ( '(' )
            {
            // InternalMachine.g:2514:1: ( '(' )
            // InternalMachine.g:2515:2: '('
            {
             before(grammarAccess.getResourceAccess().getLeftParenthesisKeyword_2_0()); 
            match(input,26,FOLLOW_2); 
             after(grammarAccess.getResourceAccess().getLeftParenthesisKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2__0__Impl"


    // $ANTLR start "rule__Resource__Group_2__1"
    // InternalMachine.g:2524:1: rule__Resource__Group_2__1 : rule__Resource__Group_2__1__Impl rule__Resource__Group_2__2 ;
    public final void rule__Resource__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2528:1: ( rule__Resource__Group_2__1__Impl rule__Resource__Group_2__2 )
            // InternalMachine.g:2529:2: rule__Resource__Group_2__1__Impl rule__Resource__Group_2__2
            {
            pushFollow(FOLLOW_22);
            rule__Resource__Group_2__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Resource__Group_2__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2__1"


    // $ANTLR start "rule__Resource__Group_2__1__Impl"
    // InternalMachine.g:2536:1: rule__Resource__Group_2__1__Impl : ( ( rule__Resource__ItemsAssignment_2_1 ) ) ;
    public final void rule__Resource__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2540:1: ( ( ( rule__Resource__ItemsAssignment_2_1 ) ) )
            // InternalMachine.g:2541:1: ( ( rule__Resource__ItemsAssignment_2_1 ) )
            {
            // InternalMachine.g:2541:1: ( ( rule__Resource__ItemsAssignment_2_1 ) )
            // InternalMachine.g:2542:2: ( rule__Resource__ItemsAssignment_2_1 )
            {
             before(grammarAccess.getResourceAccess().getItemsAssignment_2_1()); 
            // InternalMachine.g:2543:2: ( rule__Resource__ItemsAssignment_2_1 )
            // InternalMachine.g:2543:3: rule__Resource__ItemsAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__Resource__ItemsAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getResourceAccess().getItemsAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2__1__Impl"


    // $ANTLR start "rule__Resource__Group_2__2"
    // InternalMachine.g:2551:1: rule__Resource__Group_2__2 : rule__Resource__Group_2__2__Impl rule__Resource__Group_2__3 ;
    public final void rule__Resource__Group_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2555:1: ( rule__Resource__Group_2__2__Impl rule__Resource__Group_2__3 )
            // InternalMachine.g:2556:2: rule__Resource__Group_2__2__Impl rule__Resource__Group_2__3
            {
            pushFollow(FOLLOW_22);
            rule__Resource__Group_2__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Resource__Group_2__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2__2"


    // $ANTLR start "rule__Resource__Group_2__2__Impl"
    // InternalMachine.g:2563:1: rule__Resource__Group_2__2__Impl : ( ( rule__Resource__Group_2_2__0 )* ) ;
    public final void rule__Resource__Group_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2567:1: ( ( ( rule__Resource__Group_2_2__0 )* ) )
            // InternalMachine.g:2568:1: ( ( rule__Resource__Group_2_2__0 )* )
            {
            // InternalMachine.g:2568:1: ( ( rule__Resource__Group_2_2__0 )* )
            // InternalMachine.g:2569:2: ( rule__Resource__Group_2_2__0 )*
            {
             before(grammarAccess.getResourceAccess().getGroup_2_2()); 
            // InternalMachine.g:2570:2: ( rule__Resource__Group_2_2__0 )*
            loop24:
            do {
                int alt24=2;
                int LA24_0 = input.LA(1);

                if ( (LA24_0==24) ) {
                    alt24=1;
                }


                switch (alt24) {
            	case 1 :
            	    // InternalMachine.g:2570:3: rule__Resource__Group_2_2__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__Resource__Group_2_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop24;
                }
            } while (true);

             after(grammarAccess.getResourceAccess().getGroup_2_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2__2__Impl"


    // $ANTLR start "rule__Resource__Group_2__3"
    // InternalMachine.g:2578:1: rule__Resource__Group_2__3 : rule__Resource__Group_2__3__Impl ;
    public final void rule__Resource__Group_2__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2582:1: ( rule__Resource__Group_2__3__Impl )
            // InternalMachine.g:2583:2: rule__Resource__Group_2__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Resource__Group_2__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2__3"


    // $ANTLR start "rule__Resource__Group_2__3__Impl"
    // InternalMachine.g:2589:1: rule__Resource__Group_2__3__Impl : ( ')' ) ;
    public final void rule__Resource__Group_2__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2593:1: ( ( ')' ) )
            // InternalMachine.g:2594:1: ( ')' )
            {
            // InternalMachine.g:2594:1: ( ')' )
            // InternalMachine.g:2595:2: ')'
            {
             before(grammarAccess.getResourceAccess().getRightParenthesisKeyword_2_3()); 
            match(input,27,FOLLOW_2); 
             after(grammarAccess.getResourceAccess().getRightParenthesisKeyword_2_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2__3__Impl"


    // $ANTLR start "rule__Resource__Group_2_2__0"
    // InternalMachine.g:2605:1: rule__Resource__Group_2_2__0 : rule__Resource__Group_2_2__0__Impl rule__Resource__Group_2_2__1 ;
    public final void rule__Resource__Group_2_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2609:1: ( rule__Resource__Group_2_2__0__Impl rule__Resource__Group_2_2__1 )
            // InternalMachine.g:2610:2: rule__Resource__Group_2_2__0__Impl rule__Resource__Group_2_2__1
            {
            pushFollow(FOLLOW_20);
            rule__Resource__Group_2_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Resource__Group_2_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2_2__0"


    // $ANTLR start "rule__Resource__Group_2_2__0__Impl"
    // InternalMachine.g:2617:1: rule__Resource__Group_2_2__0__Impl : ( ',' ) ;
    public final void rule__Resource__Group_2_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2621:1: ( ( ',' ) )
            // InternalMachine.g:2622:1: ( ',' )
            {
            // InternalMachine.g:2622:1: ( ',' )
            // InternalMachine.g:2623:2: ','
            {
             before(grammarAccess.getResourceAccess().getCommaKeyword_2_2_0()); 
            match(input,24,FOLLOW_2); 
             after(grammarAccess.getResourceAccess().getCommaKeyword_2_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2_2__0__Impl"


    // $ANTLR start "rule__Resource__Group_2_2__1"
    // InternalMachine.g:2632:1: rule__Resource__Group_2_2__1 : rule__Resource__Group_2_2__1__Impl ;
    public final void rule__Resource__Group_2_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2636:1: ( rule__Resource__Group_2_2__1__Impl )
            // InternalMachine.g:2637:2: rule__Resource__Group_2_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Resource__Group_2_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2_2__1"


    // $ANTLR start "rule__Resource__Group_2_2__1__Impl"
    // InternalMachine.g:2643:1: rule__Resource__Group_2_2__1__Impl : ( ( rule__Resource__ItemsAssignment_2_2_1 ) ) ;
    public final void rule__Resource__Group_2_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2647:1: ( ( ( rule__Resource__ItemsAssignment_2_2_1 ) ) )
            // InternalMachine.g:2648:1: ( ( rule__Resource__ItemsAssignment_2_2_1 ) )
            {
            // InternalMachine.g:2648:1: ( ( rule__Resource__ItemsAssignment_2_2_1 ) )
            // InternalMachine.g:2649:2: ( rule__Resource__ItemsAssignment_2_2_1 )
            {
             before(grammarAccess.getResourceAccess().getItemsAssignment_2_2_1()); 
            // InternalMachine.g:2650:2: ( rule__Resource__ItemsAssignment_2_2_1 )
            // InternalMachine.g:2650:3: rule__Resource__ItemsAssignment_2_2_1
            {
            pushFollow(FOLLOW_2);
            rule__Resource__ItemsAssignment_2_2_1();

            state._fsp--;


            }

             after(grammarAccess.getResourceAccess().getItemsAssignment_2_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__Group_2_2__1__Impl"


    // $ANTLR start "rule__Peripheral__Group__0"
    // InternalMachine.g:2659:1: rule__Peripheral__Group__0 : rule__Peripheral__Group__0__Impl rule__Peripheral__Group__1 ;
    public final void rule__Peripheral__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2663:1: ( rule__Peripheral__Group__0__Impl rule__Peripheral__Group__1 )
            // InternalMachine.g:2664:2: rule__Peripheral__Group__0__Impl rule__Peripheral__Group__1
            {
            pushFollow(FOLLOW_23);
            rule__Peripheral__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group__0"


    // $ANTLR start "rule__Peripheral__Group__0__Impl"
    // InternalMachine.g:2671:1: rule__Peripheral__Group__0__Impl : ( ( rule__Peripheral__NameAssignment_0 ) ) ;
    public final void rule__Peripheral__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2675:1: ( ( ( rule__Peripheral__NameAssignment_0 ) ) )
            // InternalMachine.g:2676:1: ( ( rule__Peripheral__NameAssignment_0 ) )
            {
            // InternalMachine.g:2676:1: ( ( rule__Peripheral__NameAssignment_0 ) )
            // InternalMachine.g:2677:2: ( rule__Peripheral__NameAssignment_0 )
            {
             before(grammarAccess.getPeripheralAccess().getNameAssignment_0()); 
            // InternalMachine.g:2678:2: ( rule__Peripheral__NameAssignment_0 )
            // InternalMachine.g:2678:3: rule__Peripheral__NameAssignment_0
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__NameAssignment_0();

            state._fsp--;


            }

             after(grammarAccess.getPeripheralAccess().getNameAssignment_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group__0__Impl"


    // $ANTLR start "rule__Peripheral__Group__1"
    // InternalMachine.g:2686:1: rule__Peripheral__Group__1 : rule__Peripheral__Group__1__Impl rule__Peripheral__Group__2 ;
    public final void rule__Peripheral__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2690:1: ( rule__Peripheral__Group__1__Impl rule__Peripheral__Group__2 )
            // InternalMachine.g:2691:2: rule__Peripheral__Group__1__Impl rule__Peripheral__Group__2
            {
            pushFollow(FOLLOW_6);
            rule__Peripheral__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group__1"


    // $ANTLR start "rule__Peripheral__Group__1__Impl"
    // InternalMachine.g:2698:1: rule__Peripheral__Group__1__Impl : ( ':' ) ;
    public final void rule__Peripheral__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2702:1: ( ( ':' ) )
            // InternalMachine.g:2703:1: ( ':' )
            {
            // InternalMachine.g:2703:1: ( ':' )
            // InternalMachine.g:2704:2: ':'
            {
             before(grammarAccess.getPeripheralAccess().getColonKeyword_1()); 
            match(input,28,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getColonKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group__1__Impl"


    // $ANTLR start "rule__Peripheral__Group__2"
    // InternalMachine.g:2713:1: rule__Peripheral__Group__2 : rule__Peripheral__Group__2__Impl rule__Peripheral__Group__3 ;
    public final void rule__Peripheral__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2717:1: ( rule__Peripheral__Group__2__Impl rule__Peripheral__Group__3 )
            // InternalMachine.g:2718:2: rule__Peripheral__Group__2__Impl rule__Peripheral__Group__3
            {
            pushFollow(FOLLOW_7);
            rule__Peripheral__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group__2"


    // $ANTLR start "rule__Peripheral__Group__2__Impl"
    // InternalMachine.g:2725:1: rule__Peripheral__Group__2__Impl : ( ( rule__Peripheral__TypeAssignment_2 ) ) ;
    public final void rule__Peripheral__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2729:1: ( ( ( rule__Peripheral__TypeAssignment_2 ) ) )
            // InternalMachine.g:2730:1: ( ( rule__Peripheral__TypeAssignment_2 ) )
            {
            // InternalMachine.g:2730:1: ( ( rule__Peripheral__TypeAssignment_2 ) )
            // InternalMachine.g:2731:2: ( rule__Peripheral__TypeAssignment_2 )
            {
             before(grammarAccess.getPeripheralAccess().getTypeAssignment_2()); 
            // InternalMachine.g:2732:2: ( rule__Peripheral__TypeAssignment_2 )
            // InternalMachine.g:2732:3: rule__Peripheral__TypeAssignment_2
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__TypeAssignment_2();

            state._fsp--;


            }

             after(grammarAccess.getPeripheralAccess().getTypeAssignment_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group__2__Impl"


    // $ANTLR start "rule__Peripheral__Group__3"
    // InternalMachine.g:2740:1: rule__Peripheral__Group__3 : rule__Peripheral__Group__3__Impl ;
    public final void rule__Peripheral__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2744:1: ( rule__Peripheral__Group__3__Impl )
            // InternalMachine.g:2745:2: rule__Peripheral__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__Group__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group__3"


    // $ANTLR start "rule__Peripheral__Group__3__Impl"
    // InternalMachine.g:2751:1: rule__Peripheral__Group__3__Impl : ( ( rule__Peripheral__Group_3__0 )? ) ;
    public final void rule__Peripheral__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2755:1: ( ( ( rule__Peripheral__Group_3__0 )? ) )
            // InternalMachine.g:2756:1: ( ( rule__Peripheral__Group_3__0 )? )
            {
            // InternalMachine.g:2756:1: ( ( rule__Peripheral__Group_3__0 )? )
            // InternalMachine.g:2757:2: ( rule__Peripheral__Group_3__0 )?
            {
             before(grammarAccess.getPeripheralAccess().getGroup_3()); 
            // InternalMachine.g:2758:2: ( rule__Peripheral__Group_3__0 )?
            int alt25=2;
            int LA25_0 = input.LA(1);

            if ( (LA25_0==13) ) {
                alt25=1;
            }
            switch (alt25) {
                case 1 :
                    // InternalMachine.g:2758:3: rule__Peripheral__Group_3__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Peripheral__Group_3__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPeripheralAccess().getGroup_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group__3__Impl"


    // $ANTLR start "rule__Peripheral__Group_3__0"
    // InternalMachine.g:2767:1: rule__Peripheral__Group_3__0 : rule__Peripheral__Group_3__0__Impl rule__Peripheral__Group_3__1 ;
    public final void rule__Peripheral__Group_3__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2771:1: ( rule__Peripheral__Group_3__0__Impl rule__Peripheral__Group_3__1 )
            // InternalMachine.g:2772:2: rule__Peripheral__Group_3__0__Impl rule__Peripheral__Group_3__1
            {
            pushFollow(FOLLOW_24);
            rule__Peripheral__Group_3__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3__0"


    // $ANTLR start "rule__Peripheral__Group_3__0__Impl"
    // InternalMachine.g:2779:1: rule__Peripheral__Group_3__0__Impl : ( '{' ) ;
    public final void rule__Peripheral__Group_3__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2783:1: ( ( '{' ) )
            // InternalMachine.g:2784:1: ( '{' )
            {
            // InternalMachine.g:2784:1: ( '{' )
            // InternalMachine.g:2785:2: '{'
            {
             before(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_0()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3__0__Impl"


    // $ANTLR start "rule__Peripheral__Group_3__1"
    // InternalMachine.g:2794:1: rule__Peripheral__Group_3__1 : rule__Peripheral__Group_3__1__Impl rule__Peripheral__Group_3__2 ;
    public final void rule__Peripheral__Group_3__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2798:1: ( rule__Peripheral__Group_3__1__Impl rule__Peripheral__Group_3__2 )
            // InternalMachine.g:2799:2: rule__Peripheral__Group_3__1__Impl rule__Peripheral__Group_3__2
            {
            pushFollow(FOLLOW_24);
            rule__Peripheral__Group_3__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3__1"


    // $ANTLR start "rule__Peripheral__Group_3__1__Impl"
    // InternalMachine.g:2806:1: rule__Peripheral__Group_3__1__Impl : ( ( rule__Peripheral__Group_3_1__0 )? ) ;
    public final void rule__Peripheral__Group_3__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2810:1: ( ( ( rule__Peripheral__Group_3_1__0 )? ) )
            // InternalMachine.g:2811:1: ( ( rule__Peripheral__Group_3_1__0 )? )
            {
            // InternalMachine.g:2811:1: ( ( rule__Peripheral__Group_3_1__0 )? )
            // InternalMachine.g:2812:2: ( rule__Peripheral__Group_3_1__0 )?
            {
             before(grammarAccess.getPeripheralAccess().getGroup_3_1()); 
            // InternalMachine.g:2813:2: ( rule__Peripheral__Group_3_1__0 )?
            int alt26=2;
            int LA26_0 = input.LA(1);

            if ( ((LA26_0>=29 && LA26_0<=31)) ) {
                alt26=1;
            }
            switch (alt26) {
                case 1 :
                    // InternalMachine.g:2813:3: rule__Peripheral__Group_3_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Peripheral__Group_3_1__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPeripheralAccess().getGroup_3_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3__1__Impl"


    // $ANTLR start "rule__Peripheral__Group_3__2"
    // InternalMachine.g:2821:1: rule__Peripheral__Group_3__2 : rule__Peripheral__Group_3__2__Impl ;
    public final void rule__Peripheral__Group_3__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2825:1: ( rule__Peripheral__Group_3__2__Impl )
            // InternalMachine.g:2826:2: rule__Peripheral__Group_3__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3__2"


    // $ANTLR start "rule__Peripheral__Group_3__2__Impl"
    // InternalMachine.g:2832:1: rule__Peripheral__Group_3__2__Impl : ( '}' ) ;
    public final void rule__Peripheral__Group_3__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2836:1: ( ( '}' ) )
            // InternalMachine.g:2837:1: ( '}' )
            {
            // InternalMachine.g:2837:1: ( '}' )
            // InternalMachine.g:2838:2: '}'
            {
             before(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_2()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3__2__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1__0"
    // InternalMachine.g:2848:1: rule__Peripheral__Group_3_1__0 : rule__Peripheral__Group_3_1__0__Impl rule__Peripheral__Group_3_1__1 ;
    public final void rule__Peripheral__Group_3_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2852:1: ( rule__Peripheral__Group_3_1__0__Impl rule__Peripheral__Group_3_1__1 )
            // InternalMachine.g:2853:2: rule__Peripheral__Group_3_1__0__Impl rule__Peripheral__Group_3_1__1
            {
            pushFollow(FOLLOW_25);
            rule__Peripheral__Group_3_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__0"


    // $ANTLR start "rule__Peripheral__Group_3_1__0__Impl"
    // InternalMachine.g:2860:1: rule__Peripheral__Group_3_1__0__Impl : ( ( rule__Peripheral__Group_3_1_0__0 )? ) ;
    public final void rule__Peripheral__Group_3_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2864:1: ( ( ( rule__Peripheral__Group_3_1_0__0 )? ) )
            // InternalMachine.g:2865:1: ( ( rule__Peripheral__Group_3_1_0__0 )? )
            {
            // InternalMachine.g:2865:1: ( ( rule__Peripheral__Group_3_1_0__0 )? )
            // InternalMachine.g:2866:2: ( rule__Peripheral__Group_3_1_0__0 )?
            {
             before(grammarAccess.getPeripheralAccess().getGroup_3_1_0()); 
            // InternalMachine.g:2867:2: ( rule__Peripheral__Group_3_1_0__0 )?
            int alt27=2;
            int LA27_0 = input.LA(1);

            if ( (LA27_0==30) ) {
                alt27=1;
            }
            switch (alt27) {
                case 1 :
                    // InternalMachine.g:2867:3: rule__Peripheral__Group_3_1_0__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Peripheral__Group_3_1_0__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPeripheralAccess().getGroup_3_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__0__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1__1"
    // InternalMachine.g:2875:1: rule__Peripheral__Group_3_1__1 : rule__Peripheral__Group_3_1__1__Impl rule__Peripheral__Group_3_1__2 ;
    public final void rule__Peripheral__Group_3_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2879:1: ( rule__Peripheral__Group_3_1__1__Impl rule__Peripheral__Group_3_1__2 )
            // InternalMachine.g:2880:2: rule__Peripheral__Group_3_1__1__Impl rule__Peripheral__Group_3_1__2
            {
            pushFollow(FOLLOW_25);
            rule__Peripheral__Group_3_1__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__1"


    // $ANTLR start "rule__Peripheral__Group_3_1__1__Impl"
    // InternalMachine.g:2887:1: rule__Peripheral__Group_3_1__1__Impl : ( ( rule__Peripheral__Group_3_1_1__0 )? ) ;
    public final void rule__Peripheral__Group_3_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2891:1: ( ( ( rule__Peripheral__Group_3_1_1__0 )? ) )
            // InternalMachine.g:2892:1: ( ( rule__Peripheral__Group_3_1_1__0 )? )
            {
            // InternalMachine.g:2892:1: ( ( rule__Peripheral__Group_3_1_1__0 )? )
            // InternalMachine.g:2893:2: ( rule__Peripheral__Group_3_1_1__0 )?
            {
             before(grammarAccess.getPeripheralAccess().getGroup_3_1_1()); 
            // InternalMachine.g:2894:2: ( rule__Peripheral__Group_3_1_1__0 )?
            int alt28=2;
            int LA28_0 = input.LA(1);

            if ( (LA28_0==31) ) {
                alt28=1;
            }
            switch (alt28) {
                case 1 :
                    // InternalMachine.g:2894:3: rule__Peripheral__Group_3_1_1__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Peripheral__Group_3_1_1__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPeripheralAccess().getGroup_3_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__1__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1__2"
    // InternalMachine.g:2902:1: rule__Peripheral__Group_3_1__2 : rule__Peripheral__Group_3_1__2__Impl rule__Peripheral__Group_3_1__3 ;
    public final void rule__Peripheral__Group_3_1__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2906:1: ( rule__Peripheral__Group_3_1__2__Impl rule__Peripheral__Group_3_1__3 )
            // InternalMachine.g:2907:2: rule__Peripheral__Group_3_1__2__Impl rule__Peripheral__Group_3_1__3
            {
            pushFollow(FOLLOW_26);
            rule__Peripheral__Group_3_1__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__2"


    // $ANTLR start "rule__Peripheral__Group_3_1__2__Impl"
    // InternalMachine.g:2914:1: rule__Peripheral__Group_3_1__2__Impl : ( 'Profiles' ) ;
    public final void rule__Peripheral__Group_3_1__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2918:1: ( ( 'Profiles' ) )
            // InternalMachine.g:2919:1: ( 'Profiles' )
            {
            // InternalMachine.g:2919:1: ( 'Profiles' )
            // InternalMachine.g:2920:2: 'Profiles'
            {
             before(grammarAccess.getPeripheralAccess().getProfilesKeyword_3_1_2()); 
            match(input,29,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getProfilesKeyword_3_1_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__2__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1__3"
    // InternalMachine.g:2929:1: rule__Peripheral__Group_3_1__3 : rule__Peripheral__Group_3_1__3__Impl rule__Peripheral__Group_3_1__4 ;
    public final void rule__Peripheral__Group_3_1__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2933:1: ( rule__Peripheral__Group_3_1__3__Impl rule__Peripheral__Group_3_1__4 )
            // InternalMachine.g:2934:2: rule__Peripheral__Group_3_1__3__Impl rule__Peripheral__Group_3_1__4
            {
            pushFollow(FOLLOW_6);
            rule__Peripheral__Group_3_1__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__3"


    // $ANTLR start "rule__Peripheral__Group_3_1__3__Impl"
    // InternalMachine.g:2941:1: rule__Peripheral__Group_3_1__3__Impl : ( '(' ) ;
    public final void rule__Peripheral__Group_3_1__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2945:1: ( ( '(' ) )
            // InternalMachine.g:2946:1: ( '(' )
            {
            // InternalMachine.g:2946:1: ( '(' )
            // InternalMachine.g:2947:2: '('
            {
             before(grammarAccess.getPeripheralAccess().getLeftParenthesisKeyword_3_1_3()); 
            match(input,26,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getLeftParenthesisKeyword_3_1_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__3__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1__4"
    // InternalMachine.g:2956:1: rule__Peripheral__Group_3_1__4 : rule__Peripheral__Group_3_1__4__Impl rule__Peripheral__Group_3_1__5 ;
    public final void rule__Peripheral__Group_3_1__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2960:1: ( rule__Peripheral__Group_3_1__4__Impl rule__Peripheral__Group_3_1__5 )
            // InternalMachine.g:2961:2: rule__Peripheral__Group_3_1__4__Impl rule__Peripheral__Group_3_1__5
            {
            pushFollow(FOLLOW_22);
            rule__Peripheral__Group_3_1__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__4"


    // $ANTLR start "rule__Peripheral__Group_3_1__4__Impl"
    // InternalMachine.g:2968:1: rule__Peripheral__Group_3_1__4__Impl : ( ( rule__Peripheral__ProfilesAssignment_3_1_4 ) ) ;
    public final void rule__Peripheral__Group_3_1__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2972:1: ( ( ( rule__Peripheral__ProfilesAssignment_3_1_4 ) ) )
            // InternalMachine.g:2973:1: ( ( rule__Peripheral__ProfilesAssignment_3_1_4 ) )
            {
            // InternalMachine.g:2973:1: ( ( rule__Peripheral__ProfilesAssignment_3_1_4 ) )
            // InternalMachine.g:2974:2: ( rule__Peripheral__ProfilesAssignment_3_1_4 )
            {
             before(grammarAccess.getPeripheralAccess().getProfilesAssignment_3_1_4()); 
            // InternalMachine.g:2975:2: ( rule__Peripheral__ProfilesAssignment_3_1_4 )
            // InternalMachine.g:2975:3: rule__Peripheral__ProfilesAssignment_3_1_4
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__ProfilesAssignment_3_1_4();

            state._fsp--;


            }

             after(grammarAccess.getPeripheralAccess().getProfilesAssignment_3_1_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__4__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1__5"
    // InternalMachine.g:2983:1: rule__Peripheral__Group_3_1__5 : rule__Peripheral__Group_3_1__5__Impl rule__Peripheral__Group_3_1__6 ;
    public final void rule__Peripheral__Group_3_1__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2987:1: ( rule__Peripheral__Group_3_1__5__Impl rule__Peripheral__Group_3_1__6 )
            // InternalMachine.g:2988:2: rule__Peripheral__Group_3_1__5__Impl rule__Peripheral__Group_3_1__6
            {
            pushFollow(FOLLOW_22);
            rule__Peripheral__Group_3_1__5__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1__6();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__5"


    // $ANTLR start "rule__Peripheral__Group_3_1__5__Impl"
    // InternalMachine.g:2995:1: rule__Peripheral__Group_3_1__5__Impl : ( ( rule__Peripheral__Group_3_1_5__0 )* ) ;
    public final void rule__Peripheral__Group_3_1__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:2999:1: ( ( ( rule__Peripheral__Group_3_1_5__0 )* ) )
            // InternalMachine.g:3000:1: ( ( rule__Peripheral__Group_3_1_5__0 )* )
            {
            // InternalMachine.g:3000:1: ( ( rule__Peripheral__Group_3_1_5__0 )* )
            // InternalMachine.g:3001:2: ( rule__Peripheral__Group_3_1_5__0 )*
            {
             before(grammarAccess.getPeripheralAccess().getGroup_3_1_5()); 
            // InternalMachine.g:3002:2: ( rule__Peripheral__Group_3_1_5__0 )*
            loop29:
            do {
                int alt29=2;
                int LA29_0 = input.LA(1);

                if ( (LA29_0==24) ) {
                    alt29=1;
                }


                switch (alt29) {
            	case 1 :
            	    // InternalMachine.g:3002:3: rule__Peripheral__Group_3_1_5__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__Peripheral__Group_3_1_5__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop29;
                }
            } while (true);

             after(grammarAccess.getPeripheralAccess().getGroup_3_1_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__5__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1__6"
    // InternalMachine.g:3010:1: rule__Peripheral__Group_3_1__6 : rule__Peripheral__Group_3_1__6__Impl rule__Peripheral__Group_3_1__7 ;
    public final void rule__Peripheral__Group_3_1__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3014:1: ( rule__Peripheral__Group_3_1__6__Impl rule__Peripheral__Group_3_1__7 )
            // InternalMachine.g:3015:2: rule__Peripheral__Group_3_1__6__Impl rule__Peripheral__Group_3_1__7
            {
            pushFollow(FOLLOW_27);
            rule__Peripheral__Group_3_1__6__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1__7();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__6"


    // $ANTLR start "rule__Peripheral__Group_3_1__6__Impl"
    // InternalMachine.g:3022:1: rule__Peripheral__Group_3_1__6__Impl : ( ')' ) ;
    public final void rule__Peripheral__Group_3_1__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3026:1: ( ( ')' ) )
            // InternalMachine.g:3027:1: ( ')' )
            {
            // InternalMachine.g:3027:1: ( ')' )
            // InternalMachine.g:3028:2: ')'
            {
             before(grammarAccess.getPeripheralAccess().getRightParenthesisKeyword_3_1_6()); 
            match(input,27,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getRightParenthesisKeyword_3_1_6()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__6__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1__7"
    // InternalMachine.g:3037:1: rule__Peripheral__Group_3_1__7 : rule__Peripheral__Group_3_1__7__Impl rule__Peripheral__Group_3_1__8 ;
    public final void rule__Peripheral__Group_3_1__7() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3041:1: ( rule__Peripheral__Group_3_1__7__Impl rule__Peripheral__Group_3_1__8 )
            // InternalMachine.g:3042:2: rule__Peripheral__Group_3_1__7__Impl rule__Peripheral__Group_3_1__8
            {
            pushFollow(FOLLOW_27);
            rule__Peripheral__Group_3_1__7__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1__8();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__7"


    // $ANTLR start "rule__Peripheral__Group_3_1__7__Impl"
    // InternalMachine.g:3049:1: rule__Peripheral__Group_3_1__7__Impl : ( ( rule__Peripheral__Group_3_1_7__0 )? ) ;
    public final void rule__Peripheral__Group_3_1__7__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3053:1: ( ( ( rule__Peripheral__Group_3_1_7__0 )? ) )
            // InternalMachine.g:3054:1: ( ( rule__Peripheral__Group_3_1_7__0 )? )
            {
            // InternalMachine.g:3054:1: ( ( rule__Peripheral__Group_3_1_7__0 )? )
            // InternalMachine.g:3055:2: ( rule__Peripheral__Group_3_1_7__0 )?
            {
             before(grammarAccess.getPeripheralAccess().getGroup_3_1_7()); 
            // InternalMachine.g:3056:2: ( rule__Peripheral__Group_3_1_7__0 )?
            int alt30=2;
            int LA30_0 = input.LA(1);

            if ( (LA30_0==32) ) {
                alt30=1;
            }
            switch (alt30) {
                case 1 :
                    // InternalMachine.g:3056:3: rule__Peripheral__Group_3_1_7__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Peripheral__Group_3_1_7__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPeripheralAccess().getGroup_3_1_7()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__7__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1__8"
    // InternalMachine.g:3064:1: rule__Peripheral__Group_3_1__8 : rule__Peripheral__Group_3_1__8__Impl ;
    public final void rule__Peripheral__Group_3_1__8() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3068:1: ( rule__Peripheral__Group_3_1__8__Impl )
            // InternalMachine.g:3069:2: rule__Peripheral__Group_3_1__8__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1__8__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__8"


    // $ANTLR start "rule__Peripheral__Group_3_1__8__Impl"
    // InternalMachine.g:3075:1: rule__Peripheral__Group_3_1__8__Impl : ( ( rule__Peripheral__Group_3_1_8__0 )? ) ;
    public final void rule__Peripheral__Group_3_1__8__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3079:1: ( ( ( rule__Peripheral__Group_3_1_8__0 )? ) )
            // InternalMachine.g:3080:1: ( ( rule__Peripheral__Group_3_1_8__0 )? )
            {
            // InternalMachine.g:3080:1: ( ( rule__Peripheral__Group_3_1_8__0 )? )
            // InternalMachine.g:3081:2: ( rule__Peripheral__Group_3_1_8__0 )?
            {
             before(grammarAccess.getPeripheralAccess().getGroup_3_1_8()); 
            // InternalMachine.g:3082:2: ( rule__Peripheral__Group_3_1_8__0 )?
            int alt31=2;
            int LA31_0 = input.LA(1);

            if ( (LA31_0==33) ) {
                alt31=1;
            }
            switch (alt31) {
                case 1 :
                    // InternalMachine.g:3082:3: rule__Peripheral__Group_3_1_8__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Peripheral__Group_3_1_8__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPeripheralAccess().getGroup_3_1_8()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1__8__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_0__0"
    // InternalMachine.g:3091:1: rule__Peripheral__Group_3_1_0__0 : rule__Peripheral__Group_3_1_0__0__Impl rule__Peripheral__Group_3_1_0__1 ;
    public final void rule__Peripheral__Group_3_1_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3095:1: ( rule__Peripheral__Group_3_1_0__0__Impl rule__Peripheral__Group_3_1_0__1 )
            // InternalMachine.g:3096:2: rule__Peripheral__Group_3_1_0__0__Impl rule__Peripheral__Group_3_1_0__1
            {
            pushFollow(FOLLOW_7);
            rule__Peripheral__Group_3_1_0__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_0__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_0__0"


    // $ANTLR start "rule__Peripheral__Group_3_1_0__0__Impl"
    // InternalMachine.g:3103:1: rule__Peripheral__Group_3_1_0__0__Impl : ( 'AxisPositions' ) ;
    public final void rule__Peripheral__Group_3_1_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3107:1: ( ( 'AxisPositions' ) )
            // InternalMachine.g:3108:1: ( 'AxisPositions' )
            {
            // InternalMachine.g:3108:1: ( 'AxisPositions' )
            // InternalMachine.g:3109:2: 'AxisPositions'
            {
             before(grammarAccess.getPeripheralAccess().getAxisPositionsKeyword_3_1_0_0()); 
            match(input,30,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getAxisPositionsKeyword_3_1_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_0__0__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_0__1"
    // InternalMachine.g:3118:1: rule__Peripheral__Group_3_1_0__1 : rule__Peripheral__Group_3_1_0__1__Impl rule__Peripheral__Group_3_1_0__2 ;
    public final void rule__Peripheral__Group_3_1_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3122:1: ( rule__Peripheral__Group_3_1_0__1__Impl rule__Peripheral__Group_3_1_0__2 )
            // InternalMachine.g:3123:2: rule__Peripheral__Group_3_1_0__1__Impl rule__Peripheral__Group_3_1_0__2
            {
            pushFollow(FOLLOW_8);
            rule__Peripheral__Group_3_1_0__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_0__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_0__1"


    // $ANTLR start "rule__Peripheral__Group_3_1_0__1__Impl"
    // InternalMachine.g:3130:1: rule__Peripheral__Group_3_1_0__1__Impl : ( '{' ) ;
    public final void rule__Peripheral__Group_3_1_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3134:1: ( ( '{' ) )
            // InternalMachine.g:3135:1: ( '{' )
            {
            // InternalMachine.g:3135:1: ( '{' )
            // InternalMachine.g:3136:2: '{'
            {
             before(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_0_1()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_0_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_0__1__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_0__2"
    // InternalMachine.g:3145:1: rule__Peripheral__Group_3_1_0__2 : rule__Peripheral__Group_3_1_0__2__Impl rule__Peripheral__Group_3_1_0__3 ;
    public final void rule__Peripheral__Group_3_1_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3149:1: ( rule__Peripheral__Group_3_1_0__2__Impl rule__Peripheral__Group_3_1_0__3 )
            // InternalMachine.g:3150:2: rule__Peripheral__Group_3_1_0__2__Impl rule__Peripheral__Group_3_1_0__3
            {
            pushFollow(FOLLOW_8);
            rule__Peripheral__Group_3_1_0__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_0__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_0__2"


    // $ANTLR start "rule__Peripheral__Group_3_1_0__2__Impl"
    // InternalMachine.g:3157:1: rule__Peripheral__Group_3_1_0__2__Impl : ( ( rule__Peripheral__AxisPositionsAssignment_3_1_0_2 )* ) ;
    public final void rule__Peripheral__Group_3_1_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3161:1: ( ( ( rule__Peripheral__AxisPositionsAssignment_3_1_0_2 )* ) )
            // InternalMachine.g:3162:1: ( ( rule__Peripheral__AxisPositionsAssignment_3_1_0_2 )* )
            {
            // InternalMachine.g:3162:1: ( ( rule__Peripheral__AxisPositionsAssignment_3_1_0_2 )* )
            // InternalMachine.g:3163:2: ( rule__Peripheral__AxisPositionsAssignment_3_1_0_2 )*
            {
             before(grammarAccess.getPeripheralAccess().getAxisPositionsAssignment_3_1_0_2()); 
            // InternalMachine.g:3164:2: ( rule__Peripheral__AxisPositionsAssignment_3_1_0_2 )*
            loop32:
            do {
                int alt32=2;
                int LA32_0 = input.LA(1);

                if ( (LA32_0==RULE_ID) ) {
                    alt32=1;
                }


                switch (alt32) {
            	case 1 :
            	    // InternalMachine.g:3164:3: rule__Peripheral__AxisPositionsAssignment_3_1_0_2
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__Peripheral__AxisPositionsAssignment_3_1_0_2();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop32;
                }
            } while (true);

             after(grammarAccess.getPeripheralAccess().getAxisPositionsAssignment_3_1_0_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_0__2__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_0__3"
    // InternalMachine.g:3172:1: rule__Peripheral__Group_3_1_0__3 : rule__Peripheral__Group_3_1_0__3__Impl ;
    public final void rule__Peripheral__Group_3_1_0__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3176:1: ( rule__Peripheral__Group_3_1_0__3__Impl )
            // InternalMachine.g:3177:2: rule__Peripheral__Group_3_1_0__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_0__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_0__3"


    // $ANTLR start "rule__Peripheral__Group_3_1_0__3__Impl"
    // InternalMachine.g:3183:1: rule__Peripheral__Group_3_1_0__3__Impl : ( '}' ) ;
    public final void rule__Peripheral__Group_3_1_0__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3187:1: ( ( '}' ) )
            // InternalMachine.g:3188:1: ( '}' )
            {
            // InternalMachine.g:3188:1: ( '}' )
            // InternalMachine.g:3189:2: '}'
            {
             before(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_0_3()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_0_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_0__3__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_1__0"
    // InternalMachine.g:3199:1: rule__Peripheral__Group_3_1_1__0 : rule__Peripheral__Group_3_1_1__0__Impl rule__Peripheral__Group_3_1_1__1 ;
    public final void rule__Peripheral__Group_3_1_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3203:1: ( rule__Peripheral__Group_3_1_1__0__Impl rule__Peripheral__Group_3_1_1__1 )
            // InternalMachine.g:3204:2: rule__Peripheral__Group_3_1_1__0__Impl rule__Peripheral__Group_3_1_1__1
            {
            pushFollow(FOLLOW_7);
            rule__Peripheral__Group_3_1_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_1__0"


    // $ANTLR start "rule__Peripheral__Group_3_1_1__0__Impl"
    // InternalMachine.g:3211:1: rule__Peripheral__Group_3_1_1__0__Impl : ( 'SymbolicPositions' ) ;
    public final void rule__Peripheral__Group_3_1_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3215:1: ( ( 'SymbolicPositions' ) )
            // InternalMachine.g:3216:1: ( 'SymbolicPositions' )
            {
            // InternalMachine.g:3216:1: ( 'SymbolicPositions' )
            // InternalMachine.g:3217:2: 'SymbolicPositions'
            {
             before(grammarAccess.getPeripheralAccess().getSymbolicPositionsKeyword_3_1_1_0()); 
            match(input,31,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getSymbolicPositionsKeyword_3_1_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_1__0__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_1__1"
    // InternalMachine.g:3226:1: rule__Peripheral__Group_3_1_1__1 : rule__Peripheral__Group_3_1_1__1__Impl rule__Peripheral__Group_3_1_1__2 ;
    public final void rule__Peripheral__Group_3_1_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3230:1: ( rule__Peripheral__Group_3_1_1__1__Impl rule__Peripheral__Group_3_1_1__2 )
            // InternalMachine.g:3231:2: rule__Peripheral__Group_3_1_1__1__Impl rule__Peripheral__Group_3_1_1__2
            {
            pushFollow(FOLLOW_8);
            rule__Peripheral__Group_3_1_1__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_1__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_1__1"


    // $ANTLR start "rule__Peripheral__Group_3_1_1__1__Impl"
    // InternalMachine.g:3238:1: rule__Peripheral__Group_3_1_1__1__Impl : ( '{' ) ;
    public final void rule__Peripheral__Group_3_1_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3242:1: ( ( '{' ) )
            // InternalMachine.g:3243:1: ( '{' )
            {
            // InternalMachine.g:3243:1: ( '{' )
            // InternalMachine.g:3244:2: '{'
            {
             before(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_1_1()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_1__1__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_1__2"
    // InternalMachine.g:3253:1: rule__Peripheral__Group_3_1_1__2 : rule__Peripheral__Group_3_1_1__2__Impl rule__Peripheral__Group_3_1_1__3 ;
    public final void rule__Peripheral__Group_3_1_1__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3257:1: ( rule__Peripheral__Group_3_1_1__2__Impl rule__Peripheral__Group_3_1_1__3 )
            // InternalMachine.g:3258:2: rule__Peripheral__Group_3_1_1__2__Impl rule__Peripheral__Group_3_1_1__3
            {
            pushFollow(FOLLOW_8);
            rule__Peripheral__Group_3_1_1__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_1__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_1__2"


    // $ANTLR start "rule__Peripheral__Group_3_1_1__2__Impl"
    // InternalMachine.g:3265:1: rule__Peripheral__Group_3_1_1__2__Impl : ( ( rule__Peripheral__PositionsAssignment_3_1_1_2 )* ) ;
    public final void rule__Peripheral__Group_3_1_1__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3269:1: ( ( ( rule__Peripheral__PositionsAssignment_3_1_1_2 )* ) )
            // InternalMachine.g:3270:1: ( ( rule__Peripheral__PositionsAssignment_3_1_1_2 )* )
            {
            // InternalMachine.g:3270:1: ( ( rule__Peripheral__PositionsAssignment_3_1_1_2 )* )
            // InternalMachine.g:3271:2: ( rule__Peripheral__PositionsAssignment_3_1_1_2 )*
            {
             before(grammarAccess.getPeripheralAccess().getPositionsAssignment_3_1_1_2()); 
            // InternalMachine.g:3272:2: ( rule__Peripheral__PositionsAssignment_3_1_1_2 )*
            loop33:
            do {
                int alt33=2;
                int LA33_0 = input.LA(1);

                if ( (LA33_0==RULE_ID) ) {
                    alt33=1;
                }


                switch (alt33) {
            	case 1 :
            	    // InternalMachine.g:3272:3: rule__Peripheral__PositionsAssignment_3_1_1_2
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__Peripheral__PositionsAssignment_3_1_1_2();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop33;
                }
            } while (true);

             after(grammarAccess.getPeripheralAccess().getPositionsAssignment_3_1_1_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_1__2__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_1__3"
    // InternalMachine.g:3280:1: rule__Peripheral__Group_3_1_1__3 : rule__Peripheral__Group_3_1_1__3__Impl ;
    public final void rule__Peripheral__Group_3_1_1__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3284:1: ( rule__Peripheral__Group_3_1_1__3__Impl )
            // InternalMachine.g:3285:2: rule__Peripheral__Group_3_1_1__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_1__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_1__3"


    // $ANTLR start "rule__Peripheral__Group_3_1_1__3__Impl"
    // InternalMachine.g:3291:1: rule__Peripheral__Group_3_1_1__3__Impl : ( '}' ) ;
    public final void rule__Peripheral__Group_3_1_1__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3295:1: ( ( '}' ) )
            // InternalMachine.g:3296:1: ( '}' )
            {
            // InternalMachine.g:3296:1: ( '}' )
            // InternalMachine.g:3297:2: '}'
            {
             before(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_1_3()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_1_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_1__3__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_5__0"
    // InternalMachine.g:3307:1: rule__Peripheral__Group_3_1_5__0 : rule__Peripheral__Group_3_1_5__0__Impl rule__Peripheral__Group_3_1_5__1 ;
    public final void rule__Peripheral__Group_3_1_5__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3311:1: ( rule__Peripheral__Group_3_1_5__0__Impl rule__Peripheral__Group_3_1_5__1 )
            // InternalMachine.g:3312:2: rule__Peripheral__Group_3_1_5__0__Impl rule__Peripheral__Group_3_1_5__1
            {
            pushFollow(FOLLOW_6);
            rule__Peripheral__Group_3_1_5__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_5__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_5__0"


    // $ANTLR start "rule__Peripheral__Group_3_1_5__0__Impl"
    // InternalMachine.g:3319:1: rule__Peripheral__Group_3_1_5__0__Impl : ( ',' ) ;
    public final void rule__Peripheral__Group_3_1_5__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3323:1: ( ( ',' ) )
            // InternalMachine.g:3324:1: ( ',' )
            {
            // InternalMachine.g:3324:1: ( ',' )
            // InternalMachine.g:3325:2: ','
            {
             before(grammarAccess.getPeripheralAccess().getCommaKeyword_3_1_5_0()); 
            match(input,24,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getCommaKeyword_3_1_5_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_5__0__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_5__1"
    // InternalMachine.g:3334:1: rule__Peripheral__Group_3_1_5__1 : rule__Peripheral__Group_3_1_5__1__Impl ;
    public final void rule__Peripheral__Group_3_1_5__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3338:1: ( rule__Peripheral__Group_3_1_5__1__Impl )
            // InternalMachine.g:3339:2: rule__Peripheral__Group_3_1_5__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_5__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_5__1"


    // $ANTLR start "rule__Peripheral__Group_3_1_5__1__Impl"
    // InternalMachine.g:3345:1: rule__Peripheral__Group_3_1_5__1__Impl : ( ( rule__Peripheral__ProfilesAssignment_3_1_5_1 ) ) ;
    public final void rule__Peripheral__Group_3_1_5__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3349:1: ( ( ( rule__Peripheral__ProfilesAssignment_3_1_5_1 ) ) )
            // InternalMachine.g:3350:1: ( ( rule__Peripheral__ProfilesAssignment_3_1_5_1 ) )
            {
            // InternalMachine.g:3350:1: ( ( rule__Peripheral__ProfilesAssignment_3_1_5_1 ) )
            // InternalMachine.g:3351:2: ( rule__Peripheral__ProfilesAssignment_3_1_5_1 )
            {
             before(grammarAccess.getPeripheralAccess().getProfilesAssignment_3_1_5_1()); 
            // InternalMachine.g:3352:2: ( rule__Peripheral__ProfilesAssignment_3_1_5_1 )
            // InternalMachine.g:3352:3: rule__Peripheral__ProfilesAssignment_3_1_5_1
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__ProfilesAssignment_3_1_5_1();

            state._fsp--;


            }

             after(grammarAccess.getPeripheralAccess().getProfilesAssignment_3_1_5_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_5__1__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_7__0"
    // InternalMachine.g:3361:1: rule__Peripheral__Group_3_1_7__0 : rule__Peripheral__Group_3_1_7__0__Impl rule__Peripheral__Group_3_1_7__1 ;
    public final void rule__Peripheral__Group_3_1_7__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3365:1: ( rule__Peripheral__Group_3_1_7__0__Impl rule__Peripheral__Group_3_1_7__1 )
            // InternalMachine.g:3366:2: rule__Peripheral__Group_3_1_7__0__Impl rule__Peripheral__Group_3_1_7__1
            {
            pushFollow(FOLLOW_7);
            rule__Peripheral__Group_3_1_7__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_7__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_7__0"


    // $ANTLR start "rule__Peripheral__Group_3_1_7__0__Impl"
    // InternalMachine.g:3373:1: rule__Peripheral__Group_3_1_7__0__Impl : ( 'Distances' ) ;
    public final void rule__Peripheral__Group_3_1_7__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3377:1: ( ( 'Distances' ) )
            // InternalMachine.g:3378:1: ( 'Distances' )
            {
            // InternalMachine.g:3378:1: ( 'Distances' )
            // InternalMachine.g:3379:2: 'Distances'
            {
             before(grammarAccess.getPeripheralAccess().getDistancesKeyword_3_1_7_0()); 
            match(input,32,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getDistancesKeyword_3_1_7_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_7__0__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_7__1"
    // InternalMachine.g:3388:1: rule__Peripheral__Group_3_1_7__1 : rule__Peripheral__Group_3_1_7__1__Impl rule__Peripheral__Group_3_1_7__2 ;
    public final void rule__Peripheral__Group_3_1_7__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3392:1: ( rule__Peripheral__Group_3_1_7__1__Impl rule__Peripheral__Group_3_1_7__2 )
            // InternalMachine.g:3393:2: rule__Peripheral__Group_3_1_7__1__Impl rule__Peripheral__Group_3_1_7__2
            {
            pushFollow(FOLLOW_8);
            rule__Peripheral__Group_3_1_7__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_7__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_7__1"


    // $ANTLR start "rule__Peripheral__Group_3_1_7__1__Impl"
    // InternalMachine.g:3400:1: rule__Peripheral__Group_3_1_7__1__Impl : ( '{' ) ;
    public final void rule__Peripheral__Group_3_1_7__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3404:1: ( ( '{' ) )
            // InternalMachine.g:3405:1: ( '{' )
            {
            // InternalMachine.g:3405:1: ( '{' )
            // InternalMachine.g:3406:2: '{'
            {
             before(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_7_1()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_7_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_7__1__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_7__2"
    // InternalMachine.g:3415:1: rule__Peripheral__Group_3_1_7__2 : rule__Peripheral__Group_3_1_7__2__Impl rule__Peripheral__Group_3_1_7__3 ;
    public final void rule__Peripheral__Group_3_1_7__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3419:1: ( rule__Peripheral__Group_3_1_7__2__Impl rule__Peripheral__Group_3_1_7__3 )
            // InternalMachine.g:3420:2: rule__Peripheral__Group_3_1_7__2__Impl rule__Peripheral__Group_3_1_7__3
            {
            pushFollow(FOLLOW_8);
            rule__Peripheral__Group_3_1_7__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_7__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_7__2"


    // $ANTLR start "rule__Peripheral__Group_3_1_7__2__Impl"
    // InternalMachine.g:3427:1: rule__Peripheral__Group_3_1_7__2__Impl : ( ( rule__Peripheral__DistancesAssignment_3_1_7_2 )* ) ;
    public final void rule__Peripheral__Group_3_1_7__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3431:1: ( ( ( rule__Peripheral__DistancesAssignment_3_1_7_2 )* ) )
            // InternalMachine.g:3432:1: ( ( rule__Peripheral__DistancesAssignment_3_1_7_2 )* )
            {
            // InternalMachine.g:3432:1: ( ( rule__Peripheral__DistancesAssignment_3_1_7_2 )* )
            // InternalMachine.g:3433:2: ( rule__Peripheral__DistancesAssignment_3_1_7_2 )*
            {
             before(grammarAccess.getPeripheralAccess().getDistancesAssignment_3_1_7_2()); 
            // InternalMachine.g:3434:2: ( rule__Peripheral__DistancesAssignment_3_1_7_2 )*
            loop34:
            do {
                int alt34=2;
                int LA34_0 = input.LA(1);

                if ( (LA34_0==RULE_ID) ) {
                    alt34=1;
                }


                switch (alt34) {
            	case 1 :
            	    // InternalMachine.g:3434:3: rule__Peripheral__DistancesAssignment_3_1_7_2
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__Peripheral__DistancesAssignment_3_1_7_2();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop34;
                }
            } while (true);

             after(grammarAccess.getPeripheralAccess().getDistancesAssignment_3_1_7_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_7__2__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_7__3"
    // InternalMachine.g:3442:1: rule__Peripheral__Group_3_1_7__3 : rule__Peripheral__Group_3_1_7__3__Impl ;
    public final void rule__Peripheral__Group_3_1_7__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3446:1: ( rule__Peripheral__Group_3_1_7__3__Impl )
            // InternalMachine.g:3447:2: rule__Peripheral__Group_3_1_7__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_7__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_7__3"


    // $ANTLR start "rule__Peripheral__Group_3_1_7__3__Impl"
    // InternalMachine.g:3453:1: rule__Peripheral__Group_3_1_7__3__Impl : ( '}' ) ;
    public final void rule__Peripheral__Group_3_1_7__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3457:1: ( ( '}' ) )
            // InternalMachine.g:3458:1: ( '}' )
            {
            // InternalMachine.g:3458:1: ( '}' )
            // InternalMachine.g:3459:2: '}'
            {
             before(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_7_3()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_7_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_7__3__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_8__0"
    // InternalMachine.g:3469:1: rule__Peripheral__Group_3_1_8__0 : rule__Peripheral__Group_3_1_8__0__Impl rule__Peripheral__Group_3_1_8__1 ;
    public final void rule__Peripheral__Group_3_1_8__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3473:1: ( rule__Peripheral__Group_3_1_8__0__Impl rule__Peripheral__Group_3_1_8__1 )
            // InternalMachine.g:3474:2: rule__Peripheral__Group_3_1_8__0__Impl rule__Peripheral__Group_3_1_8__1
            {
            pushFollow(FOLLOW_7);
            rule__Peripheral__Group_3_1_8__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_8__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_8__0"


    // $ANTLR start "rule__Peripheral__Group_3_1_8__0__Impl"
    // InternalMachine.g:3481:1: rule__Peripheral__Group_3_1_8__0__Impl : ( 'Paths' ) ;
    public final void rule__Peripheral__Group_3_1_8__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3485:1: ( ( 'Paths' ) )
            // InternalMachine.g:3486:1: ( 'Paths' )
            {
            // InternalMachine.g:3486:1: ( 'Paths' )
            // InternalMachine.g:3487:2: 'Paths'
            {
             before(grammarAccess.getPeripheralAccess().getPathsKeyword_3_1_8_0()); 
            match(input,33,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getPathsKeyword_3_1_8_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_8__0__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_8__1"
    // InternalMachine.g:3496:1: rule__Peripheral__Group_3_1_8__1 : rule__Peripheral__Group_3_1_8__1__Impl rule__Peripheral__Group_3_1_8__2 ;
    public final void rule__Peripheral__Group_3_1_8__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3500:1: ( rule__Peripheral__Group_3_1_8__1__Impl rule__Peripheral__Group_3_1_8__2 )
            // InternalMachine.g:3501:2: rule__Peripheral__Group_3_1_8__1__Impl rule__Peripheral__Group_3_1_8__2
            {
            pushFollow(FOLLOW_28);
            rule__Peripheral__Group_3_1_8__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_8__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_8__1"


    // $ANTLR start "rule__Peripheral__Group_3_1_8__1__Impl"
    // InternalMachine.g:3508:1: rule__Peripheral__Group_3_1_8__1__Impl : ( '{' ) ;
    public final void rule__Peripheral__Group_3_1_8__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3512:1: ( ( '{' ) )
            // InternalMachine.g:3513:1: ( '{' )
            {
            // InternalMachine.g:3513:1: ( '{' )
            // InternalMachine.g:3514:2: '{'
            {
             before(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_8_1()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getLeftCurlyBracketKeyword_3_1_8_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_8__1__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_8__2"
    // InternalMachine.g:3523:1: rule__Peripheral__Group_3_1_8__2 : rule__Peripheral__Group_3_1_8__2__Impl rule__Peripheral__Group_3_1_8__3 ;
    public final void rule__Peripheral__Group_3_1_8__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3527:1: ( rule__Peripheral__Group_3_1_8__2__Impl rule__Peripheral__Group_3_1_8__3 )
            // InternalMachine.g:3528:2: rule__Peripheral__Group_3_1_8__2__Impl rule__Peripheral__Group_3_1_8__3
            {
            pushFollow(FOLLOW_28);
            rule__Peripheral__Group_3_1_8__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_8__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_8__2"


    // $ANTLR start "rule__Peripheral__Group_3_1_8__2__Impl"
    // InternalMachine.g:3535:1: rule__Peripheral__Group_3_1_8__2__Impl : ( ( rule__Peripheral__PathsAssignment_3_1_8_2 )* ) ;
    public final void rule__Peripheral__Group_3_1_8__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3539:1: ( ( ( rule__Peripheral__PathsAssignment_3_1_8_2 )* ) )
            // InternalMachine.g:3540:1: ( ( rule__Peripheral__PathsAssignment_3_1_8_2 )* )
            {
            // InternalMachine.g:3540:1: ( ( rule__Peripheral__PathsAssignment_3_1_8_2 )* )
            // InternalMachine.g:3541:2: ( rule__Peripheral__PathsAssignment_3_1_8_2 )*
            {
             before(grammarAccess.getPeripheralAccess().getPathsAssignment_3_1_8_2()); 
            // InternalMachine.g:3542:2: ( rule__Peripheral__PathsAssignment_3_1_8_2 )*
            loop35:
            do {
                int alt35=2;
                int LA35_0 = input.LA(1);

                if ( (LA35_0==RULE_ID||LA35_0==40) ) {
                    alt35=1;
                }


                switch (alt35) {
            	case 1 :
            	    // InternalMachine.g:3542:3: rule__Peripheral__PathsAssignment_3_1_8_2
            	    {
            	    pushFollow(FOLLOW_29);
            	    rule__Peripheral__PathsAssignment_3_1_8_2();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop35;
                }
            } while (true);

             after(grammarAccess.getPeripheralAccess().getPathsAssignment_3_1_8_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_8__2__Impl"


    // $ANTLR start "rule__Peripheral__Group_3_1_8__3"
    // InternalMachine.g:3550:1: rule__Peripheral__Group_3_1_8__3 : rule__Peripheral__Group_3_1_8__3__Impl ;
    public final void rule__Peripheral__Group_3_1_8__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3554:1: ( rule__Peripheral__Group_3_1_8__3__Impl )
            // InternalMachine.g:3555:2: rule__Peripheral__Group_3_1_8__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Peripheral__Group_3_1_8__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_8__3"


    // $ANTLR start "rule__Peripheral__Group_3_1_8__3__Impl"
    // InternalMachine.g:3561:1: rule__Peripheral__Group_3_1_8__3__Impl : ( '}' ) ;
    public final void rule__Peripheral__Group_3_1_8__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3565:1: ( ( '}' ) )
            // InternalMachine.g:3566:1: ( '}' )
            {
            // InternalMachine.g:3566:1: ( '}' )
            // InternalMachine.g:3567:2: '}'
            {
             before(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_8_3()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getRightCurlyBracketKeyword_3_1_8_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__Group_3_1_8__3__Impl"


    // $ANTLR start "rule__Distance__Group__0"
    // InternalMachine.g:3577:1: rule__Distance__Group__0 : rule__Distance__Group__0__Impl rule__Distance__Group__1 ;
    public final void rule__Distance__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3581:1: ( rule__Distance__Group__0__Impl rule__Distance__Group__1 )
            // InternalMachine.g:3582:2: rule__Distance__Group__0__Impl rule__Distance__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__Distance__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Distance__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group__0"


    // $ANTLR start "rule__Distance__Group__0__Impl"
    // InternalMachine.g:3589:1: rule__Distance__Group__0__Impl : ( () ) ;
    public final void rule__Distance__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3593:1: ( ( () ) )
            // InternalMachine.g:3594:1: ( () )
            {
            // InternalMachine.g:3594:1: ( () )
            // InternalMachine.g:3595:2: ()
            {
             before(grammarAccess.getDistanceAccess().getDistanceAction_0()); 
            // InternalMachine.g:3596:2: ()
            // InternalMachine.g:3596:3: 
            {
            }

             after(grammarAccess.getDistanceAccess().getDistanceAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group__0__Impl"


    // $ANTLR start "rule__Distance__Group__1"
    // InternalMachine.g:3604:1: rule__Distance__Group__1 : rule__Distance__Group__1__Impl rule__Distance__Group__2 ;
    public final void rule__Distance__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3608:1: ( rule__Distance__Group__1__Impl rule__Distance__Group__2 )
            // InternalMachine.g:3609:2: rule__Distance__Group__1__Impl rule__Distance__Group__2
            {
            pushFollow(FOLLOW_15);
            rule__Distance__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Distance__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group__1"


    // $ANTLR start "rule__Distance__Group__1__Impl"
    // InternalMachine.g:3616:1: rule__Distance__Group__1__Impl : ( ( rule__Distance__NameAssignment_1 ) ) ;
    public final void rule__Distance__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3620:1: ( ( ( rule__Distance__NameAssignment_1 ) ) )
            // InternalMachine.g:3621:1: ( ( rule__Distance__NameAssignment_1 ) )
            {
            // InternalMachine.g:3621:1: ( ( rule__Distance__NameAssignment_1 ) )
            // InternalMachine.g:3622:2: ( rule__Distance__NameAssignment_1 )
            {
             before(grammarAccess.getDistanceAccess().getNameAssignment_1()); 
            // InternalMachine.g:3623:2: ( rule__Distance__NameAssignment_1 )
            // InternalMachine.g:3623:3: rule__Distance__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Distance__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getDistanceAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group__1__Impl"


    // $ANTLR start "rule__Distance__Group__2"
    // InternalMachine.g:3631:1: rule__Distance__Group__2 : rule__Distance__Group__2__Impl ;
    public final void rule__Distance__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3635:1: ( rule__Distance__Group__2__Impl )
            // InternalMachine.g:3636:2: rule__Distance__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Distance__Group__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group__2"


    // $ANTLR start "rule__Distance__Group__2__Impl"
    // InternalMachine.g:3642:1: rule__Distance__Group__2__Impl : ( ( rule__Distance__Group_2__0 )? ) ;
    public final void rule__Distance__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3646:1: ( ( ( rule__Distance__Group_2__0 )? ) )
            // InternalMachine.g:3647:1: ( ( rule__Distance__Group_2__0 )? )
            {
            // InternalMachine.g:3647:1: ( ( rule__Distance__Group_2__0 )? )
            // InternalMachine.g:3648:2: ( rule__Distance__Group_2__0 )?
            {
             before(grammarAccess.getDistanceAccess().getGroup_2()); 
            // InternalMachine.g:3649:2: ( rule__Distance__Group_2__0 )?
            int alt36=2;
            int LA36_0 = input.LA(1);

            if ( (LA36_0==21) ) {
                alt36=1;
            }
            switch (alt36) {
                case 1 :
                    // InternalMachine.g:3649:3: rule__Distance__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__Distance__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getDistanceAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group__2__Impl"


    // $ANTLR start "rule__Distance__Group_2__0"
    // InternalMachine.g:3658:1: rule__Distance__Group_2__0 : rule__Distance__Group_2__0__Impl rule__Distance__Group_2__1 ;
    public final void rule__Distance__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3662:1: ( rule__Distance__Group_2__0__Impl rule__Distance__Group_2__1 )
            // InternalMachine.g:3663:2: rule__Distance__Group_2__0__Impl rule__Distance__Group_2__1
            {
            pushFollow(FOLLOW_6);
            rule__Distance__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Distance__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2__0"


    // $ANTLR start "rule__Distance__Group_2__0__Impl"
    // InternalMachine.g:3670:1: rule__Distance__Group_2__0__Impl : ( '[' ) ;
    public final void rule__Distance__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3674:1: ( ( '[' ) )
            // InternalMachine.g:3675:1: ( '[' )
            {
            // InternalMachine.g:3675:1: ( '[' )
            // InternalMachine.g:3676:2: '['
            {
             before(grammarAccess.getDistanceAccess().getLeftSquareBracketKeyword_2_0()); 
            match(input,21,FOLLOW_2); 
             after(grammarAccess.getDistanceAccess().getLeftSquareBracketKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2__0__Impl"


    // $ANTLR start "rule__Distance__Group_2__1"
    // InternalMachine.g:3685:1: rule__Distance__Group_2__1 : rule__Distance__Group_2__1__Impl rule__Distance__Group_2__2 ;
    public final void rule__Distance__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3689:1: ( rule__Distance__Group_2__1__Impl rule__Distance__Group_2__2 )
            // InternalMachine.g:3690:2: rule__Distance__Group_2__1__Impl rule__Distance__Group_2__2
            {
            pushFollow(FOLLOW_30);
            rule__Distance__Group_2__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Distance__Group_2__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2__1"


    // $ANTLR start "rule__Distance__Group_2__1__Impl"
    // InternalMachine.g:3697:1: rule__Distance__Group_2__1__Impl : ( ( rule__Distance__SettlingAssignment_2_1 ) ) ;
    public final void rule__Distance__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3701:1: ( ( ( rule__Distance__SettlingAssignment_2_1 ) ) )
            // InternalMachine.g:3702:1: ( ( rule__Distance__SettlingAssignment_2_1 ) )
            {
            // InternalMachine.g:3702:1: ( ( rule__Distance__SettlingAssignment_2_1 ) )
            // InternalMachine.g:3703:2: ( rule__Distance__SettlingAssignment_2_1 )
            {
             before(grammarAccess.getDistanceAccess().getSettlingAssignment_2_1()); 
            // InternalMachine.g:3704:2: ( rule__Distance__SettlingAssignment_2_1 )
            // InternalMachine.g:3704:3: rule__Distance__SettlingAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__Distance__SettlingAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getDistanceAccess().getSettlingAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2__1__Impl"


    // $ANTLR start "rule__Distance__Group_2__2"
    // InternalMachine.g:3712:1: rule__Distance__Group_2__2 : rule__Distance__Group_2__2__Impl rule__Distance__Group_2__3 ;
    public final void rule__Distance__Group_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3716:1: ( rule__Distance__Group_2__2__Impl rule__Distance__Group_2__3 )
            // InternalMachine.g:3717:2: rule__Distance__Group_2__2__Impl rule__Distance__Group_2__3
            {
            pushFollow(FOLLOW_30);
            rule__Distance__Group_2__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Distance__Group_2__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2__2"


    // $ANTLR start "rule__Distance__Group_2__2__Impl"
    // InternalMachine.g:3724:1: rule__Distance__Group_2__2__Impl : ( ( rule__Distance__Group_2_2__0 )* ) ;
    public final void rule__Distance__Group_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3728:1: ( ( ( rule__Distance__Group_2_2__0 )* ) )
            // InternalMachine.g:3729:1: ( ( rule__Distance__Group_2_2__0 )* )
            {
            // InternalMachine.g:3729:1: ( ( rule__Distance__Group_2_2__0 )* )
            // InternalMachine.g:3730:2: ( rule__Distance__Group_2_2__0 )*
            {
             before(grammarAccess.getDistanceAccess().getGroup_2_2()); 
            // InternalMachine.g:3731:2: ( rule__Distance__Group_2_2__0 )*
            loop37:
            do {
                int alt37=2;
                int LA37_0 = input.LA(1);

                if ( (LA37_0==24) ) {
                    alt37=1;
                }


                switch (alt37) {
            	case 1 :
            	    // InternalMachine.g:3731:3: rule__Distance__Group_2_2__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__Distance__Group_2_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop37;
                }
            } while (true);

             after(grammarAccess.getDistanceAccess().getGroup_2_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2__2__Impl"


    // $ANTLR start "rule__Distance__Group_2__3"
    // InternalMachine.g:3739:1: rule__Distance__Group_2__3 : rule__Distance__Group_2__3__Impl ;
    public final void rule__Distance__Group_2__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3743:1: ( rule__Distance__Group_2__3__Impl )
            // InternalMachine.g:3744:2: rule__Distance__Group_2__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Distance__Group_2__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2__3"


    // $ANTLR start "rule__Distance__Group_2__3__Impl"
    // InternalMachine.g:3750:1: rule__Distance__Group_2__3__Impl : ( ']' ) ;
    public final void rule__Distance__Group_2__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3754:1: ( ( ']' ) )
            // InternalMachine.g:3755:1: ( ']' )
            {
            // InternalMachine.g:3755:1: ( ']' )
            // InternalMachine.g:3756:2: ']'
            {
             before(grammarAccess.getDistanceAccess().getRightSquareBracketKeyword_2_3()); 
            match(input,22,FOLLOW_2); 
             after(grammarAccess.getDistanceAccess().getRightSquareBracketKeyword_2_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2__3__Impl"


    // $ANTLR start "rule__Distance__Group_2_2__0"
    // InternalMachine.g:3766:1: rule__Distance__Group_2_2__0 : rule__Distance__Group_2_2__0__Impl rule__Distance__Group_2_2__1 ;
    public final void rule__Distance__Group_2_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3770:1: ( rule__Distance__Group_2_2__0__Impl rule__Distance__Group_2_2__1 )
            // InternalMachine.g:3771:2: rule__Distance__Group_2_2__0__Impl rule__Distance__Group_2_2__1
            {
            pushFollow(FOLLOW_6);
            rule__Distance__Group_2_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Distance__Group_2_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2_2__0"


    // $ANTLR start "rule__Distance__Group_2_2__0__Impl"
    // InternalMachine.g:3778:1: rule__Distance__Group_2_2__0__Impl : ( ',' ) ;
    public final void rule__Distance__Group_2_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3782:1: ( ( ',' ) )
            // InternalMachine.g:3783:1: ( ',' )
            {
            // InternalMachine.g:3783:1: ( ',' )
            // InternalMachine.g:3784:2: ','
            {
             before(grammarAccess.getDistanceAccess().getCommaKeyword_2_2_0()); 
            match(input,24,FOLLOW_2); 
             after(grammarAccess.getDistanceAccess().getCommaKeyword_2_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2_2__0__Impl"


    // $ANTLR start "rule__Distance__Group_2_2__1"
    // InternalMachine.g:3793:1: rule__Distance__Group_2_2__1 : rule__Distance__Group_2_2__1__Impl ;
    public final void rule__Distance__Group_2_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3797:1: ( rule__Distance__Group_2_2__1__Impl )
            // InternalMachine.g:3798:2: rule__Distance__Group_2_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Distance__Group_2_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2_2__1"


    // $ANTLR start "rule__Distance__Group_2_2__1__Impl"
    // InternalMachine.g:3804:1: rule__Distance__Group_2_2__1__Impl : ( ( rule__Distance__SettlingAssignment_2_2_1 ) ) ;
    public final void rule__Distance__Group_2_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3808:1: ( ( ( rule__Distance__SettlingAssignment_2_2_1 ) ) )
            // InternalMachine.g:3809:1: ( ( rule__Distance__SettlingAssignment_2_2_1 ) )
            {
            // InternalMachine.g:3809:1: ( ( rule__Distance__SettlingAssignment_2_2_1 ) )
            // InternalMachine.g:3810:2: ( rule__Distance__SettlingAssignment_2_2_1 )
            {
             before(grammarAccess.getDistanceAccess().getSettlingAssignment_2_2_1()); 
            // InternalMachine.g:3811:2: ( rule__Distance__SettlingAssignment_2_2_1 )
            // InternalMachine.g:3811:3: rule__Distance__SettlingAssignment_2_2_1
            {
            pushFollow(FOLLOW_2);
            rule__Distance__SettlingAssignment_2_2_1();

            state._fsp--;


            }

             after(grammarAccess.getDistanceAccess().getSettlingAssignment_2_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__Group_2_2__1__Impl"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group__0"
    // InternalMachine.g:3820:1: rule__AxisPositionsMapEntry__Group__0 : rule__AxisPositionsMapEntry__Group__0__Impl rule__AxisPositionsMapEntry__Group__1 ;
    public final void rule__AxisPositionsMapEntry__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3824:1: ( rule__AxisPositionsMapEntry__Group__0__Impl rule__AxisPositionsMapEntry__Group__1 )
            // InternalMachine.g:3825:2: rule__AxisPositionsMapEntry__Group__0__Impl rule__AxisPositionsMapEntry__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__AxisPositionsMapEntry__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group__0"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group__0__Impl"
    // InternalMachine.g:3832:1: rule__AxisPositionsMapEntry__Group__0__Impl : ( () ) ;
    public final void rule__AxisPositionsMapEntry__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3836:1: ( ( () ) )
            // InternalMachine.g:3837:1: ( () )
            {
            // InternalMachine.g:3837:1: ( () )
            // InternalMachine.g:3838:2: ()
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getAxisPositionsMapEntryAction_0()); 
            // InternalMachine.g:3839:2: ()
            // InternalMachine.g:3839:3: 
            {
            }

             after(grammarAccess.getAxisPositionsMapEntryAccess().getAxisPositionsMapEntryAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group__0__Impl"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group__1"
    // InternalMachine.g:3847:1: rule__AxisPositionsMapEntry__Group__1 : rule__AxisPositionsMapEntry__Group__1__Impl rule__AxisPositionsMapEntry__Group__2 ;
    public final void rule__AxisPositionsMapEntry__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3851:1: ( rule__AxisPositionsMapEntry__Group__1__Impl rule__AxisPositionsMapEntry__Group__2 )
            // InternalMachine.g:3852:2: rule__AxisPositionsMapEntry__Group__1__Impl rule__AxisPositionsMapEntry__Group__2
            {
            pushFollow(FOLLOW_26);
            rule__AxisPositionsMapEntry__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group__1"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group__1__Impl"
    // InternalMachine.g:3859:1: rule__AxisPositionsMapEntry__Group__1__Impl : ( ( rule__AxisPositionsMapEntry__KeyAssignment_1 ) ) ;
    public final void rule__AxisPositionsMapEntry__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3863:1: ( ( ( rule__AxisPositionsMapEntry__KeyAssignment_1 ) ) )
            // InternalMachine.g:3864:1: ( ( rule__AxisPositionsMapEntry__KeyAssignment_1 ) )
            {
            // InternalMachine.g:3864:1: ( ( rule__AxisPositionsMapEntry__KeyAssignment_1 ) )
            // InternalMachine.g:3865:2: ( rule__AxisPositionsMapEntry__KeyAssignment_1 )
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getKeyAssignment_1()); 
            // InternalMachine.g:3866:2: ( rule__AxisPositionsMapEntry__KeyAssignment_1 )
            // InternalMachine.g:3866:3: rule__AxisPositionsMapEntry__KeyAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__KeyAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getAxisPositionsMapEntryAccess().getKeyAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group__1__Impl"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group__2"
    // InternalMachine.g:3874:1: rule__AxisPositionsMapEntry__Group__2 : rule__AxisPositionsMapEntry__Group__2__Impl ;
    public final void rule__AxisPositionsMapEntry__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3878:1: ( rule__AxisPositionsMapEntry__Group__2__Impl )
            // InternalMachine.g:3879:2: rule__AxisPositionsMapEntry__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group__2"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group__2__Impl"
    // InternalMachine.g:3885:1: rule__AxisPositionsMapEntry__Group__2__Impl : ( ( rule__AxisPositionsMapEntry__Group_2__0 )? ) ;
    public final void rule__AxisPositionsMapEntry__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3889:1: ( ( ( rule__AxisPositionsMapEntry__Group_2__0 )? ) )
            // InternalMachine.g:3890:1: ( ( rule__AxisPositionsMapEntry__Group_2__0 )? )
            {
            // InternalMachine.g:3890:1: ( ( rule__AxisPositionsMapEntry__Group_2__0 )? )
            // InternalMachine.g:3891:2: ( rule__AxisPositionsMapEntry__Group_2__0 )?
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getGroup_2()); 
            // InternalMachine.g:3892:2: ( rule__AxisPositionsMapEntry__Group_2__0 )?
            int alt38=2;
            int LA38_0 = input.LA(1);

            if ( (LA38_0==26) ) {
                alt38=1;
            }
            switch (alt38) {
                case 1 :
                    // InternalMachine.g:3892:3: rule__AxisPositionsMapEntry__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__AxisPositionsMapEntry__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getAxisPositionsMapEntryAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group__2__Impl"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2__0"
    // InternalMachine.g:3901:1: rule__AxisPositionsMapEntry__Group_2__0 : rule__AxisPositionsMapEntry__Group_2__0__Impl rule__AxisPositionsMapEntry__Group_2__1 ;
    public final void rule__AxisPositionsMapEntry__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3905:1: ( rule__AxisPositionsMapEntry__Group_2__0__Impl rule__AxisPositionsMapEntry__Group_2__1 )
            // InternalMachine.g:3906:2: rule__AxisPositionsMapEntry__Group_2__0__Impl rule__AxisPositionsMapEntry__Group_2__1
            {
            pushFollow(FOLLOW_6);
            rule__AxisPositionsMapEntry__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2__0"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2__0__Impl"
    // InternalMachine.g:3913:1: rule__AxisPositionsMapEntry__Group_2__0__Impl : ( '(' ) ;
    public final void rule__AxisPositionsMapEntry__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3917:1: ( ( '(' ) )
            // InternalMachine.g:3918:1: ( '(' )
            {
            // InternalMachine.g:3918:1: ( '(' )
            // InternalMachine.g:3919:2: '('
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getLeftParenthesisKeyword_2_0()); 
            match(input,26,FOLLOW_2); 
             after(grammarAccess.getAxisPositionsMapEntryAccess().getLeftParenthesisKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2__0__Impl"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2__1"
    // InternalMachine.g:3928:1: rule__AxisPositionsMapEntry__Group_2__1 : rule__AxisPositionsMapEntry__Group_2__1__Impl rule__AxisPositionsMapEntry__Group_2__2 ;
    public final void rule__AxisPositionsMapEntry__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3932:1: ( rule__AxisPositionsMapEntry__Group_2__1__Impl rule__AxisPositionsMapEntry__Group_2__2 )
            // InternalMachine.g:3933:2: rule__AxisPositionsMapEntry__Group_2__1__Impl rule__AxisPositionsMapEntry__Group_2__2
            {
            pushFollow(FOLLOW_22);
            rule__AxisPositionsMapEntry__Group_2__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group_2__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2__1"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2__1__Impl"
    // InternalMachine.g:3940:1: rule__AxisPositionsMapEntry__Group_2__1__Impl : ( ( rule__AxisPositionsMapEntry__ValueAssignment_2_1 ) ) ;
    public final void rule__AxisPositionsMapEntry__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3944:1: ( ( ( rule__AxisPositionsMapEntry__ValueAssignment_2_1 ) ) )
            // InternalMachine.g:3945:1: ( ( rule__AxisPositionsMapEntry__ValueAssignment_2_1 ) )
            {
            // InternalMachine.g:3945:1: ( ( rule__AxisPositionsMapEntry__ValueAssignment_2_1 ) )
            // InternalMachine.g:3946:2: ( rule__AxisPositionsMapEntry__ValueAssignment_2_1 )
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getValueAssignment_2_1()); 
            // InternalMachine.g:3947:2: ( rule__AxisPositionsMapEntry__ValueAssignment_2_1 )
            // InternalMachine.g:3947:3: rule__AxisPositionsMapEntry__ValueAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__ValueAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getAxisPositionsMapEntryAccess().getValueAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2__1__Impl"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2__2"
    // InternalMachine.g:3955:1: rule__AxisPositionsMapEntry__Group_2__2 : rule__AxisPositionsMapEntry__Group_2__2__Impl rule__AxisPositionsMapEntry__Group_2__3 ;
    public final void rule__AxisPositionsMapEntry__Group_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3959:1: ( rule__AxisPositionsMapEntry__Group_2__2__Impl rule__AxisPositionsMapEntry__Group_2__3 )
            // InternalMachine.g:3960:2: rule__AxisPositionsMapEntry__Group_2__2__Impl rule__AxisPositionsMapEntry__Group_2__3
            {
            pushFollow(FOLLOW_22);
            rule__AxisPositionsMapEntry__Group_2__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group_2__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2__2"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2__2__Impl"
    // InternalMachine.g:3967:1: rule__AxisPositionsMapEntry__Group_2__2__Impl : ( ( rule__AxisPositionsMapEntry__Group_2_2__0 )* ) ;
    public final void rule__AxisPositionsMapEntry__Group_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3971:1: ( ( ( rule__AxisPositionsMapEntry__Group_2_2__0 )* ) )
            // InternalMachine.g:3972:1: ( ( rule__AxisPositionsMapEntry__Group_2_2__0 )* )
            {
            // InternalMachine.g:3972:1: ( ( rule__AxisPositionsMapEntry__Group_2_2__0 )* )
            // InternalMachine.g:3973:2: ( rule__AxisPositionsMapEntry__Group_2_2__0 )*
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getGroup_2_2()); 
            // InternalMachine.g:3974:2: ( rule__AxisPositionsMapEntry__Group_2_2__0 )*
            loop39:
            do {
                int alt39=2;
                int LA39_0 = input.LA(1);

                if ( (LA39_0==24) ) {
                    alt39=1;
                }


                switch (alt39) {
            	case 1 :
            	    // InternalMachine.g:3974:3: rule__AxisPositionsMapEntry__Group_2_2__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__AxisPositionsMapEntry__Group_2_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop39;
                }
            } while (true);

             after(grammarAccess.getAxisPositionsMapEntryAccess().getGroup_2_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2__2__Impl"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2__3"
    // InternalMachine.g:3982:1: rule__AxisPositionsMapEntry__Group_2__3 : rule__AxisPositionsMapEntry__Group_2__3__Impl ;
    public final void rule__AxisPositionsMapEntry__Group_2__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3986:1: ( rule__AxisPositionsMapEntry__Group_2__3__Impl )
            // InternalMachine.g:3987:2: rule__AxisPositionsMapEntry__Group_2__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group_2__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2__3"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2__3__Impl"
    // InternalMachine.g:3993:1: rule__AxisPositionsMapEntry__Group_2__3__Impl : ( ')' ) ;
    public final void rule__AxisPositionsMapEntry__Group_2__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:3997:1: ( ( ')' ) )
            // InternalMachine.g:3998:1: ( ')' )
            {
            // InternalMachine.g:3998:1: ( ')' )
            // InternalMachine.g:3999:2: ')'
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getRightParenthesisKeyword_2_3()); 
            match(input,27,FOLLOW_2); 
             after(grammarAccess.getAxisPositionsMapEntryAccess().getRightParenthesisKeyword_2_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2__3__Impl"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2_2__0"
    // InternalMachine.g:4009:1: rule__AxisPositionsMapEntry__Group_2_2__0 : rule__AxisPositionsMapEntry__Group_2_2__0__Impl rule__AxisPositionsMapEntry__Group_2_2__1 ;
    public final void rule__AxisPositionsMapEntry__Group_2_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4013:1: ( rule__AxisPositionsMapEntry__Group_2_2__0__Impl rule__AxisPositionsMapEntry__Group_2_2__1 )
            // InternalMachine.g:4014:2: rule__AxisPositionsMapEntry__Group_2_2__0__Impl rule__AxisPositionsMapEntry__Group_2_2__1
            {
            pushFollow(FOLLOW_6);
            rule__AxisPositionsMapEntry__Group_2_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group_2_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2_2__0"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2_2__0__Impl"
    // InternalMachine.g:4021:1: rule__AxisPositionsMapEntry__Group_2_2__0__Impl : ( ',' ) ;
    public final void rule__AxisPositionsMapEntry__Group_2_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4025:1: ( ( ',' ) )
            // InternalMachine.g:4026:1: ( ',' )
            {
            // InternalMachine.g:4026:1: ( ',' )
            // InternalMachine.g:4027:2: ','
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getCommaKeyword_2_2_0()); 
            match(input,24,FOLLOW_2); 
             after(grammarAccess.getAxisPositionsMapEntryAccess().getCommaKeyword_2_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2_2__0__Impl"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2_2__1"
    // InternalMachine.g:4036:1: rule__AxisPositionsMapEntry__Group_2_2__1 : rule__AxisPositionsMapEntry__Group_2_2__1__Impl ;
    public final void rule__AxisPositionsMapEntry__Group_2_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4040:1: ( rule__AxisPositionsMapEntry__Group_2_2__1__Impl )
            // InternalMachine.g:4041:2: rule__AxisPositionsMapEntry__Group_2_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__Group_2_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2_2__1"


    // $ANTLR start "rule__AxisPositionsMapEntry__Group_2_2__1__Impl"
    // InternalMachine.g:4047:1: rule__AxisPositionsMapEntry__Group_2_2__1__Impl : ( ( rule__AxisPositionsMapEntry__ValueAssignment_2_2_1 ) ) ;
    public final void rule__AxisPositionsMapEntry__Group_2_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4051:1: ( ( ( rule__AxisPositionsMapEntry__ValueAssignment_2_2_1 ) ) )
            // InternalMachine.g:4052:1: ( ( rule__AxisPositionsMapEntry__ValueAssignment_2_2_1 ) )
            {
            // InternalMachine.g:4052:1: ( ( rule__AxisPositionsMapEntry__ValueAssignment_2_2_1 ) )
            // InternalMachine.g:4053:2: ( rule__AxisPositionsMapEntry__ValueAssignment_2_2_1 )
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getValueAssignment_2_2_1()); 
            // InternalMachine.g:4054:2: ( rule__AxisPositionsMapEntry__ValueAssignment_2_2_1 )
            // InternalMachine.g:4054:3: rule__AxisPositionsMapEntry__ValueAssignment_2_2_1
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionsMapEntry__ValueAssignment_2_2_1();

            state._fsp--;


            }

             after(grammarAccess.getAxisPositionsMapEntryAccess().getValueAssignment_2_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__Group_2_2__1__Impl"


    // $ANTLR start "rule__Position__Group__0"
    // InternalMachine.g:4063:1: rule__Position__Group__0 : rule__Position__Group__0__Impl rule__Position__Group__1 ;
    public final void rule__Position__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4067:1: ( rule__Position__Group__0__Impl rule__Position__Group__1 )
            // InternalMachine.g:4068:2: rule__Position__Group__0__Impl rule__Position__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__Position__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Position__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Position__Group__0"


    // $ANTLR start "rule__Position__Group__0__Impl"
    // InternalMachine.g:4075:1: rule__Position__Group__0__Impl : ( () ) ;
    public final void rule__Position__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4079:1: ( ( () ) )
            // InternalMachine.g:4080:1: ( () )
            {
            // InternalMachine.g:4080:1: ( () )
            // InternalMachine.g:4081:2: ()
            {
             before(grammarAccess.getPositionAccess().getPositionAction_0()); 
            // InternalMachine.g:4082:2: ()
            // InternalMachine.g:4082:3: 
            {
            }

             after(grammarAccess.getPositionAccess().getPositionAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Position__Group__0__Impl"


    // $ANTLR start "rule__Position__Group__1"
    // InternalMachine.g:4090:1: rule__Position__Group__1 : rule__Position__Group__1__Impl ;
    public final void rule__Position__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4094:1: ( rule__Position__Group__1__Impl )
            // InternalMachine.g:4095:2: rule__Position__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Position__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Position__Group__1"


    // $ANTLR start "rule__Position__Group__1__Impl"
    // InternalMachine.g:4101:1: rule__Position__Group__1__Impl : ( ( rule__Position__NameAssignment_1 ) ) ;
    public final void rule__Position__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4105:1: ( ( ( rule__Position__NameAssignment_1 ) ) )
            // InternalMachine.g:4106:1: ( ( rule__Position__NameAssignment_1 ) )
            {
            // InternalMachine.g:4106:1: ( ( rule__Position__NameAssignment_1 ) )
            // InternalMachine.g:4107:2: ( rule__Position__NameAssignment_1 )
            {
             before(grammarAccess.getPositionAccess().getNameAssignment_1()); 
            // InternalMachine.g:4108:2: ( rule__Position__NameAssignment_1 )
            // InternalMachine.g:4108:3: rule__Position__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Position__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getPositionAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Position__Group__1__Impl"


    // $ANTLR start "rule__SymbolicPosition__Group__0"
    // InternalMachine.g:4117:1: rule__SymbolicPosition__Group__0 : rule__SymbolicPosition__Group__0__Impl rule__SymbolicPosition__Group__1 ;
    public final void rule__SymbolicPosition__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4121:1: ( rule__SymbolicPosition__Group__0__Impl rule__SymbolicPosition__Group__1 )
            // InternalMachine.g:4122:2: rule__SymbolicPosition__Group__0__Impl rule__SymbolicPosition__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__SymbolicPosition__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group__0"


    // $ANTLR start "rule__SymbolicPosition__Group__0__Impl"
    // InternalMachine.g:4129:1: rule__SymbolicPosition__Group__0__Impl : ( () ) ;
    public final void rule__SymbolicPosition__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4133:1: ( ( () ) )
            // InternalMachine.g:4134:1: ( () )
            {
            // InternalMachine.g:4134:1: ( () )
            // InternalMachine.g:4135:2: ()
            {
             before(grammarAccess.getSymbolicPositionAccess().getSymbolicPositionAction_0()); 
            // InternalMachine.g:4136:2: ()
            // InternalMachine.g:4136:3: 
            {
            }

             after(grammarAccess.getSymbolicPositionAccess().getSymbolicPositionAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group__0__Impl"


    // $ANTLR start "rule__SymbolicPosition__Group__1"
    // InternalMachine.g:4144:1: rule__SymbolicPosition__Group__1 : rule__SymbolicPosition__Group__1__Impl rule__SymbolicPosition__Group__2 ;
    public final void rule__SymbolicPosition__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4148:1: ( rule__SymbolicPosition__Group__1__Impl rule__SymbolicPosition__Group__2 )
            // InternalMachine.g:4149:2: rule__SymbolicPosition__Group__1__Impl rule__SymbolicPosition__Group__2
            {
            pushFollow(FOLLOW_26);
            rule__SymbolicPosition__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group__1"


    // $ANTLR start "rule__SymbolicPosition__Group__1__Impl"
    // InternalMachine.g:4156:1: rule__SymbolicPosition__Group__1__Impl : ( ( rule__SymbolicPosition__NameAssignment_1 ) ) ;
    public final void rule__SymbolicPosition__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4160:1: ( ( ( rule__SymbolicPosition__NameAssignment_1 ) ) )
            // InternalMachine.g:4161:1: ( ( rule__SymbolicPosition__NameAssignment_1 ) )
            {
            // InternalMachine.g:4161:1: ( ( rule__SymbolicPosition__NameAssignment_1 ) )
            // InternalMachine.g:4162:2: ( rule__SymbolicPosition__NameAssignment_1 )
            {
             before(grammarAccess.getSymbolicPositionAccess().getNameAssignment_1()); 
            // InternalMachine.g:4163:2: ( rule__SymbolicPosition__NameAssignment_1 )
            // InternalMachine.g:4163:3: rule__SymbolicPosition__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getSymbolicPositionAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group__1__Impl"


    // $ANTLR start "rule__SymbolicPosition__Group__2"
    // InternalMachine.g:4171:1: rule__SymbolicPosition__Group__2 : rule__SymbolicPosition__Group__2__Impl ;
    public final void rule__SymbolicPosition__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4175:1: ( rule__SymbolicPosition__Group__2__Impl )
            // InternalMachine.g:4176:2: rule__SymbolicPosition__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group__2"


    // $ANTLR start "rule__SymbolicPosition__Group__2__Impl"
    // InternalMachine.g:4182:1: rule__SymbolicPosition__Group__2__Impl : ( ( rule__SymbolicPosition__Group_2__0 )? ) ;
    public final void rule__SymbolicPosition__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4186:1: ( ( ( rule__SymbolicPosition__Group_2__0 )? ) )
            // InternalMachine.g:4187:1: ( ( rule__SymbolicPosition__Group_2__0 )? )
            {
            // InternalMachine.g:4187:1: ( ( rule__SymbolicPosition__Group_2__0 )? )
            // InternalMachine.g:4188:2: ( rule__SymbolicPosition__Group_2__0 )?
            {
             before(grammarAccess.getSymbolicPositionAccess().getGroup_2()); 
            // InternalMachine.g:4189:2: ( rule__SymbolicPosition__Group_2__0 )?
            int alt40=2;
            int LA40_0 = input.LA(1);

            if ( (LA40_0==26) ) {
                alt40=1;
            }
            switch (alt40) {
                case 1 :
                    // InternalMachine.g:4189:3: rule__SymbolicPosition__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__SymbolicPosition__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getSymbolicPositionAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group__2__Impl"


    // $ANTLR start "rule__SymbolicPosition__Group_2__0"
    // InternalMachine.g:4198:1: rule__SymbolicPosition__Group_2__0 : rule__SymbolicPosition__Group_2__0__Impl rule__SymbolicPosition__Group_2__1 ;
    public final void rule__SymbolicPosition__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4202:1: ( rule__SymbolicPosition__Group_2__0__Impl rule__SymbolicPosition__Group_2__1 )
            // InternalMachine.g:4203:2: rule__SymbolicPosition__Group_2__0__Impl rule__SymbolicPosition__Group_2__1
            {
            pushFollow(FOLLOW_6);
            rule__SymbolicPosition__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2__0"


    // $ANTLR start "rule__SymbolicPosition__Group_2__0__Impl"
    // InternalMachine.g:4210:1: rule__SymbolicPosition__Group_2__0__Impl : ( '(' ) ;
    public final void rule__SymbolicPosition__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4214:1: ( ( '(' ) )
            // InternalMachine.g:4215:1: ( '(' )
            {
            // InternalMachine.g:4215:1: ( '(' )
            // InternalMachine.g:4216:2: '('
            {
             before(grammarAccess.getSymbolicPositionAccess().getLeftParenthesisKeyword_2_0()); 
            match(input,26,FOLLOW_2); 
             after(grammarAccess.getSymbolicPositionAccess().getLeftParenthesisKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2__0__Impl"


    // $ANTLR start "rule__SymbolicPosition__Group_2__1"
    // InternalMachine.g:4225:1: rule__SymbolicPosition__Group_2__1 : rule__SymbolicPosition__Group_2__1__Impl rule__SymbolicPosition__Group_2__2 ;
    public final void rule__SymbolicPosition__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4229:1: ( rule__SymbolicPosition__Group_2__1__Impl rule__SymbolicPosition__Group_2__2 )
            // InternalMachine.g:4230:2: rule__SymbolicPosition__Group_2__1__Impl rule__SymbolicPosition__Group_2__2
            {
            pushFollow(FOLLOW_22);
            rule__SymbolicPosition__Group_2__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group_2__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2__1"


    // $ANTLR start "rule__SymbolicPosition__Group_2__1__Impl"
    // InternalMachine.g:4237:1: rule__SymbolicPosition__Group_2__1__Impl : ( ( rule__SymbolicPosition__AxisPositionAssignment_2_1 ) ) ;
    public final void rule__SymbolicPosition__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4241:1: ( ( ( rule__SymbolicPosition__AxisPositionAssignment_2_1 ) ) )
            // InternalMachine.g:4242:1: ( ( rule__SymbolicPosition__AxisPositionAssignment_2_1 ) )
            {
            // InternalMachine.g:4242:1: ( ( rule__SymbolicPosition__AxisPositionAssignment_2_1 ) )
            // InternalMachine.g:4243:2: ( rule__SymbolicPosition__AxisPositionAssignment_2_1 )
            {
             before(grammarAccess.getSymbolicPositionAccess().getAxisPositionAssignment_2_1()); 
            // InternalMachine.g:4244:2: ( rule__SymbolicPosition__AxisPositionAssignment_2_1 )
            // InternalMachine.g:4244:3: rule__SymbolicPosition__AxisPositionAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__AxisPositionAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getSymbolicPositionAccess().getAxisPositionAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2__1__Impl"


    // $ANTLR start "rule__SymbolicPosition__Group_2__2"
    // InternalMachine.g:4252:1: rule__SymbolicPosition__Group_2__2 : rule__SymbolicPosition__Group_2__2__Impl rule__SymbolicPosition__Group_2__3 ;
    public final void rule__SymbolicPosition__Group_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4256:1: ( rule__SymbolicPosition__Group_2__2__Impl rule__SymbolicPosition__Group_2__3 )
            // InternalMachine.g:4257:2: rule__SymbolicPosition__Group_2__2__Impl rule__SymbolicPosition__Group_2__3
            {
            pushFollow(FOLLOW_22);
            rule__SymbolicPosition__Group_2__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group_2__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2__2"


    // $ANTLR start "rule__SymbolicPosition__Group_2__2__Impl"
    // InternalMachine.g:4264:1: rule__SymbolicPosition__Group_2__2__Impl : ( ( rule__SymbolicPosition__Group_2_2__0 )* ) ;
    public final void rule__SymbolicPosition__Group_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4268:1: ( ( ( rule__SymbolicPosition__Group_2_2__0 )* ) )
            // InternalMachine.g:4269:1: ( ( rule__SymbolicPosition__Group_2_2__0 )* )
            {
            // InternalMachine.g:4269:1: ( ( rule__SymbolicPosition__Group_2_2__0 )* )
            // InternalMachine.g:4270:2: ( rule__SymbolicPosition__Group_2_2__0 )*
            {
             before(grammarAccess.getSymbolicPositionAccess().getGroup_2_2()); 
            // InternalMachine.g:4271:2: ( rule__SymbolicPosition__Group_2_2__0 )*
            loop41:
            do {
                int alt41=2;
                int LA41_0 = input.LA(1);

                if ( (LA41_0==24) ) {
                    alt41=1;
                }


                switch (alt41) {
            	case 1 :
            	    // InternalMachine.g:4271:3: rule__SymbolicPosition__Group_2_2__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__SymbolicPosition__Group_2_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop41;
                }
            } while (true);

             after(grammarAccess.getSymbolicPositionAccess().getGroup_2_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2__2__Impl"


    // $ANTLR start "rule__SymbolicPosition__Group_2__3"
    // InternalMachine.g:4279:1: rule__SymbolicPosition__Group_2__3 : rule__SymbolicPosition__Group_2__3__Impl ;
    public final void rule__SymbolicPosition__Group_2__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4283:1: ( rule__SymbolicPosition__Group_2__3__Impl )
            // InternalMachine.g:4284:2: rule__SymbolicPosition__Group_2__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group_2__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2__3"


    // $ANTLR start "rule__SymbolicPosition__Group_2__3__Impl"
    // InternalMachine.g:4290:1: rule__SymbolicPosition__Group_2__3__Impl : ( ')' ) ;
    public final void rule__SymbolicPosition__Group_2__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4294:1: ( ( ')' ) )
            // InternalMachine.g:4295:1: ( ')' )
            {
            // InternalMachine.g:4295:1: ( ')' )
            // InternalMachine.g:4296:2: ')'
            {
             before(grammarAccess.getSymbolicPositionAccess().getRightParenthesisKeyword_2_3()); 
            match(input,27,FOLLOW_2); 
             after(grammarAccess.getSymbolicPositionAccess().getRightParenthesisKeyword_2_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2__3__Impl"


    // $ANTLR start "rule__SymbolicPosition__Group_2_2__0"
    // InternalMachine.g:4306:1: rule__SymbolicPosition__Group_2_2__0 : rule__SymbolicPosition__Group_2_2__0__Impl rule__SymbolicPosition__Group_2_2__1 ;
    public final void rule__SymbolicPosition__Group_2_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4310:1: ( rule__SymbolicPosition__Group_2_2__0__Impl rule__SymbolicPosition__Group_2_2__1 )
            // InternalMachine.g:4311:2: rule__SymbolicPosition__Group_2_2__0__Impl rule__SymbolicPosition__Group_2_2__1
            {
            pushFollow(FOLLOW_6);
            rule__SymbolicPosition__Group_2_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group_2_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2_2__0"


    // $ANTLR start "rule__SymbolicPosition__Group_2_2__0__Impl"
    // InternalMachine.g:4318:1: rule__SymbolicPosition__Group_2_2__0__Impl : ( ',' ) ;
    public final void rule__SymbolicPosition__Group_2_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4322:1: ( ( ',' ) )
            // InternalMachine.g:4323:1: ( ',' )
            {
            // InternalMachine.g:4323:1: ( ',' )
            // InternalMachine.g:4324:2: ','
            {
             before(grammarAccess.getSymbolicPositionAccess().getCommaKeyword_2_2_0()); 
            match(input,24,FOLLOW_2); 
             after(grammarAccess.getSymbolicPositionAccess().getCommaKeyword_2_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2_2__0__Impl"


    // $ANTLR start "rule__SymbolicPosition__Group_2_2__1"
    // InternalMachine.g:4333:1: rule__SymbolicPosition__Group_2_2__1 : rule__SymbolicPosition__Group_2_2__1__Impl ;
    public final void rule__SymbolicPosition__Group_2_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4337:1: ( rule__SymbolicPosition__Group_2_2__1__Impl )
            // InternalMachine.g:4338:2: rule__SymbolicPosition__Group_2_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__Group_2_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2_2__1"


    // $ANTLR start "rule__SymbolicPosition__Group_2_2__1__Impl"
    // InternalMachine.g:4344:1: rule__SymbolicPosition__Group_2_2__1__Impl : ( ( rule__SymbolicPosition__AxisPositionAssignment_2_2_1 ) ) ;
    public final void rule__SymbolicPosition__Group_2_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4348:1: ( ( ( rule__SymbolicPosition__AxisPositionAssignment_2_2_1 ) ) )
            // InternalMachine.g:4349:1: ( ( rule__SymbolicPosition__AxisPositionAssignment_2_2_1 ) )
            {
            // InternalMachine.g:4349:1: ( ( rule__SymbolicPosition__AxisPositionAssignment_2_2_1 ) )
            // InternalMachine.g:4350:2: ( rule__SymbolicPosition__AxisPositionAssignment_2_2_1 )
            {
             before(grammarAccess.getSymbolicPositionAccess().getAxisPositionAssignment_2_2_1()); 
            // InternalMachine.g:4351:2: ( rule__SymbolicPosition__AxisPositionAssignment_2_2_1 )
            // InternalMachine.g:4351:3: rule__SymbolicPosition__AxisPositionAssignment_2_2_1
            {
            pushFollow(FOLLOW_2);
            rule__SymbolicPosition__AxisPositionAssignment_2_2_1();

            state._fsp--;


            }

             after(grammarAccess.getSymbolicPositionAccess().getAxisPositionAssignment_2_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__Group_2_2__1__Impl"


    // $ANTLR start "rule__AxisPositionMapEntry__Group__0"
    // InternalMachine.g:4360:1: rule__AxisPositionMapEntry__Group__0 : rule__AxisPositionMapEntry__Group__0__Impl rule__AxisPositionMapEntry__Group__1 ;
    public final void rule__AxisPositionMapEntry__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4364:1: ( rule__AxisPositionMapEntry__Group__0__Impl rule__AxisPositionMapEntry__Group__1 )
            // InternalMachine.g:4365:2: rule__AxisPositionMapEntry__Group__0__Impl rule__AxisPositionMapEntry__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__AxisPositionMapEntry__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AxisPositionMapEntry__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__Group__0"


    // $ANTLR start "rule__AxisPositionMapEntry__Group__0__Impl"
    // InternalMachine.g:4372:1: rule__AxisPositionMapEntry__Group__0__Impl : ( () ) ;
    public final void rule__AxisPositionMapEntry__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4376:1: ( ( () ) )
            // InternalMachine.g:4377:1: ( () )
            {
            // InternalMachine.g:4377:1: ( () )
            // InternalMachine.g:4378:2: ()
            {
             before(grammarAccess.getAxisPositionMapEntryAccess().getAxisPositionMapEntryAction_0()); 
            // InternalMachine.g:4379:2: ()
            // InternalMachine.g:4379:3: 
            {
            }

             after(grammarAccess.getAxisPositionMapEntryAccess().getAxisPositionMapEntryAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__Group__0__Impl"


    // $ANTLR start "rule__AxisPositionMapEntry__Group__1"
    // InternalMachine.g:4387:1: rule__AxisPositionMapEntry__Group__1 : rule__AxisPositionMapEntry__Group__1__Impl rule__AxisPositionMapEntry__Group__2 ;
    public final void rule__AxisPositionMapEntry__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4391:1: ( rule__AxisPositionMapEntry__Group__1__Impl rule__AxisPositionMapEntry__Group__2 )
            // InternalMachine.g:4392:2: rule__AxisPositionMapEntry__Group__1__Impl rule__AxisPositionMapEntry__Group__2
            {
            pushFollow(FOLLOW_31);
            rule__AxisPositionMapEntry__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AxisPositionMapEntry__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__Group__1"


    // $ANTLR start "rule__AxisPositionMapEntry__Group__1__Impl"
    // InternalMachine.g:4399:1: rule__AxisPositionMapEntry__Group__1__Impl : ( ( rule__AxisPositionMapEntry__KeyAssignment_1 ) ) ;
    public final void rule__AxisPositionMapEntry__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4403:1: ( ( ( rule__AxisPositionMapEntry__KeyAssignment_1 ) ) )
            // InternalMachine.g:4404:1: ( ( rule__AxisPositionMapEntry__KeyAssignment_1 ) )
            {
            // InternalMachine.g:4404:1: ( ( rule__AxisPositionMapEntry__KeyAssignment_1 ) )
            // InternalMachine.g:4405:2: ( rule__AxisPositionMapEntry__KeyAssignment_1 )
            {
             before(grammarAccess.getAxisPositionMapEntryAccess().getKeyAssignment_1()); 
            // InternalMachine.g:4406:2: ( rule__AxisPositionMapEntry__KeyAssignment_1 )
            // InternalMachine.g:4406:3: rule__AxisPositionMapEntry__KeyAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionMapEntry__KeyAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getAxisPositionMapEntryAccess().getKeyAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__Group__1__Impl"


    // $ANTLR start "rule__AxisPositionMapEntry__Group__2"
    // InternalMachine.g:4414:1: rule__AxisPositionMapEntry__Group__2 : rule__AxisPositionMapEntry__Group__2__Impl rule__AxisPositionMapEntry__Group__3 ;
    public final void rule__AxisPositionMapEntry__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4418:1: ( rule__AxisPositionMapEntry__Group__2__Impl rule__AxisPositionMapEntry__Group__3 )
            // InternalMachine.g:4419:2: rule__AxisPositionMapEntry__Group__2__Impl rule__AxisPositionMapEntry__Group__3
            {
            pushFollow(FOLLOW_6);
            rule__AxisPositionMapEntry__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__AxisPositionMapEntry__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__Group__2"


    // $ANTLR start "rule__AxisPositionMapEntry__Group__2__Impl"
    // InternalMachine.g:4426:1: rule__AxisPositionMapEntry__Group__2__Impl : ( '.' ) ;
    public final void rule__AxisPositionMapEntry__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4430:1: ( ( '.' ) )
            // InternalMachine.g:4431:1: ( '.' )
            {
            // InternalMachine.g:4431:1: ( '.' )
            // InternalMachine.g:4432:2: '.'
            {
             before(grammarAccess.getAxisPositionMapEntryAccess().getFullStopKeyword_2()); 
            match(input,34,FOLLOW_2); 
             after(grammarAccess.getAxisPositionMapEntryAccess().getFullStopKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__Group__2__Impl"


    // $ANTLR start "rule__AxisPositionMapEntry__Group__3"
    // InternalMachine.g:4441:1: rule__AxisPositionMapEntry__Group__3 : rule__AxisPositionMapEntry__Group__3__Impl ;
    public final void rule__AxisPositionMapEntry__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4445:1: ( rule__AxisPositionMapEntry__Group__3__Impl )
            // InternalMachine.g:4446:2: rule__AxisPositionMapEntry__Group__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionMapEntry__Group__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__Group__3"


    // $ANTLR start "rule__AxisPositionMapEntry__Group__3__Impl"
    // InternalMachine.g:4452:1: rule__AxisPositionMapEntry__Group__3__Impl : ( ( rule__AxisPositionMapEntry__ValueAssignment_3 ) ) ;
    public final void rule__AxisPositionMapEntry__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4456:1: ( ( ( rule__AxisPositionMapEntry__ValueAssignment_3 ) ) )
            // InternalMachine.g:4457:1: ( ( rule__AxisPositionMapEntry__ValueAssignment_3 ) )
            {
            // InternalMachine.g:4457:1: ( ( rule__AxisPositionMapEntry__ValueAssignment_3 ) )
            // InternalMachine.g:4458:2: ( rule__AxisPositionMapEntry__ValueAssignment_3 )
            {
             before(grammarAccess.getAxisPositionMapEntryAccess().getValueAssignment_3()); 
            // InternalMachine.g:4459:2: ( rule__AxisPositionMapEntry__ValueAssignment_3 )
            // InternalMachine.g:4459:3: rule__AxisPositionMapEntry__ValueAssignment_3
            {
            pushFollow(FOLLOW_2);
            rule__AxisPositionMapEntry__ValueAssignment_3();

            state._fsp--;


            }

             after(grammarAccess.getAxisPositionMapEntryAccess().getValueAssignment_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__Group__3__Impl"


    // $ANTLR start "rule__Profile__Group__0"
    // InternalMachine.g:4468:1: rule__Profile__Group__0 : rule__Profile__Group__0__Impl rule__Profile__Group__1 ;
    public final void rule__Profile__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4472:1: ( rule__Profile__Group__0__Impl rule__Profile__Group__1 )
            // InternalMachine.g:4473:2: rule__Profile__Group__0__Impl rule__Profile__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__Profile__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__Profile__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Profile__Group__0"


    // $ANTLR start "rule__Profile__Group__0__Impl"
    // InternalMachine.g:4480:1: rule__Profile__Group__0__Impl : ( () ) ;
    public final void rule__Profile__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4484:1: ( ( () ) )
            // InternalMachine.g:4485:1: ( () )
            {
            // InternalMachine.g:4485:1: ( () )
            // InternalMachine.g:4486:2: ()
            {
             before(grammarAccess.getProfileAccess().getProfileAction_0()); 
            // InternalMachine.g:4487:2: ()
            // InternalMachine.g:4487:3: 
            {
            }

             after(grammarAccess.getProfileAccess().getProfileAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Profile__Group__0__Impl"


    // $ANTLR start "rule__Profile__Group__1"
    // InternalMachine.g:4495:1: rule__Profile__Group__1 : rule__Profile__Group__1__Impl ;
    public final void rule__Profile__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4499:1: ( rule__Profile__Group__1__Impl )
            // InternalMachine.g:4500:2: rule__Profile__Group__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__Profile__Group__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Profile__Group__1"


    // $ANTLR start "rule__Profile__Group__1__Impl"
    // InternalMachine.g:4506:1: rule__Profile__Group__1__Impl : ( ( rule__Profile__NameAssignment_1 ) ) ;
    public final void rule__Profile__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4510:1: ( ( ( rule__Profile__NameAssignment_1 ) ) )
            // InternalMachine.g:4511:1: ( ( rule__Profile__NameAssignment_1 ) )
            {
            // InternalMachine.g:4511:1: ( ( rule__Profile__NameAssignment_1 ) )
            // InternalMachine.g:4512:2: ( rule__Profile__NameAssignment_1 )
            {
             before(grammarAccess.getProfileAccess().getNameAssignment_1()); 
            // InternalMachine.g:4513:2: ( rule__Profile__NameAssignment_1 )
            // InternalMachine.g:4513:3: rule__Profile__NameAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__Profile__NameAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getProfileAccess().getNameAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Profile__Group__1__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group__0"
    // InternalMachine.g:4522:1: rule__UnidirectionalPath__Group__0 : rule__UnidirectionalPath__Group__0__Impl rule__UnidirectionalPath__Group__1 ;
    public final void rule__UnidirectionalPath__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4526:1: ( rule__UnidirectionalPath__Group__0__Impl rule__UnidirectionalPath__Group__1 )
            // InternalMachine.g:4527:2: rule__UnidirectionalPath__Group__0__Impl rule__UnidirectionalPath__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__UnidirectionalPath__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__0"


    // $ANTLR start "rule__UnidirectionalPath__Group__0__Impl"
    // InternalMachine.g:4534:1: rule__UnidirectionalPath__Group__0__Impl : ( () ) ;
    public final void rule__UnidirectionalPath__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4538:1: ( ( () ) )
            // InternalMachine.g:4539:1: ( () )
            {
            // InternalMachine.g:4539:1: ( () )
            // InternalMachine.g:4540:2: ()
            {
             before(grammarAccess.getUnidirectionalPathAccess().getUnidirectionalPathAction_0()); 
            // InternalMachine.g:4541:2: ()
            // InternalMachine.g:4541:3: 
            {
            }

             after(grammarAccess.getUnidirectionalPathAccess().getUnidirectionalPathAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__0__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group__1"
    // InternalMachine.g:4549:1: rule__UnidirectionalPath__Group__1 : rule__UnidirectionalPath__Group__1__Impl rule__UnidirectionalPath__Group__2 ;
    public final void rule__UnidirectionalPath__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4553:1: ( rule__UnidirectionalPath__Group__1__Impl rule__UnidirectionalPath__Group__2 )
            // InternalMachine.g:4554:2: rule__UnidirectionalPath__Group__1__Impl rule__UnidirectionalPath__Group__2
            {
            pushFollow(FOLLOW_32);
            rule__UnidirectionalPath__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__1"


    // $ANTLR start "rule__UnidirectionalPath__Group__1__Impl"
    // InternalMachine.g:4561:1: rule__UnidirectionalPath__Group__1__Impl : ( ( rule__UnidirectionalPath__SourceAssignment_1 ) ) ;
    public final void rule__UnidirectionalPath__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4565:1: ( ( ( rule__UnidirectionalPath__SourceAssignment_1 ) ) )
            // InternalMachine.g:4566:1: ( ( rule__UnidirectionalPath__SourceAssignment_1 ) )
            {
            // InternalMachine.g:4566:1: ( ( rule__UnidirectionalPath__SourceAssignment_1 ) )
            // InternalMachine.g:4567:2: ( rule__UnidirectionalPath__SourceAssignment_1 )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getSourceAssignment_1()); 
            // InternalMachine.g:4568:2: ( rule__UnidirectionalPath__SourceAssignment_1 )
            // InternalMachine.g:4568:3: rule__UnidirectionalPath__SourceAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__SourceAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getUnidirectionalPathAccess().getSourceAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__1__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group__2"
    // InternalMachine.g:4576:1: rule__UnidirectionalPath__Group__2 : rule__UnidirectionalPath__Group__2__Impl rule__UnidirectionalPath__Group__3 ;
    public final void rule__UnidirectionalPath__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4580:1: ( rule__UnidirectionalPath__Group__2__Impl rule__UnidirectionalPath__Group__3 )
            // InternalMachine.g:4581:2: rule__UnidirectionalPath__Group__2__Impl rule__UnidirectionalPath__Group__3
            {
            pushFollow(FOLLOW_6);
            rule__UnidirectionalPath__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__2"


    // $ANTLR start "rule__UnidirectionalPath__Group__2__Impl"
    // InternalMachine.g:4588:1: rule__UnidirectionalPath__Group__2__Impl : ( '-->' ) ;
    public final void rule__UnidirectionalPath__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4592:1: ( ( '-->' ) )
            // InternalMachine.g:4593:1: ( '-->' )
            {
            // InternalMachine.g:4593:1: ( '-->' )
            // InternalMachine.g:4594:2: '-->'
            {
             before(grammarAccess.getUnidirectionalPathAccess().getHyphenMinusHyphenMinusGreaterThanSignKeyword_2()); 
            match(input,35,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getHyphenMinusHyphenMinusGreaterThanSignKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__2__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group__3"
    // InternalMachine.g:4603:1: rule__UnidirectionalPath__Group__3 : rule__UnidirectionalPath__Group__3__Impl rule__UnidirectionalPath__Group__4 ;
    public final void rule__UnidirectionalPath__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4607:1: ( rule__UnidirectionalPath__Group__3__Impl rule__UnidirectionalPath__Group__4 )
            // InternalMachine.g:4608:2: rule__UnidirectionalPath__Group__3__Impl rule__UnidirectionalPath__Group__4
            {
            pushFollow(FOLLOW_33);
            rule__UnidirectionalPath__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__3"


    // $ANTLR start "rule__UnidirectionalPath__Group__3__Impl"
    // InternalMachine.g:4615:1: rule__UnidirectionalPath__Group__3__Impl : ( ( rule__UnidirectionalPath__TargetAssignment_3 ) ) ;
    public final void rule__UnidirectionalPath__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4619:1: ( ( ( rule__UnidirectionalPath__TargetAssignment_3 ) ) )
            // InternalMachine.g:4620:1: ( ( rule__UnidirectionalPath__TargetAssignment_3 ) )
            {
            // InternalMachine.g:4620:1: ( ( rule__UnidirectionalPath__TargetAssignment_3 ) )
            // InternalMachine.g:4621:2: ( rule__UnidirectionalPath__TargetAssignment_3 )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getTargetAssignment_3()); 
            // InternalMachine.g:4622:2: ( rule__UnidirectionalPath__TargetAssignment_3 )
            // InternalMachine.g:4622:3: rule__UnidirectionalPath__TargetAssignment_3
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__TargetAssignment_3();

            state._fsp--;


            }

             after(grammarAccess.getUnidirectionalPathAccess().getTargetAssignment_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__3__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group__4"
    // InternalMachine.g:4630:1: rule__UnidirectionalPath__Group__4 : rule__UnidirectionalPath__Group__4__Impl rule__UnidirectionalPath__Group__5 ;
    public final void rule__UnidirectionalPath__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4634:1: ( rule__UnidirectionalPath__Group__4__Impl rule__UnidirectionalPath__Group__5 )
            // InternalMachine.g:4635:2: rule__UnidirectionalPath__Group__4__Impl rule__UnidirectionalPath__Group__5
            {
            pushFollow(FOLLOW_34);
            rule__UnidirectionalPath__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__4"


    // $ANTLR start "rule__UnidirectionalPath__Group__4__Impl"
    // InternalMachine.g:4642:1: rule__UnidirectionalPath__Group__4__Impl : ( ( rule__UnidirectionalPath__Alternatives_4 ) ) ;
    public final void rule__UnidirectionalPath__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4646:1: ( ( ( rule__UnidirectionalPath__Alternatives_4 ) ) )
            // InternalMachine.g:4647:1: ( ( rule__UnidirectionalPath__Alternatives_4 ) )
            {
            // InternalMachine.g:4647:1: ( ( rule__UnidirectionalPath__Alternatives_4 ) )
            // InternalMachine.g:4648:2: ( rule__UnidirectionalPath__Alternatives_4 )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getAlternatives_4()); 
            // InternalMachine.g:4649:2: ( rule__UnidirectionalPath__Alternatives_4 )
            // InternalMachine.g:4649:3: rule__UnidirectionalPath__Alternatives_4
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Alternatives_4();

            state._fsp--;


            }

             after(grammarAccess.getUnidirectionalPathAccess().getAlternatives_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__4__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group__5"
    // InternalMachine.g:4657:1: rule__UnidirectionalPath__Group__5 : rule__UnidirectionalPath__Group__5__Impl ;
    public final void rule__UnidirectionalPath__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4661:1: ( rule__UnidirectionalPath__Group__5__Impl )
            // InternalMachine.g:4662:2: rule__UnidirectionalPath__Group__5__Impl
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group__5__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__5"


    // $ANTLR start "rule__UnidirectionalPath__Group__5__Impl"
    // InternalMachine.g:4668:1: rule__UnidirectionalPath__Group__5__Impl : ( ( rule__UnidirectionalPath__Group_5__0 )* ) ;
    public final void rule__UnidirectionalPath__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4672:1: ( ( ( rule__UnidirectionalPath__Group_5__0 )* ) )
            // InternalMachine.g:4673:1: ( ( rule__UnidirectionalPath__Group_5__0 )* )
            {
            // InternalMachine.g:4673:1: ( ( rule__UnidirectionalPath__Group_5__0 )* )
            // InternalMachine.g:4674:2: ( rule__UnidirectionalPath__Group_5__0 )*
            {
             before(grammarAccess.getUnidirectionalPathAccess().getGroup_5()); 
            // InternalMachine.g:4675:2: ( rule__UnidirectionalPath__Group_5__0 )*
            loop42:
            do {
                int alt42=2;
                int LA42_0 = input.LA(1);

                if ( (LA42_0==38) ) {
                    alt42=1;
                }


                switch (alt42) {
            	case 1 :
            	    // InternalMachine.g:4675:3: rule__UnidirectionalPath__Group_5__0
            	    {
            	    pushFollow(FOLLOW_35);
            	    rule__UnidirectionalPath__Group_5__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop42;
                }
            } while (true);

             after(grammarAccess.getUnidirectionalPathAccess().getGroup_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group__5__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0__0"
    // InternalMachine.g:4684:1: rule__UnidirectionalPath__Group_4_0__0 : rule__UnidirectionalPath__Group_4_0__0__Impl rule__UnidirectionalPath__Group_4_0__1 ;
    public final void rule__UnidirectionalPath__Group_4_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4688:1: ( rule__UnidirectionalPath__Group_4_0__0__Impl rule__UnidirectionalPath__Group_4_0__1 )
            // InternalMachine.g:4689:2: rule__UnidirectionalPath__Group_4_0__0__Impl rule__UnidirectionalPath__Group_4_0__1
            {
            pushFollow(FOLLOW_6);
            rule__UnidirectionalPath__Group_4_0__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group_4_0__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0__0"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0__0__Impl"
    // InternalMachine.g:4696:1: rule__UnidirectionalPath__Group_4_0__0__Impl : ( 'profiles' ) ;
    public final void rule__UnidirectionalPath__Group_4_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4700:1: ( ( 'profiles' ) )
            // InternalMachine.g:4701:1: ( 'profiles' )
            {
            // InternalMachine.g:4701:1: ( 'profiles' )
            // InternalMachine.g:4702:2: 'profiles'
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesKeyword_4_0_0()); 
            match(input,36,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getProfilesKeyword_4_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0__0__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0__1"
    // InternalMachine.g:4711:1: rule__UnidirectionalPath__Group_4_0__1 : rule__UnidirectionalPath__Group_4_0__1__Impl rule__UnidirectionalPath__Group_4_0__2 ;
    public final void rule__UnidirectionalPath__Group_4_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4715:1: ( rule__UnidirectionalPath__Group_4_0__1__Impl rule__UnidirectionalPath__Group_4_0__2 )
            // InternalMachine.g:4716:2: rule__UnidirectionalPath__Group_4_0__1__Impl rule__UnidirectionalPath__Group_4_0__2
            {
            pushFollow(FOLLOW_18);
            rule__UnidirectionalPath__Group_4_0__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group_4_0__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0__1"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0__1__Impl"
    // InternalMachine.g:4723:1: rule__UnidirectionalPath__Group_4_0__1__Impl : ( ( rule__UnidirectionalPath__ProfilesAssignment_4_0_1 ) ) ;
    public final void rule__UnidirectionalPath__Group_4_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4727:1: ( ( ( rule__UnidirectionalPath__ProfilesAssignment_4_0_1 ) ) )
            // InternalMachine.g:4728:1: ( ( rule__UnidirectionalPath__ProfilesAssignment_4_0_1 ) )
            {
            // InternalMachine.g:4728:1: ( ( rule__UnidirectionalPath__ProfilesAssignment_4_0_1 ) )
            // InternalMachine.g:4729:2: ( rule__UnidirectionalPath__ProfilesAssignment_4_0_1 )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesAssignment_4_0_1()); 
            // InternalMachine.g:4730:2: ( rule__UnidirectionalPath__ProfilesAssignment_4_0_1 )
            // InternalMachine.g:4730:3: rule__UnidirectionalPath__ProfilesAssignment_4_0_1
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__ProfilesAssignment_4_0_1();

            state._fsp--;


            }

             after(grammarAccess.getUnidirectionalPathAccess().getProfilesAssignment_4_0_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0__1__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0__2"
    // InternalMachine.g:4738:1: rule__UnidirectionalPath__Group_4_0__2 : rule__UnidirectionalPath__Group_4_0__2__Impl ;
    public final void rule__UnidirectionalPath__Group_4_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4742:1: ( rule__UnidirectionalPath__Group_4_0__2__Impl )
            // InternalMachine.g:4743:2: rule__UnidirectionalPath__Group_4_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group_4_0__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0__2"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0__2__Impl"
    // InternalMachine.g:4749:1: rule__UnidirectionalPath__Group_4_0__2__Impl : ( ( rule__UnidirectionalPath__Group_4_0_2__0 )* ) ;
    public final void rule__UnidirectionalPath__Group_4_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4753:1: ( ( ( rule__UnidirectionalPath__Group_4_0_2__0 )* ) )
            // InternalMachine.g:4754:1: ( ( rule__UnidirectionalPath__Group_4_0_2__0 )* )
            {
            // InternalMachine.g:4754:1: ( ( rule__UnidirectionalPath__Group_4_0_2__0 )* )
            // InternalMachine.g:4755:2: ( rule__UnidirectionalPath__Group_4_0_2__0 )*
            {
             before(grammarAccess.getUnidirectionalPathAccess().getGroup_4_0_2()); 
            // InternalMachine.g:4756:2: ( rule__UnidirectionalPath__Group_4_0_2__0 )*
            loop43:
            do {
                int alt43=2;
                int LA43_0 = input.LA(1);

                if ( (LA43_0==24) ) {
                    alt43=1;
                }


                switch (alt43) {
            	case 1 :
            	    // InternalMachine.g:4756:3: rule__UnidirectionalPath__Group_4_0_2__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__UnidirectionalPath__Group_4_0_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop43;
                }
            } while (true);

             after(grammarAccess.getUnidirectionalPathAccess().getGroup_4_0_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0__2__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0_2__0"
    // InternalMachine.g:4765:1: rule__UnidirectionalPath__Group_4_0_2__0 : rule__UnidirectionalPath__Group_4_0_2__0__Impl rule__UnidirectionalPath__Group_4_0_2__1 ;
    public final void rule__UnidirectionalPath__Group_4_0_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4769:1: ( rule__UnidirectionalPath__Group_4_0_2__0__Impl rule__UnidirectionalPath__Group_4_0_2__1 )
            // InternalMachine.g:4770:2: rule__UnidirectionalPath__Group_4_0_2__0__Impl rule__UnidirectionalPath__Group_4_0_2__1
            {
            pushFollow(FOLLOW_6);
            rule__UnidirectionalPath__Group_4_0_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group_4_0_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0_2__0"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0_2__0__Impl"
    // InternalMachine.g:4777:1: rule__UnidirectionalPath__Group_4_0_2__0__Impl : ( ',' ) ;
    public final void rule__UnidirectionalPath__Group_4_0_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4781:1: ( ( ',' ) )
            // InternalMachine.g:4782:1: ( ',' )
            {
            // InternalMachine.g:4782:1: ( ',' )
            // InternalMachine.g:4783:2: ','
            {
             before(grammarAccess.getUnidirectionalPathAccess().getCommaKeyword_4_0_2_0()); 
            match(input,24,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getCommaKeyword_4_0_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0_2__0__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0_2__1"
    // InternalMachine.g:4792:1: rule__UnidirectionalPath__Group_4_0_2__1 : rule__UnidirectionalPath__Group_4_0_2__1__Impl ;
    public final void rule__UnidirectionalPath__Group_4_0_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4796:1: ( rule__UnidirectionalPath__Group_4_0_2__1__Impl )
            // InternalMachine.g:4797:2: rule__UnidirectionalPath__Group_4_0_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group_4_0_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0_2__1"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_0_2__1__Impl"
    // InternalMachine.g:4803:1: rule__UnidirectionalPath__Group_4_0_2__1__Impl : ( ( rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1 ) ) ;
    public final void rule__UnidirectionalPath__Group_4_0_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4807:1: ( ( ( rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1 ) ) )
            // InternalMachine.g:4808:1: ( ( rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1 ) )
            {
            // InternalMachine.g:4808:1: ( ( rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1 ) )
            // InternalMachine.g:4809:2: ( rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1 )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesAssignment_4_0_2_1()); 
            // InternalMachine.g:4810:2: ( rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1 )
            // InternalMachine.g:4810:3: rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1();

            state._fsp--;


            }

             after(grammarAccess.getUnidirectionalPathAccess().getProfilesAssignment_4_0_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_0_2__1__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_1__0"
    // InternalMachine.g:4819:1: rule__UnidirectionalPath__Group_4_1__0 : rule__UnidirectionalPath__Group_4_1__0__Impl rule__UnidirectionalPath__Group_4_1__1 ;
    public final void rule__UnidirectionalPath__Group_4_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4823:1: ( rule__UnidirectionalPath__Group_4_1__0__Impl rule__UnidirectionalPath__Group_4_1__1 )
            // InternalMachine.g:4824:2: rule__UnidirectionalPath__Group_4_1__0__Impl rule__UnidirectionalPath__Group_4_1__1
            {
            pushFollow(FOLLOW_6);
            rule__UnidirectionalPath__Group_4_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group_4_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_1__0"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_1__0__Impl"
    // InternalMachine.g:4831:1: rule__UnidirectionalPath__Group_4_1__0__Impl : ( 'profile' ) ;
    public final void rule__UnidirectionalPath__Group_4_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4835:1: ( ( 'profile' ) )
            // InternalMachine.g:4836:1: ( 'profile' )
            {
            // InternalMachine.g:4836:1: ( 'profile' )
            // InternalMachine.g:4837:2: 'profile'
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfileKeyword_4_1_0()); 
            match(input,37,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getProfileKeyword_4_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_1__0__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_1__1"
    // InternalMachine.g:4846:1: rule__UnidirectionalPath__Group_4_1__1 : rule__UnidirectionalPath__Group_4_1__1__Impl ;
    public final void rule__UnidirectionalPath__Group_4_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4850:1: ( rule__UnidirectionalPath__Group_4_1__1__Impl )
            // InternalMachine.g:4851:2: rule__UnidirectionalPath__Group_4_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group_4_1__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_1__1"


    // $ANTLR start "rule__UnidirectionalPath__Group_4_1__1__Impl"
    // InternalMachine.g:4857:1: rule__UnidirectionalPath__Group_4_1__1__Impl : ( ( rule__UnidirectionalPath__ProfilesAssignment_4_1_1 ) ) ;
    public final void rule__UnidirectionalPath__Group_4_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4861:1: ( ( ( rule__UnidirectionalPath__ProfilesAssignment_4_1_1 ) ) )
            // InternalMachine.g:4862:1: ( ( rule__UnidirectionalPath__ProfilesAssignment_4_1_1 ) )
            {
            // InternalMachine.g:4862:1: ( ( rule__UnidirectionalPath__ProfilesAssignment_4_1_1 ) )
            // InternalMachine.g:4863:2: ( rule__UnidirectionalPath__ProfilesAssignment_4_1_1 )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesAssignment_4_1_1()); 
            // InternalMachine.g:4864:2: ( rule__UnidirectionalPath__ProfilesAssignment_4_1_1 )
            // InternalMachine.g:4864:3: rule__UnidirectionalPath__ProfilesAssignment_4_1_1
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__ProfilesAssignment_4_1_1();

            state._fsp--;


            }

             after(grammarAccess.getUnidirectionalPathAccess().getProfilesAssignment_4_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_4_1__1__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group_5__0"
    // InternalMachine.g:4873:1: rule__UnidirectionalPath__Group_5__0 : rule__UnidirectionalPath__Group_5__0__Impl rule__UnidirectionalPath__Group_5__1 ;
    public final void rule__UnidirectionalPath__Group_5__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4877:1: ( rule__UnidirectionalPath__Group_5__0__Impl rule__UnidirectionalPath__Group_5__1 )
            // InternalMachine.g:4878:2: rule__UnidirectionalPath__Group_5__0__Impl rule__UnidirectionalPath__Group_5__1
            {
            pushFollow(FOLLOW_6);
            rule__UnidirectionalPath__Group_5__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group_5__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_5__0"


    // $ANTLR start "rule__UnidirectionalPath__Group_5__0__Impl"
    // InternalMachine.g:4885:1: rule__UnidirectionalPath__Group_5__0__Impl : ( '@' ) ;
    public final void rule__UnidirectionalPath__Group_5__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4889:1: ( ( '@' ) )
            // InternalMachine.g:4890:1: ( '@' )
            {
            // InternalMachine.g:4890:1: ( '@' )
            // InternalMachine.g:4891:2: '@'
            {
             before(grammarAccess.getUnidirectionalPathAccess().getCommercialAtKeyword_5_0()); 
            match(input,38,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getCommercialAtKeyword_5_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_5__0__Impl"


    // $ANTLR start "rule__UnidirectionalPath__Group_5__1"
    // InternalMachine.g:4900:1: rule__UnidirectionalPath__Group_5__1 : rule__UnidirectionalPath__Group_5__1__Impl ;
    public final void rule__UnidirectionalPath__Group_5__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4904:1: ( rule__UnidirectionalPath__Group_5__1__Impl )
            // InternalMachine.g:4905:2: rule__UnidirectionalPath__Group_5__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__Group_5__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_5__1"


    // $ANTLR start "rule__UnidirectionalPath__Group_5__1__Impl"
    // InternalMachine.g:4911:1: rule__UnidirectionalPath__Group_5__1__Impl : ( ( rule__UnidirectionalPath__AnnotationsAssignment_5_1 ) ) ;
    public final void rule__UnidirectionalPath__Group_5__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4915:1: ( ( ( rule__UnidirectionalPath__AnnotationsAssignment_5_1 ) ) )
            // InternalMachine.g:4916:1: ( ( rule__UnidirectionalPath__AnnotationsAssignment_5_1 ) )
            {
            // InternalMachine.g:4916:1: ( ( rule__UnidirectionalPath__AnnotationsAssignment_5_1 ) )
            // InternalMachine.g:4917:2: ( rule__UnidirectionalPath__AnnotationsAssignment_5_1 )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getAnnotationsAssignment_5_1()); 
            // InternalMachine.g:4918:2: ( rule__UnidirectionalPath__AnnotationsAssignment_5_1 )
            // InternalMachine.g:4918:3: rule__UnidirectionalPath__AnnotationsAssignment_5_1
            {
            pushFollow(FOLLOW_2);
            rule__UnidirectionalPath__AnnotationsAssignment_5_1();

            state._fsp--;


            }

             after(grammarAccess.getUnidirectionalPathAccess().getAnnotationsAssignment_5_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__Group_5__1__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group__0"
    // InternalMachine.g:4927:1: rule__BidirectionalPath__Group__0 : rule__BidirectionalPath__Group__0__Impl rule__BidirectionalPath__Group__1 ;
    public final void rule__BidirectionalPath__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4931:1: ( rule__BidirectionalPath__Group__0__Impl rule__BidirectionalPath__Group__1 )
            // InternalMachine.g:4932:2: rule__BidirectionalPath__Group__0__Impl rule__BidirectionalPath__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__BidirectionalPath__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__0"


    // $ANTLR start "rule__BidirectionalPath__Group__0__Impl"
    // InternalMachine.g:4939:1: rule__BidirectionalPath__Group__0__Impl : ( () ) ;
    public final void rule__BidirectionalPath__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4943:1: ( ( () ) )
            // InternalMachine.g:4944:1: ( () )
            {
            // InternalMachine.g:4944:1: ( () )
            // InternalMachine.g:4945:2: ()
            {
             before(grammarAccess.getBidirectionalPathAccess().getBidirectionalPathAction_0()); 
            // InternalMachine.g:4946:2: ()
            // InternalMachine.g:4946:3: 
            {
            }

             after(grammarAccess.getBidirectionalPathAccess().getBidirectionalPathAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__0__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group__1"
    // InternalMachine.g:4954:1: rule__BidirectionalPath__Group__1 : rule__BidirectionalPath__Group__1__Impl rule__BidirectionalPath__Group__2 ;
    public final void rule__BidirectionalPath__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4958:1: ( rule__BidirectionalPath__Group__1__Impl rule__BidirectionalPath__Group__2 )
            // InternalMachine.g:4959:2: rule__BidirectionalPath__Group__1__Impl rule__BidirectionalPath__Group__2
            {
            pushFollow(FOLLOW_36);
            rule__BidirectionalPath__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__1"


    // $ANTLR start "rule__BidirectionalPath__Group__1__Impl"
    // InternalMachine.g:4966:1: rule__BidirectionalPath__Group__1__Impl : ( ( rule__BidirectionalPath__EndPointsAssignment_1 ) ) ;
    public final void rule__BidirectionalPath__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4970:1: ( ( ( rule__BidirectionalPath__EndPointsAssignment_1 ) ) )
            // InternalMachine.g:4971:1: ( ( rule__BidirectionalPath__EndPointsAssignment_1 ) )
            {
            // InternalMachine.g:4971:1: ( ( rule__BidirectionalPath__EndPointsAssignment_1 ) )
            // InternalMachine.g:4972:2: ( rule__BidirectionalPath__EndPointsAssignment_1 )
            {
             before(grammarAccess.getBidirectionalPathAccess().getEndPointsAssignment_1()); 
            // InternalMachine.g:4973:2: ( rule__BidirectionalPath__EndPointsAssignment_1 )
            // InternalMachine.g:4973:3: rule__BidirectionalPath__EndPointsAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__EndPointsAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getBidirectionalPathAccess().getEndPointsAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__1__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group__2"
    // InternalMachine.g:4981:1: rule__BidirectionalPath__Group__2 : rule__BidirectionalPath__Group__2__Impl rule__BidirectionalPath__Group__3 ;
    public final void rule__BidirectionalPath__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4985:1: ( rule__BidirectionalPath__Group__2__Impl rule__BidirectionalPath__Group__3 )
            // InternalMachine.g:4986:2: rule__BidirectionalPath__Group__2__Impl rule__BidirectionalPath__Group__3
            {
            pushFollow(FOLLOW_6);
            rule__BidirectionalPath__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__2"


    // $ANTLR start "rule__BidirectionalPath__Group__2__Impl"
    // InternalMachine.g:4993:1: rule__BidirectionalPath__Group__2__Impl : ( '<->' ) ;
    public final void rule__BidirectionalPath__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:4997:1: ( ( '<->' ) )
            // InternalMachine.g:4998:1: ( '<->' )
            {
            // InternalMachine.g:4998:1: ( '<->' )
            // InternalMachine.g:4999:2: '<->'
            {
             before(grammarAccess.getBidirectionalPathAccess().getLessThanSignHyphenMinusGreaterThanSignKeyword_2()); 
            match(input,39,FOLLOW_2); 
             after(grammarAccess.getBidirectionalPathAccess().getLessThanSignHyphenMinusGreaterThanSignKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__2__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group__3"
    // InternalMachine.g:5008:1: rule__BidirectionalPath__Group__3 : rule__BidirectionalPath__Group__3__Impl rule__BidirectionalPath__Group__4 ;
    public final void rule__BidirectionalPath__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5012:1: ( rule__BidirectionalPath__Group__3__Impl rule__BidirectionalPath__Group__4 )
            // InternalMachine.g:5013:2: rule__BidirectionalPath__Group__3__Impl rule__BidirectionalPath__Group__4
            {
            pushFollow(FOLLOW_33);
            rule__BidirectionalPath__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__3"


    // $ANTLR start "rule__BidirectionalPath__Group__3__Impl"
    // InternalMachine.g:5020:1: rule__BidirectionalPath__Group__3__Impl : ( ( rule__BidirectionalPath__EndPointsAssignment_3 ) ) ;
    public final void rule__BidirectionalPath__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5024:1: ( ( ( rule__BidirectionalPath__EndPointsAssignment_3 ) ) )
            // InternalMachine.g:5025:1: ( ( rule__BidirectionalPath__EndPointsAssignment_3 ) )
            {
            // InternalMachine.g:5025:1: ( ( rule__BidirectionalPath__EndPointsAssignment_3 ) )
            // InternalMachine.g:5026:2: ( rule__BidirectionalPath__EndPointsAssignment_3 )
            {
             before(grammarAccess.getBidirectionalPathAccess().getEndPointsAssignment_3()); 
            // InternalMachine.g:5027:2: ( rule__BidirectionalPath__EndPointsAssignment_3 )
            // InternalMachine.g:5027:3: rule__BidirectionalPath__EndPointsAssignment_3
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__EndPointsAssignment_3();

            state._fsp--;


            }

             after(grammarAccess.getBidirectionalPathAccess().getEndPointsAssignment_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__3__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group__4"
    // InternalMachine.g:5035:1: rule__BidirectionalPath__Group__4 : rule__BidirectionalPath__Group__4__Impl rule__BidirectionalPath__Group__5 ;
    public final void rule__BidirectionalPath__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5039:1: ( rule__BidirectionalPath__Group__4__Impl rule__BidirectionalPath__Group__5 )
            // InternalMachine.g:5040:2: rule__BidirectionalPath__Group__4__Impl rule__BidirectionalPath__Group__5
            {
            pushFollow(FOLLOW_34);
            rule__BidirectionalPath__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__4"


    // $ANTLR start "rule__BidirectionalPath__Group__4__Impl"
    // InternalMachine.g:5047:1: rule__BidirectionalPath__Group__4__Impl : ( ( rule__BidirectionalPath__Alternatives_4 ) ) ;
    public final void rule__BidirectionalPath__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5051:1: ( ( ( rule__BidirectionalPath__Alternatives_4 ) ) )
            // InternalMachine.g:5052:1: ( ( rule__BidirectionalPath__Alternatives_4 ) )
            {
            // InternalMachine.g:5052:1: ( ( rule__BidirectionalPath__Alternatives_4 ) )
            // InternalMachine.g:5053:2: ( rule__BidirectionalPath__Alternatives_4 )
            {
             before(grammarAccess.getBidirectionalPathAccess().getAlternatives_4()); 
            // InternalMachine.g:5054:2: ( rule__BidirectionalPath__Alternatives_4 )
            // InternalMachine.g:5054:3: rule__BidirectionalPath__Alternatives_4
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Alternatives_4();

            state._fsp--;


            }

             after(grammarAccess.getBidirectionalPathAccess().getAlternatives_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__4__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group__5"
    // InternalMachine.g:5062:1: rule__BidirectionalPath__Group__5 : rule__BidirectionalPath__Group__5__Impl ;
    public final void rule__BidirectionalPath__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5066:1: ( rule__BidirectionalPath__Group__5__Impl )
            // InternalMachine.g:5067:2: rule__BidirectionalPath__Group__5__Impl
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group__5__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__5"


    // $ANTLR start "rule__BidirectionalPath__Group__5__Impl"
    // InternalMachine.g:5073:1: rule__BidirectionalPath__Group__5__Impl : ( ( rule__BidirectionalPath__Group_5__0 )* ) ;
    public final void rule__BidirectionalPath__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5077:1: ( ( ( rule__BidirectionalPath__Group_5__0 )* ) )
            // InternalMachine.g:5078:1: ( ( rule__BidirectionalPath__Group_5__0 )* )
            {
            // InternalMachine.g:5078:1: ( ( rule__BidirectionalPath__Group_5__0 )* )
            // InternalMachine.g:5079:2: ( rule__BidirectionalPath__Group_5__0 )*
            {
             before(grammarAccess.getBidirectionalPathAccess().getGroup_5()); 
            // InternalMachine.g:5080:2: ( rule__BidirectionalPath__Group_5__0 )*
            loop44:
            do {
                int alt44=2;
                int LA44_0 = input.LA(1);

                if ( (LA44_0==38) ) {
                    alt44=1;
                }


                switch (alt44) {
            	case 1 :
            	    // InternalMachine.g:5080:3: rule__BidirectionalPath__Group_5__0
            	    {
            	    pushFollow(FOLLOW_35);
            	    rule__BidirectionalPath__Group_5__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop44;
                }
            } while (true);

             after(grammarAccess.getBidirectionalPathAccess().getGroup_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group__5__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0__0"
    // InternalMachine.g:5089:1: rule__BidirectionalPath__Group_4_0__0 : rule__BidirectionalPath__Group_4_0__0__Impl rule__BidirectionalPath__Group_4_0__1 ;
    public final void rule__BidirectionalPath__Group_4_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5093:1: ( rule__BidirectionalPath__Group_4_0__0__Impl rule__BidirectionalPath__Group_4_0__1 )
            // InternalMachine.g:5094:2: rule__BidirectionalPath__Group_4_0__0__Impl rule__BidirectionalPath__Group_4_0__1
            {
            pushFollow(FOLLOW_6);
            rule__BidirectionalPath__Group_4_0__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group_4_0__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0__0"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0__0__Impl"
    // InternalMachine.g:5101:1: rule__BidirectionalPath__Group_4_0__0__Impl : ( 'profiles' ) ;
    public final void rule__BidirectionalPath__Group_4_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5105:1: ( ( 'profiles' ) )
            // InternalMachine.g:5106:1: ( 'profiles' )
            {
            // InternalMachine.g:5106:1: ( 'profiles' )
            // InternalMachine.g:5107:2: 'profiles'
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesKeyword_4_0_0()); 
            match(input,36,FOLLOW_2); 
             after(grammarAccess.getBidirectionalPathAccess().getProfilesKeyword_4_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0__0__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0__1"
    // InternalMachine.g:5116:1: rule__BidirectionalPath__Group_4_0__1 : rule__BidirectionalPath__Group_4_0__1__Impl rule__BidirectionalPath__Group_4_0__2 ;
    public final void rule__BidirectionalPath__Group_4_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5120:1: ( rule__BidirectionalPath__Group_4_0__1__Impl rule__BidirectionalPath__Group_4_0__2 )
            // InternalMachine.g:5121:2: rule__BidirectionalPath__Group_4_0__1__Impl rule__BidirectionalPath__Group_4_0__2
            {
            pushFollow(FOLLOW_18);
            rule__BidirectionalPath__Group_4_0__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group_4_0__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0__1"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0__1__Impl"
    // InternalMachine.g:5128:1: rule__BidirectionalPath__Group_4_0__1__Impl : ( ( rule__BidirectionalPath__ProfilesAssignment_4_0_1 ) ) ;
    public final void rule__BidirectionalPath__Group_4_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5132:1: ( ( ( rule__BidirectionalPath__ProfilesAssignment_4_0_1 ) ) )
            // InternalMachine.g:5133:1: ( ( rule__BidirectionalPath__ProfilesAssignment_4_0_1 ) )
            {
            // InternalMachine.g:5133:1: ( ( rule__BidirectionalPath__ProfilesAssignment_4_0_1 ) )
            // InternalMachine.g:5134:2: ( rule__BidirectionalPath__ProfilesAssignment_4_0_1 )
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesAssignment_4_0_1()); 
            // InternalMachine.g:5135:2: ( rule__BidirectionalPath__ProfilesAssignment_4_0_1 )
            // InternalMachine.g:5135:3: rule__BidirectionalPath__ProfilesAssignment_4_0_1
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__ProfilesAssignment_4_0_1();

            state._fsp--;


            }

             after(grammarAccess.getBidirectionalPathAccess().getProfilesAssignment_4_0_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0__1__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0__2"
    // InternalMachine.g:5143:1: rule__BidirectionalPath__Group_4_0__2 : rule__BidirectionalPath__Group_4_0__2__Impl ;
    public final void rule__BidirectionalPath__Group_4_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5147:1: ( rule__BidirectionalPath__Group_4_0__2__Impl )
            // InternalMachine.g:5148:2: rule__BidirectionalPath__Group_4_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group_4_0__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0__2"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0__2__Impl"
    // InternalMachine.g:5154:1: rule__BidirectionalPath__Group_4_0__2__Impl : ( ( rule__BidirectionalPath__Group_4_0_2__0 )* ) ;
    public final void rule__BidirectionalPath__Group_4_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5158:1: ( ( ( rule__BidirectionalPath__Group_4_0_2__0 )* ) )
            // InternalMachine.g:5159:1: ( ( rule__BidirectionalPath__Group_4_0_2__0 )* )
            {
            // InternalMachine.g:5159:1: ( ( rule__BidirectionalPath__Group_4_0_2__0 )* )
            // InternalMachine.g:5160:2: ( rule__BidirectionalPath__Group_4_0_2__0 )*
            {
             before(grammarAccess.getBidirectionalPathAccess().getGroup_4_0_2()); 
            // InternalMachine.g:5161:2: ( rule__BidirectionalPath__Group_4_0_2__0 )*
            loop45:
            do {
                int alt45=2;
                int LA45_0 = input.LA(1);

                if ( (LA45_0==24) ) {
                    alt45=1;
                }


                switch (alt45) {
            	case 1 :
            	    // InternalMachine.g:5161:3: rule__BidirectionalPath__Group_4_0_2__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__BidirectionalPath__Group_4_0_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop45;
                }
            } while (true);

             after(grammarAccess.getBidirectionalPathAccess().getGroup_4_0_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0__2__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0_2__0"
    // InternalMachine.g:5170:1: rule__BidirectionalPath__Group_4_0_2__0 : rule__BidirectionalPath__Group_4_0_2__0__Impl rule__BidirectionalPath__Group_4_0_2__1 ;
    public final void rule__BidirectionalPath__Group_4_0_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5174:1: ( rule__BidirectionalPath__Group_4_0_2__0__Impl rule__BidirectionalPath__Group_4_0_2__1 )
            // InternalMachine.g:5175:2: rule__BidirectionalPath__Group_4_0_2__0__Impl rule__BidirectionalPath__Group_4_0_2__1
            {
            pushFollow(FOLLOW_6);
            rule__BidirectionalPath__Group_4_0_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group_4_0_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0_2__0"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0_2__0__Impl"
    // InternalMachine.g:5182:1: rule__BidirectionalPath__Group_4_0_2__0__Impl : ( ',' ) ;
    public final void rule__BidirectionalPath__Group_4_0_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5186:1: ( ( ',' ) )
            // InternalMachine.g:5187:1: ( ',' )
            {
            // InternalMachine.g:5187:1: ( ',' )
            // InternalMachine.g:5188:2: ','
            {
             before(grammarAccess.getBidirectionalPathAccess().getCommaKeyword_4_0_2_0()); 
            match(input,24,FOLLOW_2); 
             after(grammarAccess.getBidirectionalPathAccess().getCommaKeyword_4_0_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0_2__0__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0_2__1"
    // InternalMachine.g:5197:1: rule__BidirectionalPath__Group_4_0_2__1 : rule__BidirectionalPath__Group_4_0_2__1__Impl ;
    public final void rule__BidirectionalPath__Group_4_0_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5201:1: ( rule__BidirectionalPath__Group_4_0_2__1__Impl )
            // InternalMachine.g:5202:2: rule__BidirectionalPath__Group_4_0_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group_4_0_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0_2__1"


    // $ANTLR start "rule__BidirectionalPath__Group_4_0_2__1__Impl"
    // InternalMachine.g:5208:1: rule__BidirectionalPath__Group_4_0_2__1__Impl : ( ( rule__BidirectionalPath__ProfilesAssignment_4_0_2_1 ) ) ;
    public final void rule__BidirectionalPath__Group_4_0_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5212:1: ( ( ( rule__BidirectionalPath__ProfilesAssignment_4_0_2_1 ) ) )
            // InternalMachine.g:5213:1: ( ( rule__BidirectionalPath__ProfilesAssignment_4_0_2_1 ) )
            {
            // InternalMachine.g:5213:1: ( ( rule__BidirectionalPath__ProfilesAssignment_4_0_2_1 ) )
            // InternalMachine.g:5214:2: ( rule__BidirectionalPath__ProfilesAssignment_4_0_2_1 )
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesAssignment_4_0_2_1()); 
            // InternalMachine.g:5215:2: ( rule__BidirectionalPath__ProfilesAssignment_4_0_2_1 )
            // InternalMachine.g:5215:3: rule__BidirectionalPath__ProfilesAssignment_4_0_2_1
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__ProfilesAssignment_4_0_2_1();

            state._fsp--;


            }

             after(grammarAccess.getBidirectionalPathAccess().getProfilesAssignment_4_0_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_0_2__1__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group_4_1__0"
    // InternalMachine.g:5224:1: rule__BidirectionalPath__Group_4_1__0 : rule__BidirectionalPath__Group_4_1__0__Impl rule__BidirectionalPath__Group_4_1__1 ;
    public final void rule__BidirectionalPath__Group_4_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5228:1: ( rule__BidirectionalPath__Group_4_1__0__Impl rule__BidirectionalPath__Group_4_1__1 )
            // InternalMachine.g:5229:2: rule__BidirectionalPath__Group_4_1__0__Impl rule__BidirectionalPath__Group_4_1__1
            {
            pushFollow(FOLLOW_6);
            rule__BidirectionalPath__Group_4_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group_4_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_1__0"


    // $ANTLR start "rule__BidirectionalPath__Group_4_1__0__Impl"
    // InternalMachine.g:5236:1: rule__BidirectionalPath__Group_4_1__0__Impl : ( 'profile' ) ;
    public final void rule__BidirectionalPath__Group_4_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5240:1: ( ( 'profile' ) )
            // InternalMachine.g:5241:1: ( 'profile' )
            {
            // InternalMachine.g:5241:1: ( 'profile' )
            // InternalMachine.g:5242:2: 'profile'
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfileKeyword_4_1_0()); 
            match(input,37,FOLLOW_2); 
             after(grammarAccess.getBidirectionalPathAccess().getProfileKeyword_4_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_1__0__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group_4_1__1"
    // InternalMachine.g:5251:1: rule__BidirectionalPath__Group_4_1__1 : rule__BidirectionalPath__Group_4_1__1__Impl ;
    public final void rule__BidirectionalPath__Group_4_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5255:1: ( rule__BidirectionalPath__Group_4_1__1__Impl )
            // InternalMachine.g:5256:2: rule__BidirectionalPath__Group_4_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group_4_1__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_1__1"


    // $ANTLR start "rule__BidirectionalPath__Group_4_1__1__Impl"
    // InternalMachine.g:5262:1: rule__BidirectionalPath__Group_4_1__1__Impl : ( ( rule__BidirectionalPath__ProfilesAssignment_4_1_1 ) ) ;
    public final void rule__BidirectionalPath__Group_4_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5266:1: ( ( ( rule__BidirectionalPath__ProfilesAssignment_4_1_1 ) ) )
            // InternalMachine.g:5267:1: ( ( rule__BidirectionalPath__ProfilesAssignment_4_1_1 ) )
            {
            // InternalMachine.g:5267:1: ( ( rule__BidirectionalPath__ProfilesAssignment_4_1_1 ) )
            // InternalMachine.g:5268:2: ( rule__BidirectionalPath__ProfilesAssignment_4_1_1 )
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesAssignment_4_1_1()); 
            // InternalMachine.g:5269:2: ( rule__BidirectionalPath__ProfilesAssignment_4_1_1 )
            // InternalMachine.g:5269:3: rule__BidirectionalPath__ProfilesAssignment_4_1_1
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__ProfilesAssignment_4_1_1();

            state._fsp--;


            }

             after(grammarAccess.getBidirectionalPathAccess().getProfilesAssignment_4_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_4_1__1__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group_5__0"
    // InternalMachine.g:5278:1: rule__BidirectionalPath__Group_5__0 : rule__BidirectionalPath__Group_5__0__Impl rule__BidirectionalPath__Group_5__1 ;
    public final void rule__BidirectionalPath__Group_5__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5282:1: ( rule__BidirectionalPath__Group_5__0__Impl rule__BidirectionalPath__Group_5__1 )
            // InternalMachine.g:5283:2: rule__BidirectionalPath__Group_5__0__Impl rule__BidirectionalPath__Group_5__1
            {
            pushFollow(FOLLOW_6);
            rule__BidirectionalPath__Group_5__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group_5__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_5__0"


    // $ANTLR start "rule__BidirectionalPath__Group_5__0__Impl"
    // InternalMachine.g:5290:1: rule__BidirectionalPath__Group_5__0__Impl : ( '@' ) ;
    public final void rule__BidirectionalPath__Group_5__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5294:1: ( ( '@' ) )
            // InternalMachine.g:5295:1: ( '@' )
            {
            // InternalMachine.g:5295:1: ( '@' )
            // InternalMachine.g:5296:2: '@'
            {
             before(grammarAccess.getBidirectionalPathAccess().getCommercialAtKeyword_5_0()); 
            match(input,38,FOLLOW_2); 
             after(grammarAccess.getBidirectionalPathAccess().getCommercialAtKeyword_5_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_5__0__Impl"


    // $ANTLR start "rule__BidirectionalPath__Group_5__1"
    // InternalMachine.g:5305:1: rule__BidirectionalPath__Group_5__1 : rule__BidirectionalPath__Group_5__1__Impl ;
    public final void rule__BidirectionalPath__Group_5__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5309:1: ( rule__BidirectionalPath__Group_5__1__Impl )
            // InternalMachine.g:5310:2: rule__BidirectionalPath__Group_5__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__Group_5__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_5__1"


    // $ANTLR start "rule__BidirectionalPath__Group_5__1__Impl"
    // InternalMachine.g:5316:1: rule__BidirectionalPath__Group_5__1__Impl : ( ( rule__BidirectionalPath__AnnotationsAssignment_5_1 ) ) ;
    public final void rule__BidirectionalPath__Group_5__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5320:1: ( ( ( rule__BidirectionalPath__AnnotationsAssignment_5_1 ) ) )
            // InternalMachine.g:5321:1: ( ( rule__BidirectionalPath__AnnotationsAssignment_5_1 ) )
            {
            // InternalMachine.g:5321:1: ( ( rule__BidirectionalPath__AnnotationsAssignment_5_1 ) )
            // InternalMachine.g:5322:2: ( rule__BidirectionalPath__AnnotationsAssignment_5_1 )
            {
             before(grammarAccess.getBidirectionalPathAccess().getAnnotationsAssignment_5_1()); 
            // InternalMachine.g:5323:2: ( rule__BidirectionalPath__AnnotationsAssignment_5_1 )
            // InternalMachine.g:5323:3: rule__BidirectionalPath__AnnotationsAssignment_5_1
            {
            pushFollow(FOLLOW_2);
            rule__BidirectionalPath__AnnotationsAssignment_5_1();

            state._fsp--;


            }

             after(grammarAccess.getBidirectionalPathAccess().getAnnotationsAssignment_5_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__Group_5__1__Impl"


    // $ANTLR start "rule__FullMeshPath__Group__0"
    // InternalMachine.g:5332:1: rule__FullMeshPath__Group__0 : rule__FullMeshPath__Group__0__Impl rule__FullMeshPath__Group__1 ;
    public final void rule__FullMeshPath__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5336:1: ( rule__FullMeshPath__Group__0__Impl rule__FullMeshPath__Group__1 )
            // InternalMachine.g:5337:2: rule__FullMeshPath__Group__0__Impl rule__FullMeshPath__Group__1
            {
            pushFollow(FOLLOW_37);
            rule__FullMeshPath__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__0"


    // $ANTLR start "rule__FullMeshPath__Group__0__Impl"
    // InternalMachine.g:5344:1: rule__FullMeshPath__Group__0__Impl : ( () ) ;
    public final void rule__FullMeshPath__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5348:1: ( ( () ) )
            // InternalMachine.g:5349:1: ( () )
            {
            // InternalMachine.g:5349:1: ( () )
            // InternalMachine.g:5350:2: ()
            {
             before(grammarAccess.getFullMeshPathAccess().getFullMeshPathAction_0()); 
            // InternalMachine.g:5351:2: ()
            // InternalMachine.g:5351:3: 
            {
            }

             after(grammarAccess.getFullMeshPathAccess().getFullMeshPathAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__0__Impl"


    // $ANTLR start "rule__FullMeshPath__Group__1"
    // InternalMachine.g:5359:1: rule__FullMeshPath__Group__1 : rule__FullMeshPath__Group__1__Impl rule__FullMeshPath__Group__2 ;
    public final void rule__FullMeshPath__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5363:1: ( rule__FullMeshPath__Group__1__Impl rule__FullMeshPath__Group__2 )
            // InternalMachine.g:5364:2: rule__FullMeshPath__Group__1__Impl rule__FullMeshPath__Group__2
            {
            pushFollow(FOLLOW_7);
            rule__FullMeshPath__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__1"


    // $ANTLR start "rule__FullMeshPath__Group__1__Impl"
    // InternalMachine.g:5371:1: rule__FullMeshPath__Group__1__Impl : ( 'FullMesh' ) ;
    public final void rule__FullMeshPath__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5375:1: ( ( 'FullMesh' ) )
            // InternalMachine.g:5376:1: ( 'FullMesh' )
            {
            // InternalMachine.g:5376:1: ( 'FullMesh' )
            // InternalMachine.g:5377:2: 'FullMesh'
            {
             before(grammarAccess.getFullMeshPathAccess().getFullMeshKeyword_1()); 
            match(input,40,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getFullMeshKeyword_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__1__Impl"


    // $ANTLR start "rule__FullMeshPath__Group__2"
    // InternalMachine.g:5386:1: rule__FullMeshPath__Group__2 : rule__FullMeshPath__Group__2__Impl rule__FullMeshPath__Group__3 ;
    public final void rule__FullMeshPath__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5390:1: ( rule__FullMeshPath__Group__2__Impl rule__FullMeshPath__Group__3 )
            // InternalMachine.g:5391:2: rule__FullMeshPath__Group__2__Impl rule__FullMeshPath__Group__3
            {
            pushFollow(FOLLOW_33);
            rule__FullMeshPath__Group__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__2"


    // $ANTLR start "rule__FullMeshPath__Group__2__Impl"
    // InternalMachine.g:5398:1: rule__FullMeshPath__Group__2__Impl : ( '{' ) ;
    public final void rule__FullMeshPath__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5402:1: ( ( '{' ) )
            // InternalMachine.g:5403:1: ( '{' )
            {
            // InternalMachine.g:5403:1: ( '{' )
            // InternalMachine.g:5404:2: '{'
            {
             before(grammarAccess.getFullMeshPathAccess().getLeftCurlyBracketKeyword_2()); 
            match(input,13,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getLeftCurlyBracketKeyword_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__2__Impl"


    // $ANTLR start "rule__FullMeshPath__Group__3"
    // InternalMachine.g:5413:1: rule__FullMeshPath__Group__3 : rule__FullMeshPath__Group__3__Impl rule__FullMeshPath__Group__4 ;
    public final void rule__FullMeshPath__Group__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5417:1: ( rule__FullMeshPath__Group__3__Impl rule__FullMeshPath__Group__4 )
            // InternalMachine.g:5418:2: rule__FullMeshPath__Group__3__Impl rule__FullMeshPath__Group__4
            {
            pushFollow(FOLLOW_38);
            rule__FullMeshPath__Group__3__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group__4();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__3"


    // $ANTLR start "rule__FullMeshPath__Group__3__Impl"
    // InternalMachine.g:5425:1: rule__FullMeshPath__Group__3__Impl : ( ( rule__FullMeshPath__Alternatives_3 ) ) ;
    public final void rule__FullMeshPath__Group__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5429:1: ( ( ( rule__FullMeshPath__Alternatives_3 ) ) )
            // InternalMachine.g:5430:1: ( ( rule__FullMeshPath__Alternatives_3 ) )
            {
            // InternalMachine.g:5430:1: ( ( rule__FullMeshPath__Alternatives_3 ) )
            // InternalMachine.g:5431:2: ( rule__FullMeshPath__Alternatives_3 )
            {
             before(grammarAccess.getFullMeshPathAccess().getAlternatives_3()); 
            // InternalMachine.g:5432:2: ( rule__FullMeshPath__Alternatives_3 )
            // InternalMachine.g:5432:3: rule__FullMeshPath__Alternatives_3
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Alternatives_3();

            state._fsp--;


            }

             after(grammarAccess.getFullMeshPathAccess().getAlternatives_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__3__Impl"


    // $ANTLR start "rule__FullMeshPath__Group__4"
    // InternalMachine.g:5440:1: rule__FullMeshPath__Group__4 : rule__FullMeshPath__Group__4__Impl rule__FullMeshPath__Group__5 ;
    public final void rule__FullMeshPath__Group__4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5444:1: ( rule__FullMeshPath__Group__4__Impl rule__FullMeshPath__Group__5 )
            // InternalMachine.g:5445:2: rule__FullMeshPath__Group__4__Impl rule__FullMeshPath__Group__5
            {
            pushFollow(FOLLOW_38);
            rule__FullMeshPath__Group__4__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group__5();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__4"


    // $ANTLR start "rule__FullMeshPath__Group__4__Impl"
    // InternalMachine.g:5452:1: rule__FullMeshPath__Group__4__Impl : ( ( rule__FullMeshPath__Group_4__0 )* ) ;
    public final void rule__FullMeshPath__Group__4__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5456:1: ( ( ( rule__FullMeshPath__Group_4__0 )* ) )
            // InternalMachine.g:5457:1: ( ( rule__FullMeshPath__Group_4__0 )* )
            {
            // InternalMachine.g:5457:1: ( ( rule__FullMeshPath__Group_4__0 )* )
            // InternalMachine.g:5458:2: ( rule__FullMeshPath__Group_4__0 )*
            {
             before(grammarAccess.getFullMeshPathAccess().getGroup_4()); 
            // InternalMachine.g:5459:2: ( rule__FullMeshPath__Group_4__0 )*
            loop46:
            do {
                int alt46=2;
                int LA46_0 = input.LA(1);

                if ( (LA46_0==38) ) {
                    alt46=1;
                }


                switch (alt46) {
            	case 1 :
            	    // InternalMachine.g:5459:3: rule__FullMeshPath__Group_4__0
            	    {
            	    pushFollow(FOLLOW_35);
            	    rule__FullMeshPath__Group_4__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop46;
                }
            } while (true);

             after(grammarAccess.getFullMeshPathAccess().getGroup_4()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__4__Impl"


    // $ANTLR start "rule__FullMeshPath__Group__5"
    // InternalMachine.g:5467:1: rule__FullMeshPath__Group__5 : rule__FullMeshPath__Group__5__Impl rule__FullMeshPath__Group__6 ;
    public final void rule__FullMeshPath__Group__5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5471:1: ( rule__FullMeshPath__Group__5__Impl rule__FullMeshPath__Group__6 )
            // InternalMachine.g:5472:2: rule__FullMeshPath__Group__5__Impl rule__FullMeshPath__Group__6
            {
            pushFollow(FOLLOW_38);
            rule__FullMeshPath__Group__5__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group__6();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__5"


    // $ANTLR start "rule__FullMeshPath__Group__5__Impl"
    // InternalMachine.g:5479:1: rule__FullMeshPath__Group__5__Impl : ( ( rule__FullMeshPath__EndPointsAssignment_5 )* ) ;
    public final void rule__FullMeshPath__Group__5__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5483:1: ( ( ( rule__FullMeshPath__EndPointsAssignment_5 )* ) )
            // InternalMachine.g:5484:1: ( ( rule__FullMeshPath__EndPointsAssignment_5 )* )
            {
            // InternalMachine.g:5484:1: ( ( rule__FullMeshPath__EndPointsAssignment_5 )* )
            // InternalMachine.g:5485:2: ( rule__FullMeshPath__EndPointsAssignment_5 )*
            {
             before(grammarAccess.getFullMeshPathAccess().getEndPointsAssignment_5()); 
            // InternalMachine.g:5486:2: ( rule__FullMeshPath__EndPointsAssignment_5 )*
            loop47:
            do {
                int alt47=2;
                int LA47_0 = input.LA(1);

                if ( (LA47_0==RULE_ID) ) {
                    alt47=1;
                }


                switch (alt47) {
            	case 1 :
            	    // InternalMachine.g:5486:3: rule__FullMeshPath__EndPointsAssignment_5
            	    {
            	    pushFollow(FOLLOW_9);
            	    rule__FullMeshPath__EndPointsAssignment_5();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop47;
                }
            } while (true);

             after(grammarAccess.getFullMeshPathAccess().getEndPointsAssignment_5()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__5__Impl"


    // $ANTLR start "rule__FullMeshPath__Group__6"
    // InternalMachine.g:5494:1: rule__FullMeshPath__Group__6 : rule__FullMeshPath__Group__6__Impl ;
    public final void rule__FullMeshPath__Group__6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5498:1: ( rule__FullMeshPath__Group__6__Impl )
            // InternalMachine.g:5499:2: rule__FullMeshPath__Group__6__Impl
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group__6__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__6"


    // $ANTLR start "rule__FullMeshPath__Group__6__Impl"
    // InternalMachine.g:5505:1: rule__FullMeshPath__Group__6__Impl : ( '}' ) ;
    public final void rule__FullMeshPath__Group__6__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5509:1: ( ( '}' ) )
            // InternalMachine.g:5510:1: ( '}' )
            {
            // InternalMachine.g:5510:1: ( '}' )
            // InternalMachine.g:5511:2: '}'
            {
             before(grammarAccess.getFullMeshPathAccess().getRightCurlyBracketKeyword_6()); 
            match(input,14,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getRightCurlyBracketKeyword_6()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group__6__Impl"


    // $ANTLR start "rule__FullMeshPath__Group_3_0__0"
    // InternalMachine.g:5521:1: rule__FullMeshPath__Group_3_0__0 : rule__FullMeshPath__Group_3_0__0__Impl rule__FullMeshPath__Group_3_0__1 ;
    public final void rule__FullMeshPath__Group_3_0__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5525:1: ( rule__FullMeshPath__Group_3_0__0__Impl rule__FullMeshPath__Group_3_0__1 )
            // InternalMachine.g:5526:2: rule__FullMeshPath__Group_3_0__0__Impl rule__FullMeshPath__Group_3_0__1
            {
            pushFollow(FOLLOW_6);
            rule__FullMeshPath__Group_3_0__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group_3_0__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0__0"


    // $ANTLR start "rule__FullMeshPath__Group_3_0__0__Impl"
    // InternalMachine.g:5533:1: rule__FullMeshPath__Group_3_0__0__Impl : ( 'profiles' ) ;
    public final void rule__FullMeshPath__Group_3_0__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5537:1: ( ( 'profiles' ) )
            // InternalMachine.g:5538:1: ( 'profiles' )
            {
            // InternalMachine.g:5538:1: ( 'profiles' )
            // InternalMachine.g:5539:2: 'profiles'
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesKeyword_3_0_0()); 
            match(input,36,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getProfilesKeyword_3_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0__0__Impl"


    // $ANTLR start "rule__FullMeshPath__Group_3_0__1"
    // InternalMachine.g:5548:1: rule__FullMeshPath__Group_3_0__1 : rule__FullMeshPath__Group_3_0__1__Impl rule__FullMeshPath__Group_3_0__2 ;
    public final void rule__FullMeshPath__Group_3_0__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5552:1: ( rule__FullMeshPath__Group_3_0__1__Impl rule__FullMeshPath__Group_3_0__2 )
            // InternalMachine.g:5553:2: rule__FullMeshPath__Group_3_0__1__Impl rule__FullMeshPath__Group_3_0__2
            {
            pushFollow(FOLLOW_18);
            rule__FullMeshPath__Group_3_0__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group_3_0__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0__1"


    // $ANTLR start "rule__FullMeshPath__Group_3_0__1__Impl"
    // InternalMachine.g:5560:1: rule__FullMeshPath__Group_3_0__1__Impl : ( ( rule__FullMeshPath__ProfilesAssignment_3_0_1 ) ) ;
    public final void rule__FullMeshPath__Group_3_0__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5564:1: ( ( ( rule__FullMeshPath__ProfilesAssignment_3_0_1 ) ) )
            // InternalMachine.g:5565:1: ( ( rule__FullMeshPath__ProfilesAssignment_3_0_1 ) )
            {
            // InternalMachine.g:5565:1: ( ( rule__FullMeshPath__ProfilesAssignment_3_0_1 ) )
            // InternalMachine.g:5566:2: ( rule__FullMeshPath__ProfilesAssignment_3_0_1 )
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesAssignment_3_0_1()); 
            // InternalMachine.g:5567:2: ( rule__FullMeshPath__ProfilesAssignment_3_0_1 )
            // InternalMachine.g:5567:3: rule__FullMeshPath__ProfilesAssignment_3_0_1
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__ProfilesAssignment_3_0_1();

            state._fsp--;


            }

             after(grammarAccess.getFullMeshPathAccess().getProfilesAssignment_3_0_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0__1__Impl"


    // $ANTLR start "rule__FullMeshPath__Group_3_0__2"
    // InternalMachine.g:5575:1: rule__FullMeshPath__Group_3_0__2 : rule__FullMeshPath__Group_3_0__2__Impl ;
    public final void rule__FullMeshPath__Group_3_0__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5579:1: ( rule__FullMeshPath__Group_3_0__2__Impl )
            // InternalMachine.g:5580:2: rule__FullMeshPath__Group_3_0__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group_3_0__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0__2"


    // $ANTLR start "rule__FullMeshPath__Group_3_0__2__Impl"
    // InternalMachine.g:5586:1: rule__FullMeshPath__Group_3_0__2__Impl : ( ( rule__FullMeshPath__Group_3_0_2__0 )* ) ;
    public final void rule__FullMeshPath__Group_3_0__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5590:1: ( ( ( rule__FullMeshPath__Group_3_0_2__0 )* ) )
            // InternalMachine.g:5591:1: ( ( rule__FullMeshPath__Group_3_0_2__0 )* )
            {
            // InternalMachine.g:5591:1: ( ( rule__FullMeshPath__Group_3_0_2__0 )* )
            // InternalMachine.g:5592:2: ( rule__FullMeshPath__Group_3_0_2__0 )*
            {
             before(grammarAccess.getFullMeshPathAccess().getGroup_3_0_2()); 
            // InternalMachine.g:5593:2: ( rule__FullMeshPath__Group_3_0_2__0 )*
            loop48:
            do {
                int alt48=2;
                int LA48_0 = input.LA(1);

                if ( (LA48_0==24) ) {
                    alt48=1;
                }


                switch (alt48) {
            	case 1 :
            	    // InternalMachine.g:5593:3: rule__FullMeshPath__Group_3_0_2__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__FullMeshPath__Group_3_0_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop48;
                }
            } while (true);

             after(grammarAccess.getFullMeshPathAccess().getGroup_3_0_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0__2__Impl"


    // $ANTLR start "rule__FullMeshPath__Group_3_0_2__0"
    // InternalMachine.g:5602:1: rule__FullMeshPath__Group_3_0_2__0 : rule__FullMeshPath__Group_3_0_2__0__Impl rule__FullMeshPath__Group_3_0_2__1 ;
    public final void rule__FullMeshPath__Group_3_0_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5606:1: ( rule__FullMeshPath__Group_3_0_2__0__Impl rule__FullMeshPath__Group_3_0_2__1 )
            // InternalMachine.g:5607:2: rule__FullMeshPath__Group_3_0_2__0__Impl rule__FullMeshPath__Group_3_0_2__1
            {
            pushFollow(FOLLOW_6);
            rule__FullMeshPath__Group_3_0_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group_3_0_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0_2__0"


    // $ANTLR start "rule__FullMeshPath__Group_3_0_2__0__Impl"
    // InternalMachine.g:5614:1: rule__FullMeshPath__Group_3_0_2__0__Impl : ( ',' ) ;
    public final void rule__FullMeshPath__Group_3_0_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5618:1: ( ( ',' ) )
            // InternalMachine.g:5619:1: ( ',' )
            {
            // InternalMachine.g:5619:1: ( ',' )
            // InternalMachine.g:5620:2: ','
            {
             before(grammarAccess.getFullMeshPathAccess().getCommaKeyword_3_0_2_0()); 
            match(input,24,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getCommaKeyword_3_0_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0_2__0__Impl"


    // $ANTLR start "rule__FullMeshPath__Group_3_0_2__1"
    // InternalMachine.g:5629:1: rule__FullMeshPath__Group_3_0_2__1 : rule__FullMeshPath__Group_3_0_2__1__Impl ;
    public final void rule__FullMeshPath__Group_3_0_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5633:1: ( rule__FullMeshPath__Group_3_0_2__1__Impl )
            // InternalMachine.g:5634:2: rule__FullMeshPath__Group_3_0_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group_3_0_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0_2__1"


    // $ANTLR start "rule__FullMeshPath__Group_3_0_2__1__Impl"
    // InternalMachine.g:5640:1: rule__FullMeshPath__Group_3_0_2__1__Impl : ( ( rule__FullMeshPath__ProfilesAssignment_3_0_2_1 ) ) ;
    public final void rule__FullMeshPath__Group_3_0_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5644:1: ( ( ( rule__FullMeshPath__ProfilesAssignment_3_0_2_1 ) ) )
            // InternalMachine.g:5645:1: ( ( rule__FullMeshPath__ProfilesAssignment_3_0_2_1 ) )
            {
            // InternalMachine.g:5645:1: ( ( rule__FullMeshPath__ProfilesAssignment_3_0_2_1 ) )
            // InternalMachine.g:5646:2: ( rule__FullMeshPath__ProfilesAssignment_3_0_2_1 )
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesAssignment_3_0_2_1()); 
            // InternalMachine.g:5647:2: ( rule__FullMeshPath__ProfilesAssignment_3_0_2_1 )
            // InternalMachine.g:5647:3: rule__FullMeshPath__ProfilesAssignment_3_0_2_1
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__ProfilesAssignment_3_0_2_1();

            state._fsp--;


            }

             after(grammarAccess.getFullMeshPathAccess().getProfilesAssignment_3_0_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_0_2__1__Impl"


    // $ANTLR start "rule__FullMeshPath__Group_3_1__0"
    // InternalMachine.g:5656:1: rule__FullMeshPath__Group_3_1__0 : rule__FullMeshPath__Group_3_1__0__Impl rule__FullMeshPath__Group_3_1__1 ;
    public final void rule__FullMeshPath__Group_3_1__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5660:1: ( rule__FullMeshPath__Group_3_1__0__Impl rule__FullMeshPath__Group_3_1__1 )
            // InternalMachine.g:5661:2: rule__FullMeshPath__Group_3_1__0__Impl rule__FullMeshPath__Group_3_1__1
            {
            pushFollow(FOLLOW_6);
            rule__FullMeshPath__Group_3_1__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group_3_1__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_1__0"


    // $ANTLR start "rule__FullMeshPath__Group_3_1__0__Impl"
    // InternalMachine.g:5668:1: rule__FullMeshPath__Group_3_1__0__Impl : ( 'profile' ) ;
    public final void rule__FullMeshPath__Group_3_1__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5672:1: ( ( 'profile' ) )
            // InternalMachine.g:5673:1: ( 'profile' )
            {
            // InternalMachine.g:5673:1: ( 'profile' )
            // InternalMachine.g:5674:2: 'profile'
            {
             before(grammarAccess.getFullMeshPathAccess().getProfileKeyword_3_1_0()); 
            match(input,37,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getProfileKeyword_3_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_1__0__Impl"


    // $ANTLR start "rule__FullMeshPath__Group_3_1__1"
    // InternalMachine.g:5683:1: rule__FullMeshPath__Group_3_1__1 : rule__FullMeshPath__Group_3_1__1__Impl ;
    public final void rule__FullMeshPath__Group_3_1__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5687:1: ( rule__FullMeshPath__Group_3_1__1__Impl )
            // InternalMachine.g:5688:2: rule__FullMeshPath__Group_3_1__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group_3_1__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_1__1"


    // $ANTLR start "rule__FullMeshPath__Group_3_1__1__Impl"
    // InternalMachine.g:5694:1: rule__FullMeshPath__Group_3_1__1__Impl : ( ( rule__FullMeshPath__ProfilesAssignment_3_1_1 ) ) ;
    public final void rule__FullMeshPath__Group_3_1__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5698:1: ( ( ( rule__FullMeshPath__ProfilesAssignment_3_1_1 ) ) )
            // InternalMachine.g:5699:1: ( ( rule__FullMeshPath__ProfilesAssignment_3_1_1 ) )
            {
            // InternalMachine.g:5699:1: ( ( rule__FullMeshPath__ProfilesAssignment_3_1_1 ) )
            // InternalMachine.g:5700:2: ( rule__FullMeshPath__ProfilesAssignment_3_1_1 )
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesAssignment_3_1_1()); 
            // InternalMachine.g:5701:2: ( rule__FullMeshPath__ProfilesAssignment_3_1_1 )
            // InternalMachine.g:5701:3: rule__FullMeshPath__ProfilesAssignment_3_1_1
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__ProfilesAssignment_3_1_1();

            state._fsp--;


            }

             after(grammarAccess.getFullMeshPathAccess().getProfilesAssignment_3_1_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_3_1__1__Impl"


    // $ANTLR start "rule__FullMeshPath__Group_4__0"
    // InternalMachine.g:5710:1: rule__FullMeshPath__Group_4__0 : rule__FullMeshPath__Group_4__0__Impl rule__FullMeshPath__Group_4__1 ;
    public final void rule__FullMeshPath__Group_4__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5714:1: ( rule__FullMeshPath__Group_4__0__Impl rule__FullMeshPath__Group_4__1 )
            // InternalMachine.g:5715:2: rule__FullMeshPath__Group_4__0__Impl rule__FullMeshPath__Group_4__1
            {
            pushFollow(FOLLOW_6);
            rule__FullMeshPath__Group_4__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group_4__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_4__0"


    // $ANTLR start "rule__FullMeshPath__Group_4__0__Impl"
    // InternalMachine.g:5722:1: rule__FullMeshPath__Group_4__0__Impl : ( '@' ) ;
    public final void rule__FullMeshPath__Group_4__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5726:1: ( ( '@' ) )
            // InternalMachine.g:5727:1: ( '@' )
            {
            // InternalMachine.g:5727:1: ( '@' )
            // InternalMachine.g:5728:2: '@'
            {
             before(grammarAccess.getFullMeshPathAccess().getCommercialAtKeyword_4_0()); 
            match(input,38,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getCommercialAtKeyword_4_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_4__0__Impl"


    // $ANTLR start "rule__FullMeshPath__Group_4__1"
    // InternalMachine.g:5737:1: rule__FullMeshPath__Group_4__1 : rule__FullMeshPath__Group_4__1__Impl ;
    public final void rule__FullMeshPath__Group_4__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5741:1: ( rule__FullMeshPath__Group_4__1__Impl )
            // InternalMachine.g:5742:2: rule__FullMeshPath__Group_4__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__Group_4__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_4__1"


    // $ANTLR start "rule__FullMeshPath__Group_4__1__Impl"
    // InternalMachine.g:5748:1: rule__FullMeshPath__Group_4__1__Impl : ( ( rule__FullMeshPath__AnnotationsAssignment_4_1 ) ) ;
    public final void rule__FullMeshPath__Group_4__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5752:1: ( ( ( rule__FullMeshPath__AnnotationsAssignment_4_1 ) ) )
            // InternalMachine.g:5753:1: ( ( rule__FullMeshPath__AnnotationsAssignment_4_1 ) )
            {
            // InternalMachine.g:5753:1: ( ( rule__FullMeshPath__AnnotationsAssignment_4_1 ) )
            // InternalMachine.g:5754:2: ( rule__FullMeshPath__AnnotationsAssignment_4_1 )
            {
             before(grammarAccess.getFullMeshPathAccess().getAnnotationsAssignment_4_1()); 
            // InternalMachine.g:5755:2: ( rule__FullMeshPath__AnnotationsAssignment_4_1 )
            // InternalMachine.g:5755:3: rule__FullMeshPath__AnnotationsAssignment_4_1
            {
            pushFollow(FOLLOW_2);
            rule__FullMeshPath__AnnotationsAssignment_4_1();

            state._fsp--;


            }

             after(grammarAccess.getFullMeshPathAccess().getAnnotationsAssignment_4_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__Group_4__1__Impl"


    // $ANTLR start "rule__PathTargetReference__Group__0"
    // InternalMachine.g:5764:1: rule__PathTargetReference__Group__0 : rule__PathTargetReference__Group__0__Impl rule__PathTargetReference__Group__1 ;
    public final void rule__PathTargetReference__Group__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5768:1: ( rule__PathTargetReference__Group__0__Impl rule__PathTargetReference__Group__1 )
            // InternalMachine.g:5769:2: rule__PathTargetReference__Group__0__Impl rule__PathTargetReference__Group__1
            {
            pushFollow(FOLLOW_6);
            rule__PathTargetReference__Group__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group__0"


    // $ANTLR start "rule__PathTargetReference__Group__0__Impl"
    // InternalMachine.g:5776:1: rule__PathTargetReference__Group__0__Impl : ( () ) ;
    public final void rule__PathTargetReference__Group__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5780:1: ( ( () ) )
            // InternalMachine.g:5781:1: ( () )
            {
            // InternalMachine.g:5781:1: ( () )
            // InternalMachine.g:5782:2: ()
            {
             before(grammarAccess.getPathTargetReferenceAccess().getPathTargetReferenceAction_0()); 
            // InternalMachine.g:5783:2: ()
            // InternalMachine.g:5783:3: 
            {
            }

             after(grammarAccess.getPathTargetReferenceAccess().getPathTargetReferenceAction_0()); 

            }


            }

        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group__0__Impl"


    // $ANTLR start "rule__PathTargetReference__Group__1"
    // InternalMachine.g:5791:1: rule__PathTargetReference__Group__1 : rule__PathTargetReference__Group__1__Impl rule__PathTargetReference__Group__2 ;
    public final void rule__PathTargetReference__Group__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5795:1: ( rule__PathTargetReference__Group__1__Impl rule__PathTargetReference__Group__2 )
            // InternalMachine.g:5796:2: rule__PathTargetReference__Group__1__Impl rule__PathTargetReference__Group__2
            {
            pushFollow(FOLLOW_15);
            rule__PathTargetReference__Group__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group__1"


    // $ANTLR start "rule__PathTargetReference__Group__1__Impl"
    // InternalMachine.g:5803:1: rule__PathTargetReference__Group__1__Impl : ( ( rule__PathTargetReference__PositionAssignment_1 ) ) ;
    public final void rule__PathTargetReference__Group__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5807:1: ( ( ( rule__PathTargetReference__PositionAssignment_1 ) ) )
            // InternalMachine.g:5808:1: ( ( rule__PathTargetReference__PositionAssignment_1 ) )
            {
            // InternalMachine.g:5808:1: ( ( rule__PathTargetReference__PositionAssignment_1 ) )
            // InternalMachine.g:5809:2: ( rule__PathTargetReference__PositionAssignment_1 )
            {
             before(grammarAccess.getPathTargetReferenceAccess().getPositionAssignment_1()); 
            // InternalMachine.g:5810:2: ( rule__PathTargetReference__PositionAssignment_1 )
            // InternalMachine.g:5810:3: rule__PathTargetReference__PositionAssignment_1
            {
            pushFollow(FOLLOW_2);
            rule__PathTargetReference__PositionAssignment_1();

            state._fsp--;


            }

             after(grammarAccess.getPathTargetReferenceAccess().getPositionAssignment_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group__1__Impl"


    // $ANTLR start "rule__PathTargetReference__Group__2"
    // InternalMachine.g:5818:1: rule__PathTargetReference__Group__2 : rule__PathTargetReference__Group__2__Impl ;
    public final void rule__PathTargetReference__Group__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5822:1: ( rule__PathTargetReference__Group__2__Impl )
            // InternalMachine.g:5823:2: rule__PathTargetReference__Group__2__Impl
            {
            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group__2__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group__2"


    // $ANTLR start "rule__PathTargetReference__Group__2__Impl"
    // InternalMachine.g:5829:1: rule__PathTargetReference__Group__2__Impl : ( ( rule__PathTargetReference__Group_2__0 )? ) ;
    public final void rule__PathTargetReference__Group__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5833:1: ( ( ( rule__PathTargetReference__Group_2__0 )? ) )
            // InternalMachine.g:5834:1: ( ( rule__PathTargetReference__Group_2__0 )? )
            {
            // InternalMachine.g:5834:1: ( ( rule__PathTargetReference__Group_2__0 )? )
            // InternalMachine.g:5835:2: ( rule__PathTargetReference__Group_2__0 )?
            {
             before(grammarAccess.getPathTargetReferenceAccess().getGroup_2()); 
            // InternalMachine.g:5836:2: ( rule__PathTargetReference__Group_2__0 )?
            int alt49=2;
            int LA49_0 = input.LA(1);

            if ( (LA49_0==21) ) {
                alt49=1;
            }
            switch (alt49) {
                case 1 :
                    // InternalMachine.g:5836:3: rule__PathTargetReference__Group_2__0
                    {
                    pushFollow(FOLLOW_2);
                    rule__PathTargetReference__Group_2__0();

                    state._fsp--;


                    }
                    break;

            }

             after(grammarAccess.getPathTargetReferenceAccess().getGroup_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group__2__Impl"


    // $ANTLR start "rule__PathTargetReference__Group_2__0"
    // InternalMachine.g:5845:1: rule__PathTargetReference__Group_2__0 : rule__PathTargetReference__Group_2__0__Impl rule__PathTargetReference__Group_2__1 ;
    public final void rule__PathTargetReference__Group_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5849:1: ( rule__PathTargetReference__Group_2__0__Impl rule__PathTargetReference__Group_2__1 )
            // InternalMachine.g:5850:2: rule__PathTargetReference__Group_2__0__Impl rule__PathTargetReference__Group_2__1
            {
            pushFollow(FOLLOW_6);
            rule__PathTargetReference__Group_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2__0"


    // $ANTLR start "rule__PathTargetReference__Group_2__0__Impl"
    // InternalMachine.g:5857:1: rule__PathTargetReference__Group_2__0__Impl : ( '[' ) ;
    public final void rule__PathTargetReference__Group_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5861:1: ( ( '[' ) )
            // InternalMachine.g:5862:1: ( '[' )
            {
            // InternalMachine.g:5862:1: ( '[' )
            // InternalMachine.g:5863:2: '['
            {
             before(grammarAccess.getPathTargetReferenceAccess().getLeftSquareBracketKeyword_2_0()); 
            match(input,21,FOLLOW_2); 
             after(grammarAccess.getPathTargetReferenceAccess().getLeftSquareBracketKeyword_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2__0__Impl"


    // $ANTLR start "rule__PathTargetReference__Group_2__1"
    // InternalMachine.g:5872:1: rule__PathTargetReference__Group_2__1 : rule__PathTargetReference__Group_2__1__Impl rule__PathTargetReference__Group_2__2 ;
    public final void rule__PathTargetReference__Group_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5876:1: ( rule__PathTargetReference__Group_2__1__Impl rule__PathTargetReference__Group_2__2 )
            // InternalMachine.g:5877:2: rule__PathTargetReference__Group_2__1__Impl rule__PathTargetReference__Group_2__2
            {
            pushFollow(FOLLOW_30);
            rule__PathTargetReference__Group_2__1__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group_2__2();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2__1"


    // $ANTLR start "rule__PathTargetReference__Group_2__1__Impl"
    // InternalMachine.g:5884:1: rule__PathTargetReference__Group_2__1__Impl : ( ( rule__PathTargetReference__SettlingAssignment_2_1 ) ) ;
    public final void rule__PathTargetReference__Group_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5888:1: ( ( ( rule__PathTargetReference__SettlingAssignment_2_1 ) ) )
            // InternalMachine.g:5889:1: ( ( rule__PathTargetReference__SettlingAssignment_2_1 ) )
            {
            // InternalMachine.g:5889:1: ( ( rule__PathTargetReference__SettlingAssignment_2_1 ) )
            // InternalMachine.g:5890:2: ( rule__PathTargetReference__SettlingAssignment_2_1 )
            {
             before(grammarAccess.getPathTargetReferenceAccess().getSettlingAssignment_2_1()); 
            // InternalMachine.g:5891:2: ( rule__PathTargetReference__SettlingAssignment_2_1 )
            // InternalMachine.g:5891:3: rule__PathTargetReference__SettlingAssignment_2_1
            {
            pushFollow(FOLLOW_2);
            rule__PathTargetReference__SettlingAssignment_2_1();

            state._fsp--;


            }

             after(grammarAccess.getPathTargetReferenceAccess().getSettlingAssignment_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2__1__Impl"


    // $ANTLR start "rule__PathTargetReference__Group_2__2"
    // InternalMachine.g:5899:1: rule__PathTargetReference__Group_2__2 : rule__PathTargetReference__Group_2__2__Impl rule__PathTargetReference__Group_2__3 ;
    public final void rule__PathTargetReference__Group_2__2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5903:1: ( rule__PathTargetReference__Group_2__2__Impl rule__PathTargetReference__Group_2__3 )
            // InternalMachine.g:5904:2: rule__PathTargetReference__Group_2__2__Impl rule__PathTargetReference__Group_2__3
            {
            pushFollow(FOLLOW_30);
            rule__PathTargetReference__Group_2__2__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group_2__3();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2__2"


    // $ANTLR start "rule__PathTargetReference__Group_2__2__Impl"
    // InternalMachine.g:5911:1: rule__PathTargetReference__Group_2__2__Impl : ( ( rule__PathTargetReference__Group_2_2__0 )* ) ;
    public final void rule__PathTargetReference__Group_2__2__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5915:1: ( ( ( rule__PathTargetReference__Group_2_2__0 )* ) )
            // InternalMachine.g:5916:1: ( ( rule__PathTargetReference__Group_2_2__0 )* )
            {
            // InternalMachine.g:5916:1: ( ( rule__PathTargetReference__Group_2_2__0 )* )
            // InternalMachine.g:5917:2: ( rule__PathTargetReference__Group_2_2__0 )*
            {
             before(grammarAccess.getPathTargetReferenceAccess().getGroup_2_2()); 
            // InternalMachine.g:5918:2: ( rule__PathTargetReference__Group_2_2__0 )*
            loop50:
            do {
                int alt50=2;
                int LA50_0 = input.LA(1);

                if ( (LA50_0==24) ) {
                    alt50=1;
                }


                switch (alt50) {
            	case 1 :
            	    // InternalMachine.g:5918:3: rule__PathTargetReference__Group_2_2__0
            	    {
            	    pushFollow(FOLLOW_19);
            	    rule__PathTargetReference__Group_2_2__0();

            	    state._fsp--;


            	    }
            	    break;

            	default :
            	    break loop50;
                }
            } while (true);

             after(grammarAccess.getPathTargetReferenceAccess().getGroup_2_2()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2__2__Impl"


    // $ANTLR start "rule__PathTargetReference__Group_2__3"
    // InternalMachine.g:5926:1: rule__PathTargetReference__Group_2__3 : rule__PathTargetReference__Group_2__3__Impl ;
    public final void rule__PathTargetReference__Group_2__3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5930:1: ( rule__PathTargetReference__Group_2__3__Impl )
            // InternalMachine.g:5931:2: rule__PathTargetReference__Group_2__3__Impl
            {
            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group_2__3__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2__3"


    // $ANTLR start "rule__PathTargetReference__Group_2__3__Impl"
    // InternalMachine.g:5937:1: rule__PathTargetReference__Group_2__3__Impl : ( ']' ) ;
    public final void rule__PathTargetReference__Group_2__3__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5941:1: ( ( ']' ) )
            // InternalMachine.g:5942:1: ( ']' )
            {
            // InternalMachine.g:5942:1: ( ']' )
            // InternalMachine.g:5943:2: ']'
            {
             before(grammarAccess.getPathTargetReferenceAccess().getRightSquareBracketKeyword_2_3()); 
            match(input,22,FOLLOW_2); 
             after(grammarAccess.getPathTargetReferenceAccess().getRightSquareBracketKeyword_2_3()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2__3__Impl"


    // $ANTLR start "rule__PathTargetReference__Group_2_2__0"
    // InternalMachine.g:5953:1: rule__PathTargetReference__Group_2_2__0 : rule__PathTargetReference__Group_2_2__0__Impl rule__PathTargetReference__Group_2_2__1 ;
    public final void rule__PathTargetReference__Group_2_2__0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5957:1: ( rule__PathTargetReference__Group_2_2__0__Impl rule__PathTargetReference__Group_2_2__1 )
            // InternalMachine.g:5958:2: rule__PathTargetReference__Group_2_2__0__Impl rule__PathTargetReference__Group_2_2__1
            {
            pushFollow(FOLLOW_6);
            rule__PathTargetReference__Group_2_2__0__Impl();

            state._fsp--;

            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group_2_2__1();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2_2__0"


    // $ANTLR start "rule__PathTargetReference__Group_2_2__0__Impl"
    // InternalMachine.g:5965:1: rule__PathTargetReference__Group_2_2__0__Impl : ( ',' ) ;
    public final void rule__PathTargetReference__Group_2_2__0__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5969:1: ( ( ',' ) )
            // InternalMachine.g:5970:1: ( ',' )
            {
            // InternalMachine.g:5970:1: ( ',' )
            // InternalMachine.g:5971:2: ','
            {
             before(grammarAccess.getPathTargetReferenceAccess().getCommaKeyword_2_2_0()); 
            match(input,24,FOLLOW_2); 
             after(grammarAccess.getPathTargetReferenceAccess().getCommaKeyword_2_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2_2__0__Impl"


    // $ANTLR start "rule__PathTargetReference__Group_2_2__1"
    // InternalMachine.g:5980:1: rule__PathTargetReference__Group_2_2__1 : rule__PathTargetReference__Group_2_2__1__Impl ;
    public final void rule__PathTargetReference__Group_2_2__1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5984:1: ( rule__PathTargetReference__Group_2_2__1__Impl )
            // InternalMachine.g:5985:2: rule__PathTargetReference__Group_2_2__1__Impl
            {
            pushFollow(FOLLOW_2);
            rule__PathTargetReference__Group_2_2__1__Impl();

            state._fsp--;


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2_2__1"


    // $ANTLR start "rule__PathTargetReference__Group_2_2__1__Impl"
    // InternalMachine.g:5991:1: rule__PathTargetReference__Group_2_2__1__Impl : ( ( rule__PathTargetReference__SettlingAssignment_2_2_1 ) ) ;
    public final void rule__PathTargetReference__Group_2_2__1__Impl() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:5995:1: ( ( ( rule__PathTargetReference__SettlingAssignment_2_2_1 ) ) )
            // InternalMachine.g:5996:1: ( ( rule__PathTargetReference__SettlingAssignment_2_2_1 ) )
            {
            // InternalMachine.g:5996:1: ( ( rule__PathTargetReference__SettlingAssignment_2_2_1 ) )
            // InternalMachine.g:5997:2: ( rule__PathTargetReference__SettlingAssignment_2_2_1 )
            {
             before(grammarAccess.getPathTargetReferenceAccess().getSettlingAssignment_2_2_1()); 
            // InternalMachine.g:5998:2: ( rule__PathTargetReference__SettlingAssignment_2_2_1 )
            // InternalMachine.g:5998:3: rule__PathTargetReference__SettlingAssignment_2_2_1
            {
            pushFollow(FOLLOW_2);
            rule__PathTargetReference__SettlingAssignment_2_2_1();

            state._fsp--;


            }

             after(grammarAccess.getPathTargetReferenceAccess().getSettlingAssignment_2_2_1()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__Group_2_2__1__Impl"


    // $ANTLR start "rule__Machine__ImportsAssignment_1"
    // InternalMachine.g:6007:1: rule__Machine__ImportsAssignment_1 : ( ruleImport ) ;
    public final void rule__Machine__ImportsAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6011:1: ( ( ruleImport ) )
            // InternalMachine.g:6012:2: ( ruleImport )
            {
            // InternalMachine.g:6012:2: ( ruleImport )
            // InternalMachine.g:6013:3: ruleImport
            {
             before(grammarAccess.getMachineAccess().getImportsImportParserRuleCall_1_0()); 
            pushFollow(FOLLOW_2);
            ruleImport();

            state._fsp--;

             after(grammarAccess.getMachineAccess().getImportsImportParserRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__ImportsAssignment_1"


    // $ANTLR start "rule__Machine__TypeAssignment_2_1"
    // InternalMachine.g:6022:1: rule__Machine__TypeAssignment_2_1 : ( RULE_ID ) ;
    public final void rule__Machine__TypeAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6026:1: ( ( RULE_ID ) )
            // InternalMachine.g:6027:2: ( RULE_ID )
            {
            // InternalMachine.g:6027:2: ( RULE_ID )
            // InternalMachine.g:6028:3: RULE_ID
            {
             before(grammarAccess.getMachineAccess().getTypeIDTerminalRuleCall_2_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getMachineAccess().getTypeIDTerminalRuleCall_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__TypeAssignment_2_1"


    // $ANTLR start "rule__Machine__PathAnnotationsAssignment_3_2"
    // InternalMachine.g:6037:1: rule__Machine__PathAnnotationsAssignment_3_2 : ( rulePathAnnotation ) ;
    public final void rule__Machine__PathAnnotationsAssignment_3_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6041:1: ( ( rulePathAnnotation ) )
            // InternalMachine.g:6042:2: ( rulePathAnnotation )
            {
            // InternalMachine.g:6042:2: ( rulePathAnnotation )
            // InternalMachine.g:6043:3: rulePathAnnotation
            {
             before(grammarAccess.getMachineAccess().getPathAnnotationsPathAnnotationParserRuleCall_3_2_0()); 
            pushFollow(FOLLOW_2);
            rulePathAnnotation();

            state._fsp--;

             after(grammarAccess.getMachineAccess().getPathAnnotationsPathAnnotationParserRuleCall_3_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__PathAnnotationsAssignment_3_2"


    // $ANTLR start "rule__Machine__PeripheralTypesAssignment_4_0"
    // InternalMachine.g:6052:1: rule__Machine__PeripheralTypesAssignment_4_0 : ( rulePeripheralType ) ;
    public final void rule__Machine__PeripheralTypesAssignment_4_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6056:1: ( ( rulePeripheralType ) )
            // InternalMachine.g:6057:2: ( rulePeripheralType )
            {
            // InternalMachine.g:6057:2: ( rulePeripheralType )
            // InternalMachine.g:6058:3: rulePeripheralType
            {
             before(grammarAccess.getMachineAccess().getPeripheralTypesPeripheralTypeParserRuleCall_4_0_0()); 
            pushFollow(FOLLOW_2);
            rulePeripheralType();

            state._fsp--;

             after(grammarAccess.getMachineAccess().getPeripheralTypesPeripheralTypeParserRuleCall_4_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__PeripheralTypesAssignment_4_0"


    // $ANTLR start "rule__Machine__ResourcesAssignment_4_1"
    // InternalMachine.g:6067:1: rule__Machine__ResourcesAssignment_4_1 : ( ruleResource ) ;
    public final void rule__Machine__ResourcesAssignment_4_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6071:1: ( ( ruleResource ) )
            // InternalMachine.g:6072:2: ( ruleResource )
            {
            // InternalMachine.g:6072:2: ( ruleResource )
            // InternalMachine.g:6073:3: ruleResource
            {
             before(grammarAccess.getMachineAccess().getResourcesResourceParserRuleCall_4_1_0()); 
            pushFollow(FOLLOW_2);
            ruleResource();

            state._fsp--;

             after(grammarAccess.getMachineAccess().getResourcesResourceParserRuleCall_4_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Machine__ResourcesAssignment_4_1"


    // $ANTLR start "rule__Import__ImportURIAssignment_1"
    // InternalMachine.g:6082:1: rule__Import__ImportURIAssignment_1 : ( RULE_STRING ) ;
    public final void rule__Import__ImportURIAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6086:1: ( ( RULE_STRING ) )
            // InternalMachine.g:6087:2: ( RULE_STRING )
            {
            // InternalMachine.g:6087:2: ( RULE_STRING )
            // InternalMachine.g:6088:3: RULE_STRING
            {
             before(grammarAccess.getImportAccess().getImportURISTRINGTerminalRuleCall_1_0()); 
            match(input,RULE_STRING,FOLLOW_2); 
             after(grammarAccess.getImportAccess().getImportURISTRINGTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Import__ImportURIAssignment_1"


    // $ANTLR start "rule__PathAnnotation__NameAssignment_1"
    // InternalMachine.g:6097:1: rule__PathAnnotation__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__PathAnnotation__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6101:1: ( ( RULE_ID ) )
            // InternalMachine.g:6102:2: ( RULE_ID )
            {
            // InternalMachine.g:6102:2: ( RULE_ID )
            // InternalMachine.g:6103:3: RULE_ID
            {
             before(grammarAccess.getPathAnnotationAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getPathAnnotationAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathAnnotation__NameAssignment_1"


    // $ANTLR start "rule__PeripheralType__NameAssignment_2"
    // InternalMachine.g:6112:1: rule__PeripheralType__NameAssignment_2 : ( RULE_ID ) ;
    public final void rule__PeripheralType__NameAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6116:1: ( ( RULE_ID ) )
            // InternalMachine.g:6117:2: ( RULE_ID )
            {
            // InternalMachine.g:6117:2: ( RULE_ID )
            // InternalMachine.g:6118:3: RULE_ID
            {
             before(grammarAccess.getPeripheralTypeAccess().getNameIDTerminalRuleCall_2_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getNameIDTerminalRuleCall_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__NameAssignment_2"


    // $ANTLR start "rule__PeripheralType__ActionsAssignment_4_2"
    // InternalMachine.g:6127:1: rule__PeripheralType__ActionsAssignment_4_2 : ( ruleActionType ) ;
    public final void rule__PeripheralType__ActionsAssignment_4_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6131:1: ( ( ruleActionType ) )
            // InternalMachine.g:6132:2: ( ruleActionType )
            {
            // InternalMachine.g:6132:2: ( ruleActionType )
            // InternalMachine.g:6133:3: ruleActionType
            {
             before(grammarAccess.getPeripheralTypeAccess().getActionsActionTypeParserRuleCall_4_2_0()); 
            pushFollow(FOLLOW_2);
            ruleActionType();

            state._fsp--;

             after(grammarAccess.getPeripheralTypeAccess().getActionsActionTypeParserRuleCall_4_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__ActionsAssignment_4_2"


    // $ANTLR start "rule__PeripheralType__SetPointsAssignment_5_2"
    // InternalMachine.g:6142:1: rule__PeripheralType__SetPointsAssignment_5_2 : ( ruleSetPoint ) ;
    public final void rule__PeripheralType__SetPointsAssignment_5_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6146:1: ( ( ruleSetPoint ) )
            // InternalMachine.g:6147:2: ( ruleSetPoint )
            {
            // InternalMachine.g:6147:2: ( ruleSetPoint )
            // InternalMachine.g:6148:3: ruleSetPoint
            {
             before(grammarAccess.getPeripheralTypeAccess().getSetPointsSetPointParserRuleCall_5_2_0()); 
            pushFollow(FOLLOW_2);
            ruleSetPoint();

            state._fsp--;

             after(grammarAccess.getPeripheralTypeAccess().getSetPointsSetPointParserRuleCall_5_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__SetPointsAssignment_5_2"


    // $ANTLR start "rule__PeripheralType__AxesAssignment_5_6"
    // InternalMachine.g:6157:1: rule__PeripheralType__AxesAssignment_5_6 : ( ruleAxis ) ;
    public final void rule__PeripheralType__AxesAssignment_5_6() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6161:1: ( ( ruleAxis ) )
            // InternalMachine.g:6162:2: ( ruleAxis )
            {
            // InternalMachine.g:6162:2: ( ruleAxis )
            // InternalMachine.g:6163:3: ruleAxis
            {
             before(grammarAccess.getPeripheralTypeAccess().getAxesAxisParserRuleCall_5_6_0()); 
            pushFollow(FOLLOW_2);
            ruleAxis();

            state._fsp--;

             after(grammarAccess.getPeripheralTypeAccess().getAxesAxisParserRuleCall_5_6_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__AxesAssignment_5_6"


    // $ANTLR start "rule__PeripheralType__ConversionAssignment_5_8_1"
    // InternalMachine.g:6172:1: rule__PeripheralType__ConversionAssignment_5_8_1 : ( RULE_STRING ) ;
    public final void rule__PeripheralType__ConversionAssignment_5_8_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6176:1: ( ( RULE_STRING ) )
            // InternalMachine.g:6177:2: ( RULE_STRING )
            {
            // InternalMachine.g:6177:2: ( RULE_STRING )
            // InternalMachine.g:6178:3: RULE_STRING
            {
             before(grammarAccess.getPeripheralTypeAccess().getConversionSTRINGTerminalRuleCall_5_8_1_0()); 
            match(input,RULE_STRING,FOLLOW_2); 
             after(grammarAccess.getPeripheralTypeAccess().getConversionSTRINGTerminalRuleCall_5_8_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PeripheralType__ConversionAssignment_5_8_1"


    // $ANTLR start "rule__ActionType__NameAssignment_1"
    // InternalMachine.g:6187:1: rule__ActionType__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__ActionType__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6191:1: ( ( RULE_ID ) )
            // InternalMachine.g:6192:2: ( RULE_ID )
            {
            // InternalMachine.g:6192:2: ( RULE_ID )
            // InternalMachine.g:6193:3: RULE_ID
            {
             before(grammarAccess.getActionTypeAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getActionTypeAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ActionType__NameAssignment_1"


    // $ANTLR start "rule__SetPoint__NameAssignment_1"
    // InternalMachine.g:6202:1: rule__SetPoint__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__SetPoint__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6206:1: ( ( RULE_ID ) )
            // InternalMachine.g:6207:2: ( RULE_ID )
            {
            // InternalMachine.g:6207:2: ( RULE_ID )
            // InternalMachine.g:6208:3: RULE_ID
            {
             before(grammarAccess.getSetPointAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getSetPointAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__NameAssignment_1"


    // $ANTLR start "rule__SetPoint__UnitAssignment_2_1"
    // InternalMachine.g:6217:1: rule__SetPoint__UnitAssignment_2_1 : ( RULE_ID ) ;
    public final void rule__SetPoint__UnitAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6221:1: ( ( RULE_ID ) )
            // InternalMachine.g:6222:2: ( RULE_ID )
            {
            // InternalMachine.g:6222:2: ( RULE_ID )
            // InternalMachine.g:6223:3: RULE_ID
            {
             before(grammarAccess.getSetPointAccess().getUnitIDTerminalRuleCall_2_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getSetPointAccess().getUnitIDTerminalRuleCall_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SetPoint__UnitAssignment_2_1"


    // $ANTLR start "rule__Axis__NameAssignment_1"
    // InternalMachine.g:6232:1: rule__Axis__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__Axis__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6236:1: ( ( RULE_ID ) )
            // InternalMachine.g:6237:2: ( RULE_ID )
            {
            // InternalMachine.g:6237:2: ( RULE_ID )
            // InternalMachine.g:6238:3: RULE_ID
            {
             before(grammarAccess.getAxisAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getAxisAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__NameAssignment_1"


    // $ANTLR start "rule__Axis__UnitAssignment_2_1"
    // InternalMachine.g:6247:1: rule__Axis__UnitAssignment_2_1 : ( RULE_ID ) ;
    public final void rule__Axis__UnitAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6251:1: ( ( RULE_ID ) )
            // InternalMachine.g:6252:2: ( RULE_ID )
            {
            // InternalMachine.g:6252:2: ( RULE_ID )
            // InternalMachine.g:6253:3: RULE_ID
            {
             before(grammarAccess.getAxisAccess().getUnitIDTerminalRuleCall_2_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getAxisAccess().getUnitIDTerminalRuleCall_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__UnitAssignment_2_1"


    // $ANTLR start "rule__Axis__SetPointsAssignment_3_1"
    // InternalMachine.g:6262:1: rule__Axis__SetPointsAssignment_3_1 : ( ( RULE_ID ) ) ;
    public final void rule__Axis__SetPointsAssignment_3_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6266:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6267:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6267:2: ( ( RULE_ID ) )
            // InternalMachine.g:6268:3: ( RULE_ID )
            {
             before(grammarAccess.getAxisAccess().getSetPointsSetPointCrossReference_3_1_0()); 
            // InternalMachine.g:6269:3: ( RULE_ID )
            // InternalMachine.g:6270:4: RULE_ID
            {
             before(grammarAccess.getAxisAccess().getSetPointsSetPointIDTerminalRuleCall_3_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getAxisAccess().getSetPointsSetPointIDTerminalRuleCall_3_1_0_1()); 

            }

             after(grammarAccess.getAxisAccess().getSetPointsSetPointCrossReference_3_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__SetPointsAssignment_3_1"


    // $ANTLR start "rule__Axis__SetPointsAssignment_3_2_1"
    // InternalMachine.g:6281:1: rule__Axis__SetPointsAssignment_3_2_1 : ( ( RULE_ID ) ) ;
    public final void rule__Axis__SetPointsAssignment_3_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6285:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6286:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6286:2: ( ( RULE_ID ) )
            // InternalMachine.g:6287:3: ( RULE_ID )
            {
             before(grammarAccess.getAxisAccess().getSetPointsSetPointCrossReference_3_2_1_0()); 
            // InternalMachine.g:6288:3: ( RULE_ID )
            // InternalMachine.g:6289:4: RULE_ID
            {
             before(grammarAccess.getAxisAccess().getSetPointsSetPointIDTerminalRuleCall_3_2_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getAxisAccess().getSetPointsSetPointIDTerminalRuleCall_3_2_1_0_1()); 

            }

             after(grammarAccess.getAxisAccess().getSetPointsSetPointCrossReference_3_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Axis__SetPointsAssignment_3_2_1"


    // $ANTLR start "rule__ResourceItem__NameAssignment_1"
    // InternalMachine.g:6300:1: rule__ResourceItem__NameAssignment_1 : ( ruleIID ) ;
    public final void rule__ResourceItem__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6304:1: ( ( ruleIID ) )
            // InternalMachine.g:6305:2: ( ruleIID )
            {
            // InternalMachine.g:6305:2: ( ruleIID )
            // InternalMachine.g:6306:3: ruleIID
            {
             before(grammarAccess.getResourceItemAccess().getNameIIDParserRuleCall_1_0()); 
            pushFollow(FOLLOW_2);
            ruleIID();

            state._fsp--;

             after(grammarAccess.getResourceItemAccess().getNameIIDParserRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__ResourceItem__NameAssignment_1"


    // $ANTLR start "rule__Resource__NameAssignment_1"
    // InternalMachine.g:6315:1: rule__Resource__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__Resource__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6319:1: ( ( RULE_ID ) )
            // InternalMachine.g:6320:2: ( RULE_ID )
            {
            // InternalMachine.g:6320:2: ( RULE_ID )
            // InternalMachine.g:6321:3: RULE_ID
            {
             before(grammarAccess.getResourceAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getResourceAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__NameAssignment_1"


    // $ANTLR start "rule__Resource__ItemsAssignment_2_1"
    // InternalMachine.g:6330:1: rule__Resource__ItemsAssignment_2_1 : ( ruleResourceItem ) ;
    public final void rule__Resource__ItemsAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6334:1: ( ( ruleResourceItem ) )
            // InternalMachine.g:6335:2: ( ruleResourceItem )
            {
            // InternalMachine.g:6335:2: ( ruleResourceItem )
            // InternalMachine.g:6336:3: ruleResourceItem
            {
             before(grammarAccess.getResourceAccess().getItemsResourceItemParserRuleCall_2_1_0()); 
            pushFollow(FOLLOW_2);
            ruleResourceItem();

            state._fsp--;

             after(grammarAccess.getResourceAccess().getItemsResourceItemParserRuleCall_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__ItemsAssignment_2_1"


    // $ANTLR start "rule__Resource__ItemsAssignment_2_2_1"
    // InternalMachine.g:6345:1: rule__Resource__ItemsAssignment_2_2_1 : ( ruleResourceItem ) ;
    public final void rule__Resource__ItemsAssignment_2_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6349:1: ( ( ruleResourceItem ) )
            // InternalMachine.g:6350:2: ( ruleResourceItem )
            {
            // InternalMachine.g:6350:2: ( ruleResourceItem )
            // InternalMachine.g:6351:3: ruleResourceItem
            {
             before(grammarAccess.getResourceAccess().getItemsResourceItemParserRuleCall_2_2_1_0()); 
            pushFollow(FOLLOW_2);
            ruleResourceItem();

            state._fsp--;

             after(grammarAccess.getResourceAccess().getItemsResourceItemParserRuleCall_2_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__ItemsAssignment_2_2_1"


    // $ANTLR start "rule__Resource__PeripheralsAssignment_4"
    // InternalMachine.g:6360:1: rule__Resource__PeripheralsAssignment_4 : ( rulePeripheral ) ;
    public final void rule__Resource__PeripheralsAssignment_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6364:1: ( ( rulePeripheral ) )
            // InternalMachine.g:6365:2: ( rulePeripheral )
            {
            // InternalMachine.g:6365:2: ( rulePeripheral )
            // InternalMachine.g:6366:3: rulePeripheral
            {
             before(grammarAccess.getResourceAccess().getPeripheralsPeripheralParserRuleCall_4_0()); 
            pushFollow(FOLLOW_2);
            rulePeripheral();

            state._fsp--;

             after(grammarAccess.getResourceAccess().getPeripheralsPeripheralParserRuleCall_4_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Resource__PeripheralsAssignment_4"


    // $ANTLR start "rule__Peripheral__NameAssignment_0"
    // InternalMachine.g:6375:1: rule__Peripheral__NameAssignment_0 : ( RULE_ID ) ;
    public final void rule__Peripheral__NameAssignment_0() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6379:1: ( ( RULE_ID ) )
            // InternalMachine.g:6380:2: ( RULE_ID )
            {
            // InternalMachine.g:6380:2: ( RULE_ID )
            // InternalMachine.g:6381:3: RULE_ID
            {
             before(grammarAccess.getPeripheralAccess().getNameIDTerminalRuleCall_0_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getNameIDTerminalRuleCall_0_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__NameAssignment_0"


    // $ANTLR start "rule__Peripheral__TypeAssignment_2"
    // InternalMachine.g:6390:1: rule__Peripheral__TypeAssignment_2 : ( ( RULE_ID ) ) ;
    public final void rule__Peripheral__TypeAssignment_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6394:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6395:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6395:2: ( ( RULE_ID ) )
            // InternalMachine.g:6396:3: ( RULE_ID )
            {
             before(grammarAccess.getPeripheralAccess().getTypePeripheralTypeCrossReference_2_0()); 
            // InternalMachine.g:6397:3: ( RULE_ID )
            // InternalMachine.g:6398:4: RULE_ID
            {
             before(grammarAccess.getPeripheralAccess().getTypePeripheralTypeIDTerminalRuleCall_2_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getPeripheralAccess().getTypePeripheralTypeIDTerminalRuleCall_2_0_1()); 

            }

             after(grammarAccess.getPeripheralAccess().getTypePeripheralTypeCrossReference_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__TypeAssignment_2"


    // $ANTLR start "rule__Peripheral__AxisPositionsAssignment_3_1_0_2"
    // InternalMachine.g:6409:1: rule__Peripheral__AxisPositionsAssignment_3_1_0_2 : ( ruleAxisPositionsMapEntry ) ;
    public final void rule__Peripheral__AxisPositionsAssignment_3_1_0_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6413:1: ( ( ruleAxisPositionsMapEntry ) )
            // InternalMachine.g:6414:2: ( ruleAxisPositionsMapEntry )
            {
            // InternalMachine.g:6414:2: ( ruleAxisPositionsMapEntry )
            // InternalMachine.g:6415:3: ruleAxisPositionsMapEntry
            {
             before(grammarAccess.getPeripheralAccess().getAxisPositionsAxisPositionsMapEntryParserRuleCall_3_1_0_2_0()); 
            pushFollow(FOLLOW_2);
            ruleAxisPositionsMapEntry();

            state._fsp--;

             after(grammarAccess.getPeripheralAccess().getAxisPositionsAxisPositionsMapEntryParserRuleCall_3_1_0_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__AxisPositionsAssignment_3_1_0_2"


    // $ANTLR start "rule__Peripheral__PositionsAssignment_3_1_1_2"
    // InternalMachine.g:6424:1: rule__Peripheral__PositionsAssignment_3_1_1_2 : ( ruleSymbolicPosition ) ;
    public final void rule__Peripheral__PositionsAssignment_3_1_1_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6428:1: ( ( ruleSymbolicPosition ) )
            // InternalMachine.g:6429:2: ( ruleSymbolicPosition )
            {
            // InternalMachine.g:6429:2: ( ruleSymbolicPosition )
            // InternalMachine.g:6430:3: ruleSymbolicPosition
            {
             before(grammarAccess.getPeripheralAccess().getPositionsSymbolicPositionParserRuleCall_3_1_1_2_0()); 
            pushFollow(FOLLOW_2);
            ruleSymbolicPosition();

            state._fsp--;

             after(grammarAccess.getPeripheralAccess().getPositionsSymbolicPositionParserRuleCall_3_1_1_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__PositionsAssignment_3_1_1_2"


    // $ANTLR start "rule__Peripheral__ProfilesAssignment_3_1_4"
    // InternalMachine.g:6439:1: rule__Peripheral__ProfilesAssignment_3_1_4 : ( ruleProfile ) ;
    public final void rule__Peripheral__ProfilesAssignment_3_1_4() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6443:1: ( ( ruleProfile ) )
            // InternalMachine.g:6444:2: ( ruleProfile )
            {
            // InternalMachine.g:6444:2: ( ruleProfile )
            // InternalMachine.g:6445:3: ruleProfile
            {
             before(grammarAccess.getPeripheralAccess().getProfilesProfileParserRuleCall_3_1_4_0()); 
            pushFollow(FOLLOW_2);
            ruleProfile();

            state._fsp--;

             after(grammarAccess.getPeripheralAccess().getProfilesProfileParserRuleCall_3_1_4_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__ProfilesAssignment_3_1_4"


    // $ANTLR start "rule__Peripheral__ProfilesAssignment_3_1_5_1"
    // InternalMachine.g:6454:1: rule__Peripheral__ProfilesAssignment_3_1_5_1 : ( ruleProfile ) ;
    public final void rule__Peripheral__ProfilesAssignment_3_1_5_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6458:1: ( ( ruleProfile ) )
            // InternalMachine.g:6459:2: ( ruleProfile )
            {
            // InternalMachine.g:6459:2: ( ruleProfile )
            // InternalMachine.g:6460:3: ruleProfile
            {
             before(grammarAccess.getPeripheralAccess().getProfilesProfileParserRuleCall_3_1_5_1_0()); 
            pushFollow(FOLLOW_2);
            ruleProfile();

            state._fsp--;

             after(grammarAccess.getPeripheralAccess().getProfilesProfileParserRuleCall_3_1_5_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__ProfilesAssignment_3_1_5_1"


    // $ANTLR start "rule__Peripheral__DistancesAssignment_3_1_7_2"
    // InternalMachine.g:6469:1: rule__Peripheral__DistancesAssignment_3_1_7_2 : ( ruleDistance ) ;
    public final void rule__Peripheral__DistancesAssignment_3_1_7_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6473:1: ( ( ruleDistance ) )
            // InternalMachine.g:6474:2: ( ruleDistance )
            {
            // InternalMachine.g:6474:2: ( ruleDistance )
            // InternalMachine.g:6475:3: ruleDistance
            {
             before(grammarAccess.getPeripheralAccess().getDistancesDistanceParserRuleCall_3_1_7_2_0()); 
            pushFollow(FOLLOW_2);
            ruleDistance();

            state._fsp--;

             after(grammarAccess.getPeripheralAccess().getDistancesDistanceParserRuleCall_3_1_7_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__DistancesAssignment_3_1_7_2"


    // $ANTLR start "rule__Peripheral__PathsAssignment_3_1_8_2"
    // InternalMachine.g:6484:1: rule__Peripheral__PathsAssignment_3_1_8_2 : ( rulePath ) ;
    public final void rule__Peripheral__PathsAssignment_3_1_8_2() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6488:1: ( ( rulePath ) )
            // InternalMachine.g:6489:2: ( rulePath )
            {
            // InternalMachine.g:6489:2: ( rulePath )
            // InternalMachine.g:6490:3: rulePath
            {
             before(grammarAccess.getPeripheralAccess().getPathsPathParserRuleCall_3_1_8_2_0()); 
            pushFollow(FOLLOW_2);
            rulePath();

            state._fsp--;

             after(grammarAccess.getPeripheralAccess().getPathsPathParserRuleCall_3_1_8_2_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Peripheral__PathsAssignment_3_1_8_2"


    // $ANTLR start "rule__Distance__NameAssignment_1"
    // InternalMachine.g:6499:1: rule__Distance__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__Distance__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6503:1: ( ( RULE_ID ) )
            // InternalMachine.g:6504:2: ( RULE_ID )
            {
            // InternalMachine.g:6504:2: ( RULE_ID )
            // InternalMachine.g:6505:3: RULE_ID
            {
             before(grammarAccess.getDistanceAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getDistanceAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__NameAssignment_1"


    // $ANTLR start "rule__Distance__SettlingAssignment_2_1"
    // InternalMachine.g:6514:1: rule__Distance__SettlingAssignment_2_1 : ( ( RULE_ID ) ) ;
    public final void rule__Distance__SettlingAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6518:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6519:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6519:2: ( ( RULE_ID ) )
            // InternalMachine.g:6520:3: ( RULE_ID )
            {
             before(grammarAccess.getDistanceAccess().getSettlingAxisCrossReference_2_1_0()); 
            // InternalMachine.g:6521:3: ( RULE_ID )
            // InternalMachine.g:6522:4: RULE_ID
            {
             before(grammarAccess.getDistanceAccess().getSettlingAxisIDTerminalRuleCall_2_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getDistanceAccess().getSettlingAxisIDTerminalRuleCall_2_1_0_1()); 

            }

             after(grammarAccess.getDistanceAccess().getSettlingAxisCrossReference_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__SettlingAssignment_2_1"


    // $ANTLR start "rule__Distance__SettlingAssignment_2_2_1"
    // InternalMachine.g:6533:1: rule__Distance__SettlingAssignment_2_2_1 : ( ( RULE_ID ) ) ;
    public final void rule__Distance__SettlingAssignment_2_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6537:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6538:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6538:2: ( ( RULE_ID ) )
            // InternalMachine.g:6539:3: ( RULE_ID )
            {
             before(grammarAccess.getDistanceAccess().getSettlingAxisCrossReference_2_2_1_0()); 
            // InternalMachine.g:6540:3: ( RULE_ID )
            // InternalMachine.g:6541:4: RULE_ID
            {
             before(grammarAccess.getDistanceAccess().getSettlingAxisIDTerminalRuleCall_2_2_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getDistanceAccess().getSettlingAxisIDTerminalRuleCall_2_2_1_0_1()); 

            }

             after(grammarAccess.getDistanceAccess().getSettlingAxisCrossReference_2_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Distance__SettlingAssignment_2_2_1"


    // $ANTLR start "rule__AxisPositionsMapEntry__KeyAssignment_1"
    // InternalMachine.g:6552:1: rule__AxisPositionsMapEntry__KeyAssignment_1 : ( ( RULE_ID ) ) ;
    public final void rule__AxisPositionsMapEntry__KeyAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6556:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6557:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6557:2: ( ( RULE_ID ) )
            // InternalMachine.g:6558:3: ( RULE_ID )
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getKeyAxisCrossReference_1_0()); 
            // InternalMachine.g:6559:3: ( RULE_ID )
            // InternalMachine.g:6560:4: RULE_ID
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getKeyAxisIDTerminalRuleCall_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getAxisPositionsMapEntryAccess().getKeyAxisIDTerminalRuleCall_1_0_1()); 

            }

             after(grammarAccess.getAxisPositionsMapEntryAccess().getKeyAxisCrossReference_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__KeyAssignment_1"


    // $ANTLR start "rule__AxisPositionsMapEntry__ValueAssignment_2_1"
    // InternalMachine.g:6571:1: rule__AxisPositionsMapEntry__ValueAssignment_2_1 : ( rulePosition ) ;
    public final void rule__AxisPositionsMapEntry__ValueAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6575:1: ( ( rulePosition ) )
            // InternalMachine.g:6576:2: ( rulePosition )
            {
            // InternalMachine.g:6576:2: ( rulePosition )
            // InternalMachine.g:6577:3: rulePosition
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getValuePositionParserRuleCall_2_1_0()); 
            pushFollow(FOLLOW_2);
            rulePosition();

            state._fsp--;

             after(grammarAccess.getAxisPositionsMapEntryAccess().getValuePositionParserRuleCall_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__ValueAssignment_2_1"


    // $ANTLR start "rule__AxisPositionsMapEntry__ValueAssignment_2_2_1"
    // InternalMachine.g:6586:1: rule__AxisPositionsMapEntry__ValueAssignment_2_2_1 : ( rulePosition ) ;
    public final void rule__AxisPositionsMapEntry__ValueAssignment_2_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6590:1: ( ( rulePosition ) )
            // InternalMachine.g:6591:2: ( rulePosition )
            {
            // InternalMachine.g:6591:2: ( rulePosition )
            // InternalMachine.g:6592:3: rulePosition
            {
             before(grammarAccess.getAxisPositionsMapEntryAccess().getValuePositionParserRuleCall_2_2_1_0()); 
            pushFollow(FOLLOW_2);
            rulePosition();

            state._fsp--;

             after(grammarAccess.getAxisPositionsMapEntryAccess().getValuePositionParserRuleCall_2_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionsMapEntry__ValueAssignment_2_2_1"


    // $ANTLR start "rule__Position__NameAssignment_1"
    // InternalMachine.g:6601:1: rule__Position__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__Position__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6605:1: ( ( RULE_ID ) )
            // InternalMachine.g:6606:2: ( RULE_ID )
            {
            // InternalMachine.g:6606:2: ( RULE_ID )
            // InternalMachine.g:6607:3: RULE_ID
            {
             before(grammarAccess.getPositionAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getPositionAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Position__NameAssignment_1"


    // $ANTLR start "rule__SymbolicPosition__NameAssignment_1"
    // InternalMachine.g:6616:1: rule__SymbolicPosition__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__SymbolicPosition__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6620:1: ( ( RULE_ID ) )
            // InternalMachine.g:6621:2: ( RULE_ID )
            {
            // InternalMachine.g:6621:2: ( RULE_ID )
            // InternalMachine.g:6622:3: RULE_ID
            {
             before(grammarAccess.getSymbolicPositionAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getSymbolicPositionAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__NameAssignment_1"


    // $ANTLR start "rule__SymbolicPosition__AxisPositionAssignment_2_1"
    // InternalMachine.g:6631:1: rule__SymbolicPosition__AxisPositionAssignment_2_1 : ( ruleAxisPositionMapEntry ) ;
    public final void rule__SymbolicPosition__AxisPositionAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6635:1: ( ( ruleAxisPositionMapEntry ) )
            // InternalMachine.g:6636:2: ( ruleAxisPositionMapEntry )
            {
            // InternalMachine.g:6636:2: ( ruleAxisPositionMapEntry )
            // InternalMachine.g:6637:3: ruleAxisPositionMapEntry
            {
             before(grammarAccess.getSymbolicPositionAccess().getAxisPositionAxisPositionMapEntryParserRuleCall_2_1_0()); 
            pushFollow(FOLLOW_2);
            ruleAxisPositionMapEntry();

            state._fsp--;

             after(grammarAccess.getSymbolicPositionAccess().getAxisPositionAxisPositionMapEntryParserRuleCall_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__AxisPositionAssignment_2_1"


    // $ANTLR start "rule__SymbolicPosition__AxisPositionAssignment_2_2_1"
    // InternalMachine.g:6646:1: rule__SymbolicPosition__AxisPositionAssignment_2_2_1 : ( ruleAxisPositionMapEntry ) ;
    public final void rule__SymbolicPosition__AxisPositionAssignment_2_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6650:1: ( ( ruleAxisPositionMapEntry ) )
            // InternalMachine.g:6651:2: ( ruleAxisPositionMapEntry )
            {
            // InternalMachine.g:6651:2: ( ruleAxisPositionMapEntry )
            // InternalMachine.g:6652:3: ruleAxisPositionMapEntry
            {
             before(grammarAccess.getSymbolicPositionAccess().getAxisPositionAxisPositionMapEntryParserRuleCall_2_2_1_0()); 
            pushFollow(FOLLOW_2);
            ruleAxisPositionMapEntry();

            state._fsp--;

             after(grammarAccess.getSymbolicPositionAccess().getAxisPositionAxisPositionMapEntryParserRuleCall_2_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__SymbolicPosition__AxisPositionAssignment_2_2_1"


    // $ANTLR start "rule__AxisPositionMapEntry__KeyAssignment_1"
    // InternalMachine.g:6661:1: rule__AxisPositionMapEntry__KeyAssignment_1 : ( ( RULE_ID ) ) ;
    public final void rule__AxisPositionMapEntry__KeyAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6665:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6666:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6666:2: ( ( RULE_ID ) )
            // InternalMachine.g:6667:3: ( RULE_ID )
            {
             before(grammarAccess.getAxisPositionMapEntryAccess().getKeyAxisCrossReference_1_0()); 
            // InternalMachine.g:6668:3: ( RULE_ID )
            // InternalMachine.g:6669:4: RULE_ID
            {
             before(grammarAccess.getAxisPositionMapEntryAccess().getKeyAxisIDTerminalRuleCall_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getAxisPositionMapEntryAccess().getKeyAxisIDTerminalRuleCall_1_0_1()); 

            }

             after(grammarAccess.getAxisPositionMapEntryAccess().getKeyAxisCrossReference_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__KeyAssignment_1"


    // $ANTLR start "rule__AxisPositionMapEntry__ValueAssignment_3"
    // InternalMachine.g:6680:1: rule__AxisPositionMapEntry__ValueAssignment_3 : ( ( RULE_ID ) ) ;
    public final void rule__AxisPositionMapEntry__ValueAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6684:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6685:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6685:2: ( ( RULE_ID ) )
            // InternalMachine.g:6686:3: ( RULE_ID )
            {
             before(grammarAccess.getAxisPositionMapEntryAccess().getValuePositionCrossReference_3_0()); 
            // InternalMachine.g:6687:3: ( RULE_ID )
            // InternalMachine.g:6688:4: RULE_ID
            {
             before(grammarAccess.getAxisPositionMapEntryAccess().getValuePositionIDTerminalRuleCall_3_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getAxisPositionMapEntryAccess().getValuePositionIDTerminalRuleCall_3_0_1()); 

            }

             after(grammarAccess.getAxisPositionMapEntryAccess().getValuePositionCrossReference_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__AxisPositionMapEntry__ValueAssignment_3"


    // $ANTLR start "rule__Profile__NameAssignment_1"
    // InternalMachine.g:6699:1: rule__Profile__NameAssignment_1 : ( RULE_ID ) ;
    public final void rule__Profile__NameAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6703:1: ( ( RULE_ID ) )
            // InternalMachine.g:6704:2: ( RULE_ID )
            {
            // InternalMachine.g:6704:2: ( RULE_ID )
            // InternalMachine.g:6705:3: RULE_ID
            {
             before(grammarAccess.getProfileAccess().getNameIDTerminalRuleCall_1_0()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getProfileAccess().getNameIDTerminalRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__Profile__NameAssignment_1"


    // $ANTLR start "rule__UnidirectionalPath__SourceAssignment_1"
    // InternalMachine.g:6714:1: rule__UnidirectionalPath__SourceAssignment_1 : ( ( RULE_ID ) ) ;
    public final void rule__UnidirectionalPath__SourceAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6718:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6719:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6719:2: ( ( RULE_ID ) )
            // InternalMachine.g:6720:3: ( RULE_ID )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getSourceSymbolicPositionCrossReference_1_0()); 
            // InternalMachine.g:6721:3: ( RULE_ID )
            // InternalMachine.g:6722:4: RULE_ID
            {
             before(grammarAccess.getUnidirectionalPathAccess().getSourceSymbolicPositionIDTerminalRuleCall_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getSourceSymbolicPositionIDTerminalRuleCall_1_0_1()); 

            }

             after(grammarAccess.getUnidirectionalPathAccess().getSourceSymbolicPositionCrossReference_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__SourceAssignment_1"


    // $ANTLR start "rule__UnidirectionalPath__TargetAssignment_3"
    // InternalMachine.g:6733:1: rule__UnidirectionalPath__TargetAssignment_3 : ( rulePathTargetReference ) ;
    public final void rule__UnidirectionalPath__TargetAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6737:1: ( ( rulePathTargetReference ) )
            // InternalMachine.g:6738:2: ( rulePathTargetReference )
            {
            // InternalMachine.g:6738:2: ( rulePathTargetReference )
            // InternalMachine.g:6739:3: rulePathTargetReference
            {
             before(grammarAccess.getUnidirectionalPathAccess().getTargetPathTargetReferenceParserRuleCall_3_0()); 
            pushFollow(FOLLOW_2);
            rulePathTargetReference();

            state._fsp--;

             after(grammarAccess.getUnidirectionalPathAccess().getTargetPathTargetReferenceParserRuleCall_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__TargetAssignment_3"


    // $ANTLR start "rule__UnidirectionalPath__ProfilesAssignment_4_0_1"
    // InternalMachine.g:6748:1: rule__UnidirectionalPath__ProfilesAssignment_4_0_1 : ( ( RULE_ID ) ) ;
    public final void rule__UnidirectionalPath__ProfilesAssignment_4_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6752:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6753:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6753:2: ( ( RULE_ID ) )
            // InternalMachine.g:6754:3: ( RULE_ID )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileCrossReference_4_0_1_0()); 
            // InternalMachine.g:6755:3: ( RULE_ID )
            // InternalMachine.g:6756:4: RULE_ID
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_0_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_0_1_0_1()); 

            }

             after(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileCrossReference_4_0_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__ProfilesAssignment_4_0_1"


    // $ANTLR start "rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1"
    // InternalMachine.g:6767:1: rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1 : ( ( RULE_ID ) ) ;
    public final void rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6771:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6772:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6772:2: ( ( RULE_ID ) )
            // InternalMachine.g:6773:3: ( RULE_ID )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileCrossReference_4_0_2_1_0()); 
            // InternalMachine.g:6774:3: ( RULE_ID )
            // InternalMachine.g:6775:4: RULE_ID
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_0_2_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_0_2_1_0_1()); 

            }

             after(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileCrossReference_4_0_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__ProfilesAssignment_4_0_2_1"


    // $ANTLR start "rule__UnidirectionalPath__ProfilesAssignment_4_1_1"
    // InternalMachine.g:6786:1: rule__UnidirectionalPath__ProfilesAssignment_4_1_1 : ( ( RULE_ID ) ) ;
    public final void rule__UnidirectionalPath__ProfilesAssignment_4_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6790:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6791:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6791:2: ( ( RULE_ID ) )
            // InternalMachine.g:6792:3: ( RULE_ID )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileCrossReference_4_1_1_0()); 
            // InternalMachine.g:6793:3: ( RULE_ID )
            // InternalMachine.g:6794:4: RULE_ID
            {
             before(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_1_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_1_1_0_1()); 

            }

             after(grammarAccess.getUnidirectionalPathAccess().getProfilesProfileCrossReference_4_1_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__ProfilesAssignment_4_1_1"


    // $ANTLR start "rule__UnidirectionalPath__AnnotationsAssignment_5_1"
    // InternalMachine.g:6805:1: rule__UnidirectionalPath__AnnotationsAssignment_5_1 : ( ( RULE_ID ) ) ;
    public final void rule__UnidirectionalPath__AnnotationsAssignment_5_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6809:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6810:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6810:2: ( ( RULE_ID ) )
            // InternalMachine.g:6811:3: ( RULE_ID )
            {
             before(grammarAccess.getUnidirectionalPathAccess().getAnnotationsPathAnnotationCrossReference_5_1_0()); 
            // InternalMachine.g:6812:3: ( RULE_ID )
            // InternalMachine.g:6813:4: RULE_ID
            {
             before(grammarAccess.getUnidirectionalPathAccess().getAnnotationsPathAnnotationIDTerminalRuleCall_5_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getUnidirectionalPathAccess().getAnnotationsPathAnnotationIDTerminalRuleCall_5_1_0_1()); 

            }

             after(grammarAccess.getUnidirectionalPathAccess().getAnnotationsPathAnnotationCrossReference_5_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__UnidirectionalPath__AnnotationsAssignment_5_1"


    // $ANTLR start "rule__BidirectionalPath__EndPointsAssignment_1"
    // InternalMachine.g:6824:1: rule__BidirectionalPath__EndPointsAssignment_1 : ( rulePathTargetReference ) ;
    public final void rule__BidirectionalPath__EndPointsAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6828:1: ( ( rulePathTargetReference ) )
            // InternalMachine.g:6829:2: ( rulePathTargetReference )
            {
            // InternalMachine.g:6829:2: ( rulePathTargetReference )
            // InternalMachine.g:6830:3: rulePathTargetReference
            {
             before(grammarAccess.getBidirectionalPathAccess().getEndPointsPathTargetReferenceParserRuleCall_1_0()); 
            pushFollow(FOLLOW_2);
            rulePathTargetReference();

            state._fsp--;

             after(grammarAccess.getBidirectionalPathAccess().getEndPointsPathTargetReferenceParserRuleCall_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__EndPointsAssignment_1"


    // $ANTLR start "rule__BidirectionalPath__EndPointsAssignment_3"
    // InternalMachine.g:6839:1: rule__BidirectionalPath__EndPointsAssignment_3 : ( rulePathTargetReference ) ;
    public final void rule__BidirectionalPath__EndPointsAssignment_3() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6843:1: ( ( rulePathTargetReference ) )
            // InternalMachine.g:6844:2: ( rulePathTargetReference )
            {
            // InternalMachine.g:6844:2: ( rulePathTargetReference )
            // InternalMachine.g:6845:3: rulePathTargetReference
            {
             before(grammarAccess.getBidirectionalPathAccess().getEndPointsPathTargetReferenceParserRuleCall_3_0()); 
            pushFollow(FOLLOW_2);
            rulePathTargetReference();

            state._fsp--;

             after(grammarAccess.getBidirectionalPathAccess().getEndPointsPathTargetReferenceParserRuleCall_3_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__EndPointsAssignment_3"


    // $ANTLR start "rule__BidirectionalPath__ProfilesAssignment_4_0_1"
    // InternalMachine.g:6854:1: rule__BidirectionalPath__ProfilesAssignment_4_0_1 : ( ( RULE_ID ) ) ;
    public final void rule__BidirectionalPath__ProfilesAssignment_4_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6858:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6859:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6859:2: ( ( RULE_ID ) )
            // InternalMachine.g:6860:3: ( RULE_ID )
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesProfileCrossReference_4_0_1_0()); 
            // InternalMachine.g:6861:3: ( RULE_ID )
            // InternalMachine.g:6862:4: RULE_ID
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_0_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getBidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_0_1_0_1()); 

            }

             after(grammarAccess.getBidirectionalPathAccess().getProfilesProfileCrossReference_4_0_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__ProfilesAssignment_4_0_1"


    // $ANTLR start "rule__BidirectionalPath__ProfilesAssignment_4_0_2_1"
    // InternalMachine.g:6873:1: rule__BidirectionalPath__ProfilesAssignment_4_0_2_1 : ( ( RULE_ID ) ) ;
    public final void rule__BidirectionalPath__ProfilesAssignment_4_0_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6877:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6878:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6878:2: ( ( RULE_ID ) )
            // InternalMachine.g:6879:3: ( RULE_ID )
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesProfileCrossReference_4_0_2_1_0()); 
            // InternalMachine.g:6880:3: ( RULE_ID )
            // InternalMachine.g:6881:4: RULE_ID
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_0_2_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getBidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_0_2_1_0_1()); 

            }

             after(grammarAccess.getBidirectionalPathAccess().getProfilesProfileCrossReference_4_0_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__ProfilesAssignment_4_0_2_1"


    // $ANTLR start "rule__BidirectionalPath__ProfilesAssignment_4_1_1"
    // InternalMachine.g:6892:1: rule__BidirectionalPath__ProfilesAssignment_4_1_1 : ( ( RULE_ID ) ) ;
    public final void rule__BidirectionalPath__ProfilesAssignment_4_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6896:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6897:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6897:2: ( ( RULE_ID ) )
            // InternalMachine.g:6898:3: ( RULE_ID )
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesProfileCrossReference_4_1_1_0()); 
            // InternalMachine.g:6899:3: ( RULE_ID )
            // InternalMachine.g:6900:4: RULE_ID
            {
             before(grammarAccess.getBidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_1_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getBidirectionalPathAccess().getProfilesProfileIDTerminalRuleCall_4_1_1_0_1()); 

            }

             after(grammarAccess.getBidirectionalPathAccess().getProfilesProfileCrossReference_4_1_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__ProfilesAssignment_4_1_1"


    // $ANTLR start "rule__BidirectionalPath__AnnotationsAssignment_5_1"
    // InternalMachine.g:6911:1: rule__BidirectionalPath__AnnotationsAssignment_5_1 : ( ( RULE_ID ) ) ;
    public final void rule__BidirectionalPath__AnnotationsAssignment_5_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6915:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6916:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6916:2: ( ( RULE_ID ) )
            // InternalMachine.g:6917:3: ( RULE_ID )
            {
             before(grammarAccess.getBidirectionalPathAccess().getAnnotationsPathAnnotationCrossReference_5_1_0()); 
            // InternalMachine.g:6918:3: ( RULE_ID )
            // InternalMachine.g:6919:4: RULE_ID
            {
             before(grammarAccess.getBidirectionalPathAccess().getAnnotationsPathAnnotationIDTerminalRuleCall_5_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getBidirectionalPathAccess().getAnnotationsPathAnnotationIDTerminalRuleCall_5_1_0_1()); 

            }

             after(grammarAccess.getBidirectionalPathAccess().getAnnotationsPathAnnotationCrossReference_5_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__BidirectionalPath__AnnotationsAssignment_5_1"


    // $ANTLR start "rule__FullMeshPath__ProfilesAssignment_3_0_1"
    // InternalMachine.g:6930:1: rule__FullMeshPath__ProfilesAssignment_3_0_1 : ( ( RULE_ID ) ) ;
    public final void rule__FullMeshPath__ProfilesAssignment_3_0_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6934:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6935:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6935:2: ( ( RULE_ID ) )
            // InternalMachine.g:6936:3: ( RULE_ID )
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesProfileCrossReference_3_0_1_0()); 
            // InternalMachine.g:6937:3: ( RULE_ID )
            // InternalMachine.g:6938:4: RULE_ID
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesProfileIDTerminalRuleCall_3_0_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getProfilesProfileIDTerminalRuleCall_3_0_1_0_1()); 

            }

             after(grammarAccess.getFullMeshPathAccess().getProfilesProfileCrossReference_3_0_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__ProfilesAssignment_3_0_1"


    // $ANTLR start "rule__FullMeshPath__ProfilesAssignment_3_0_2_1"
    // InternalMachine.g:6949:1: rule__FullMeshPath__ProfilesAssignment_3_0_2_1 : ( ( RULE_ID ) ) ;
    public final void rule__FullMeshPath__ProfilesAssignment_3_0_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6953:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6954:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6954:2: ( ( RULE_ID ) )
            // InternalMachine.g:6955:3: ( RULE_ID )
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesProfileCrossReference_3_0_2_1_0()); 
            // InternalMachine.g:6956:3: ( RULE_ID )
            // InternalMachine.g:6957:4: RULE_ID
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesProfileIDTerminalRuleCall_3_0_2_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getProfilesProfileIDTerminalRuleCall_3_0_2_1_0_1()); 

            }

             after(grammarAccess.getFullMeshPathAccess().getProfilesProfileCrossReference_3_0_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__ProfilesAssignment_3_0_2_1"


    // $ANTLR start "rule__FullMeshPath__ProfilesAssignment_3_1_1"
    // InternalMachine.g:6968:1: rule__FullMeshPath__ProfilesAssignment_3_1_1 : ( ( RULE_ID ) ) ;
    public final void rule__FullMeshPath__ProfilesAssignment_3_1_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6972:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6973:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6973:2: ( ( RULE_ID ) )
            // InternalMachine.g:6974:3: ( RULE_ID )
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesProfileCrossReference_3_1_1_0()); 
            // InternalMachine.g:6975:3: ( RULE_ID )
            // InternalMachine.g:6976:4: RULE_ID
            {
             before(grammarAccess.getFullMeshPathAccess().getProfilesProfileIDTerminalRuleCall_3_1_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getProfilesProfileIDTerminalRuleCall_3_1_1_0_1()); 

            }

             after(grammarAccess.getFullMeshPathAccess().getProfilesProfileCrossReference_3_1_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__ProfilesAssignment_3_1_1"


    // $ANTLR start "rule__FullMeshPath__AnnotationsAssignment_4_1"
    // InternalMachine.g:6987:1: rule__FullMeshPath__AnnotationsAssignment_4_1 : ( ( RULE_ID ) ) ;
    public final void rule__FullMeshPath__AnnotationsAssignment_4_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:6991:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:6992:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:6992:2: ( ( RULE_ID ) )
            // InternalMachine.g:6993:3: ( RULE_ID )
            {
             before(grammarAccess.getFullMeshPathAccess().getAnnotationsPathAnnotationCrossReference_4_1_0()); 
            // InternalMachine.g:6994:3: ( RULE_ID )
            // InternalMachine.g:6995:4: RULE_ID
            {
             before(grammarAccess.getFullMeshPathAccess().getAnnotationsPathAnnotationIDTerminalRuleCall_4_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getFullMeshPathAccess().getAnnotationsPathAnnotationIDTerminalRuleCall_4_1_0_1()); 

            }

             after(grammarAccess.getFullMeshPathAccess().getAnnotationsPathAnnotationCrossReference_4_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__AnnotationsAssignment_4_1"


    // $ANTLR start "rule__FullMeshPath__EndPointsAssignment_5"
    // InternalMachine.g:7006:1: rule__FullMeshPath__EndPointsAssignment_5 : ( rulePathTargetReference ) ;
    public final void rule__FullMeshPath__EndPointsAssignment_5() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:7010:1: ( ( rulePathTargetReference ) )
            // InternalMachine.g:7011:2: ( rulePathTargetReference )
            {
            // InternalMachine.g:7011:2: ( rulePathTargetReference )
            // InternalMachine.g:7012:3: rulePathTargetReference
            {
             before(grammarAccess.getFullMeshPathAccess().getEndPointsPathTargetReferenceParserRuleCall_5_0()); 
            pushFollow(FOLLOW_2);
            rulePathTargetReference();

            state._fsp--;

             after(grammarAccess.getFullMeshPathAccess().getEndPointsPathTargetReferenceParserRuleCall_5_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__FullMeshPath__EndPointsAssignment_5"


    // $ANTLR start "rule__PathTargetReference__PositionAssignment_1"
    // InternalMachine.g:7021:1: rule__PathTargetReference__PositionAssignment_1 : ( ( RULE_ID ) ) ;
    public final void rule__PathTargetReference__PositionAssignment_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:7025:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:7026:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:7026:2: ( ( RULE_ID ) )
            // InternalMachine.g:7027:3: ( RULE_ID )
            {
             before(grammarAccess.getPathTargetReferenceAccess().getPositionSymbolicPositionCrossReference_1_0()); 
            // InternalMachine.g:7028:3: ( RULE_ID )
            // InternalMachine.g:7029:4: RULE_ID
            {
             before(grammarAccess.getPathTargetReferenceAccess().getPositionSymbolicPositionIDTerminalRuleCall_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getPathTargetReferenceAccess().getPositionSymbolicPositionIDTerminalRuleCall_1_0_1()); 

            }

             after(grammarAccess.getPathTargetReferenceAccess().getPositionSymbolicPositionCrossReference_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__PositionAssignment_1"


    // $ANTLR start "rule__PathTargetReference__SettlingAssignment_2_1"
    // InternalMachine.g:7040:1: rule__PathTargetReference__SettlingAssignment_2_1 : ( ( RULE_ID ) ) ;
    public final void rule__PathTargetReference__SettlingAssignment_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:7044:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:7045:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:7045:2: ( ( RULE_ID ) )
            // InternalMachine.g:7046:3: ( RULE_ID )
            {
             before(grammarAccess.getPathTargetReferenceAccess().getSettlingAxisCrossReference_2_1_0()); 
            // InternalMachine.g:7047:3: ( RULE_ID )
            // InternalMachine.g:7048:4: RULE_ID
            {
             before(grammarAccess.getPathTargetReferenceAccess().getSettlingAxisIDTerminalRuleCall_2_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getPathTargetReferenceAccess().getSettlingAxisIDTerminalRuleCall_2_1_0_1()); 

            }

             after(grammarAccess.getPathTargetReferenceAccess().getSettlingAxisCrossReference_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__SettlingAssignment_2_1"


    // $ANTLR start "rule__PathTargetReference__SettlingAssignment_2_2_1"
    // InternalMachine.g:7059:1: rule__PathTargetReference__SettlingAssignment_2_2_1 : ( ( RULE_ID ) ) ;
    public final void rule__PathTargetReference__SettlingAssignment_2_2_1() throws RecognitionException {

        		int stackSize = keepStackSize();
        	
        try {
            // InternalMachine.g:7063:1: ( ( ( RULE_ID ) ) )
            // InternalMachine.g:7064:2: ( ( RULE_ID ) )
            {
            // InternalMachine.g:7064:2: ( ( RULE_ID ) )
            // InternalMachine.g:7065:3: ( RULE_ID )
            {
             before(grammarAccess.getPathTargetReferenceAccess().getSettlingAxisCrossReference_2_2_1_0()); 
            // InternalMachine.g:7066:3: ( RULE_ID )
            // InternalMachine.g:7067:4: RULE_ID
            {
             before(grammarAccess.getPathTargetReferenceAccess().getSettlingAxisIDTerminalRuleCall_2_2_1_0_1()); 
            match(input,RULE_ID,FOLLOW_2); 
             after(grammarAccess.getPathTargetReferenceAccess().getSettlingAxisIDTerminalRuleCall_2_2_1_0_1()); 

            }

             after(grammarAccess.getPathTargetReferenceAccess().getSettlingAxisCrossReference_2_2_1_0()); 

            }


            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {

            	restoreStackSize(stackSize);

        }
        return ;
    }
    // $ANTLR end "rule__PathTargetReference__SettlingAssignment_2_2_1"

    // Delegated rules


 

    public static final BitSet FOLLOW_1 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_2 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_3 = new BitSet(new long[]{0x0000000002019800L});
    public static final BitSet FOLLOW_4 = new BitSet(new long[]{0x0000000000008002L});
    public static final BitSet FOLLOW_5 = new BitSet(new long[]{0x0000000002010002L});
    public static final BitSet FOLLOW_6 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_7 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_8 = new BitSet(new long[]{0x0000000000004020L});
    public static final BitSet FOLLOW_9 = new BitSet(new long[]{0x0000000000000022L});
    public static final BitSet FOLLOW_10 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_11 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_12 = new BitSet(new long[]{0x0000000000064000L});
    public static final BitSet FOLLOW_13 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_14 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_15 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_16 = new BitSet(new long[]{0x0000000000400000L});
    public static final BitSet FOLLOW_17 = new BitSet(new long[]{0x0000000000A00000L});
    public static final BitSet FOLLOW_18 = new BitSet(new long[]{0x0000000001000000L});
    public static final BitSet FOLLOW_19 = new BitSet(new long[]{0x0000000001000002L});
    public static final BitSet FOLLOW_20 = new BitSet(new long[]{0x0000000000000030L});
    public static final BitSet FOLLOW_21 = new BitSet(new long[]{0x0000000004002000L});
    public static final BitSet FOLLOW_22 = new BitSet(new long[]{0x0000000009000000L});
    public static final BitSet FOLLOW_23 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_24 = new BitSet(new long[]{0x00000000E0004000L});
    public static final BitSet FOLLOW_25 = new BitSet(new long[]{0x00000000E0000000L});
    public static final BitSet FOLLOW_26 = new BitSet(new long[]{0x0000000004000000L});
    public static final BitSet FOLLOW_27 = new BitSet(new long[]{0x0000000300000000L});
    public static final BitSet FOLLOW_28 = new BitSet(new long[]{0x0000010000004020L});
    public static final BitSet FOLLOW_29 = new BitSet(new long[]{0x0000010000000022L});
    public static final BitSet FOLLOW_30 = new BitSet(new long[]{0x0000000001400000L});
    public static final BitSet FOLLOW_31 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_32 = new BitSet(new long[]{0x0000000800000000L});
    public static final BitSet FOLLOW_33 = new BitSet(new long[]{0x0000003000000000L});
    public static final BitSet FOLLOW_34 = new BitSet(new long[]{0x0000004000000000L});
    public static final BitSet FOLLOW_35 = new BitSet(new long[]{0x0000004000000002L});
    public static final BitSet FOLLOW_36 = new BitSet(new long[]{0x0000008000000000L});
    public static final BitSet FOLLOW_37 = new BitSet(new long[]{0x0000010000000020L});
    public static final BitSet FOLLOW_38 = new BitSet(new long[]{0x0000004000004020L});

}